;;;(load "initogl")

(oglwin '.gl :width 400 :height 400)
(pack .gl :side 'left :expand 'yes :fill 'both)

(define fogmode 'exp)
(define fogdensity 0.35)
(define  fogstart 0)
(define  fogend 5)

(frame '.controls)
(pack .controls :side 'right :fill 'y)

(button '.quit :text "Quit" :command "exit")
(pack .quit :in .controls :fill 'x)

(foreach mode '( exp exp2 linear )
    (radiobutton (tk-string #\. mode) :text mode :var 'fogmode
           :value mode :command '(begin
	(.gl 'eval :fog 'fogmode fogmode)
	(.gl 'redraw) 
	(packscales)
    ))
   ( pack (tk-string #\. mode) :in .controls :side 'top :anchor 'w)
)


(define ( changedensity  fogdensity)
   ( .gl 'eval :fog 'fogdensity fogdensity)   
   ( .gl 'redraw)
)

(scale '.density :label 'density :from 0 :to 1 :res 0.05 :orient 'vert
	:var 'fogdensity :command changedensity)  ;;; 'changedensity is no good
                                                  ;;;  should be a function object

(scale '.start :label 'start :from 0 :to 10 :res 0.1 :orient 'vert 
	:var 'fogstart :command '(changerange 'fogstart fogstart))

(scale '.end :label 'end :from 0 :to 10 :res 0.1 :orient 'vert 
	:var 'fogend :command '(changerange 'fogend fogend))

(define ( changerange  parm value)
    (.gl 'eval :fog parm value)
    (.gl 'redraw)
)

(define ( packscales)
    (if (equal? fogmode "linear")  ;;;; not  'linear
      (begin
	(catch (pack 'forget .density))
	(pack .start :in .controls :anchor 'w)
	(pack .end :in .controls :anchor 'w)
      )
     ;else 
      (begin
	(catch (pack 'forget .start))
	(catch (pack 'forget .end))
	(pack .density :in .controls :anchor 'w)
      )
    )
)
 


(packscales)

(.gl 'eval 
	:matrixmode 'projection 
	:loadidentity 
	:ortho -4 4 -4 4 -8 8 
	:matrixmode 'modelview 
	:loadidentity 
	:colormaterial 'frontandback 'ambientanddiffuse
	:material 'front 'specular 1 1 1
	:material 'front 'shininess 50
	:fog 'fogmode fogmode
	:fog 'fogdensity fogdensity
	:fog 'fogstart fogstart
	:fog 'fogend fogend
        :light 'light0 'position 10 10 10
	:enable 'colormaterial
	:enable 'lighting 
	:enable 'light0 
	:enable 'depthtest
	:enable 'fog
)

(define sphere (.gl 'sphere 1 20 20))

(.gl 'main :clear 'colorbuffer 'depthbuffer
	 :color 1 0 0 
	 :pushmatrix :translate -2 0 0 :call sphere :popmatrix 
	 :color 1 1 0 
	 :pushmatrix :translate 0 0 2 :call sphere :popmatrix 
	 :color 0 1 0 
	 :pushmatrix :translate 2 0 4 :call sphere :popmatrix) 





