;;;(load "initogl")

(define nedge 0)
(define edge (make-vector 20 0))
(define nvtx 0)
(define vtx (make-vector 20 0))
(define picture #f)
(define xrot 0)
(define yrot 0)
(define pickvtx 0)
(define pickz 0)
(define mouse-x 0)
(define mouse-y 0)

(define (vtx-edge i side)
  (if (= side 0)
    (vector-ref vtx (car (vector-ref edge i)))
    (vector-ref vtx (cdr (vector-ref edge i)))
  )
)  

(define (compute_picture)
  (let ((l ()))
    (set! l
	   '(:clear colorbuffer depthbuffer 
	    :shademodel flat 
	    :begin lines))
    (do ((i 0 (+ i 1)))
        ((>= i nedge)) 
	(set! l (append l `(:vertex ,@(vtx-edge i 0)
                     :vertex ,@(vtx-edge i 1)) ))
    )
   (set! l (append l '(:end :initnames :pushname -1 :pointsize 5))) 
    (do ((i 0 (+ i 1)))
        ((>= i nvtx)) 
	(set! l (append l `(:loadname ,i :begin points 
                  :vertex ,@(vector-ref vtx i) :end)))
    )
   ;(format #t "l=~s~%" l)
   (if  picture (.gl 'deletelist   picture ))
   (set!  picture (apply  .gl 'newlist  l))
))
    
(define ( redraw)
   
   ( .gl 'main 
	    :matrixmode 'projection 
	    :loadidentity 
	    :ortho -4 4 -4 4 -4 4 
	    :matrixmode 'modelview 
	    :loadidentity 
	    :rotate yrot 1 0 0
	    :rotate xrot 0 1 0
	    :call picture
))

(define (pick_point  x y )
  (let ((l ()))  
    
	   ;(format #t  "pick point ~a ~a~%" x y)
    (set!  l ( .gl 'select 100 
	    :matrixmode 'projection 
	    :pushmatrix
	    :loadidentity 
	    :pickmatrix x y 4 4
	    :ortho -4 4 -4 4 -4 4 
            :matrixmode 'modelview 
            :call picture 
	    :matrixmode 'projection 
	    :popmatrix ) )
    (set!  pickvtx ())
    ;(format #t "pick point l=~s~%" l)
    (when (list? (car l))  ;;; This is not bug of STk
      (do ((hit 0))
        ((null? l))
        (set! hit (pop l))
;;;	(set!  pickvtx (list-ref hit 3))
	(if (< (length hit) 4)
              ()   ;;;continue
          (begin
            (set!  pickvtx (list-ref hit 3))
 	   (set!  pickz (list-ref hit 1)) 
	   (format #t  "pick point ~a ~a~%" x y)
	   (format #t  "vtx ~a~%" pickvtx)
	   (format #t  "world coords ~a~%" (vector-ref vtx pickvtx))
	   (format #t  "window coords ~a~%"
                  (apply .gl 'project (vector-ref vtx pickvtx)))
              (set! l ())   ;;;break
	  )
        )
      )
   )
))

(define (move_point  x y )
  
    (when (not  (null? pickvtx))
       (vector-set! vtx pickvtx (.gl 'unproject x y pickz))
       ( compute_picture)
       (redraw)
    )
)

(oglwin '.gl)
(pack  .gl :expand 'yes :fill 'both)

(set!  nvtx 0)
(foreach x '(-1 1) 

   (foreach y '(-1 1)
	(foreach z '(-1 1)
	    (vector-set!  vtx nvtx (list x y z))
	    (set!  nvtx(+ nvtx 1))
	)
    )
)

(set!  nedge 0)
(do ((i 0(+ i 1)))
    ((>= i  8))
   (do ((j (+ i 1) (+ j 1))(count 0))
       ((>= j  8)) 
	(set!  count 0) 
	(do ((k 0 (+ k 1)))
            ((>= k  3)) 
	    (if (= (list-ref (vector-ref vtx i) k) 
                   (list-ref (vector-ref vtx j) k))
                (set! count (+ count 1))
            ) 
	)
	(when (= count 2)
	    (vector-set!  edge nedge (cons i j))
	     (set! nedge (+ nedge 1))
	)
    )
)

(compute_picture)
	
(set! xrot 10) 
(set!  yrot 10)

(bind .gl "<Button-1>" (lambda (x y) (set!  mouse-x x)( set! mouse-y y)))

(bind .gl "<B1-Motion>" 
  (lambda (x y) 
    (set! xrot (+  xrot (- x mouse-x))) 
    (set! yrot (+  yrot (- y mouse-y))) 
    (set!  mouse-x x)
    (set!  mouse-y y)
    (redraw)
))
(bind .gl "<Button-3>" (lambda (x y)( pick_point x y )))

(bind .gl "<B3-Motion>" (lambda (x y)(move_point x y )))
(redraw)



