;;;;(load "~sato/initogl")

(load "tkoptionmenu")

(define dsmenu 0)
(define s_radius 0)
(define s_slices 0)
(define s_stacks 0)
(define  c_baseRadius 0)
(define  c_height 0)
(define  c_slices 0)
(define c_stacks 0)
(define sphere 0)
(define partialdisk 0)
(define cylinder 0)
(define ormenu 0)
(define nrmenu 0)
(define txmenu 0)
(define qmenu 0)
(define parms 0)
(define line 0)
(define geom 0)


(define (sphere_geometry)
    ;global s_radius s_slices s_stacks
    (catch (apply destroy (winfo 'children .geom)))
    (scale '.geom.radius :label 'radius :from 0.1 :to 3 :res 0.1 
        :variable 's_radius :command '(redraw) :orient 'horizontal)
    (scale '.geom.slices :label 'slices :from 3 :to 50 
        :variable 's_slices :command '(redraw) :orient 'horizontal)
    (scale '.geom.stacks :label 'stacks :from 3 :to 50 
        :variable 's_stacks :command '(redraw) :orient 'horizontal)
    (foreach w (winfo 'children .geom)
        (pack w :side 'top :anchor 'w)
    )
)

(define (cylinder_geometry)
    ;global c_baseRadius c_topRadius c_height c_slices c_stacks
    (catch (apply destroy (winfo 'children .geom)))
    (scale '.geom.baseradius :label "base radius" :from 0.1 
        :to 3 :res 0.1 
        :variable 'c_baseRadius :command '(redraw) :orient 'horizontal)
    (scale '.geom.topradius :label "top radius" :from 0.1 
        :to 3 :res 0.1 
        :variable 'c_topRadius :command '(redraw) :orient 'horizontal)
    (scale '.geom.height :label "height" :from 0.1 
        :to 3 :res 0.1 
        :variable 'c_height :command '(redraw) :orient 'horizontal)
    (scale '.geom.slices :label "slices" :from 3 :to 50 
        :variable 'c_slices :command '(redraw) :orient 'horizontal)
    (scale '.geom.stacks :label "stacks" :from 3 :to 50 
        :variable 'c_stacks :command '(redraw) :orient 'horizontal)
    (foreach w (winfo 'children .geom)
        (pack w :side 'top :anchor 'w)
    )
)

(define (disk_geometry )
    ;global d_innerRadius d_outerRadius d_slices d_loops
    (catch (apply destroy (winfo 'children .geom)))
    (scale '.geom.innerradius :label "inner radius" :from 0.0 
        :to 3 :res 0.1 
        :variable 'd_innerRadius :command '(redraw) :orient 'horizontal)
   ( scale '.geom.outerradius :label "outer radius" :from 0.0 
        :to 3 :res 0.1 
        :variable 'd_outerRadius :command '(redraw) :orient 'horizontal)
    (scale '.geom.slices :label 'slices :from 3 :to 50 
        :variable 'd_slices :command '(redraw) :orient 'horizontal)
    (scale '.geom.loops :label 'loops :from 3 :to 50 
        :variable 'd_loops :command '(redraw) :orient 'horizontal)
    ;(pack (winfo 'children .geom) :side 'top :anchor 'w)
    (foreach w (winfo 'children .geom)
        (pack w :side 'top :anchor 'w)
    )

)

(define (partialdisk_geometry)
    ;global p_innerRadius p_outerRadius p_slices p_loops p_stAngle p_swAngle
    (catch (apply destroy (winfo 'children .geom)))
   (scale '.geom.innerradius :label "inner radius" :from 0.0 
        :to 3 :res 0.1 
        :variable 'p_innerRadius :command '(redraw) :orient 'horizontal)
   (scale '.geom.outerradius :label "outer radius" :from 0.0 
        :to 3 :res 0.1 
        :variable 'p_outerRadius :command '(redraw) :orient 'horizontal)
   (scale '.geom.slices :label 'slices :from 3 :to 50 
        :variable 'p_slices :command '(redraw) :orient 'horizontal)
   (scale '.geom.loops :label 'loops :from 3 :to 50 
        :variable 'p_loops :command '(redraw) :orient 'horizontal)
   (scale '.geom.stangle :label "start angle" :from 0 :to 360 
        :variable 'p_stAngle :command '(redraw) :orient 'horizontal)
   (scale '.geom.swangle :label "sweep angle" :from 0 :to 360 
        :variable 'p_swAngle :command '(redraw) :orient 'horizontal)
   ; (pack (winfo 'children .geom) :side 'top :anchor 'w)
     (foreach w (winfo 'children .geom)
        (pack w :side 'top :anchor 'w)
    )

)
(define xrot 0)
(define yrot 0)
(define mouse-x 0)
(define mouse-y 0)
(define (rotation_bindings path )
   ; global xrot yrot
   (set! xrot 0) 
   (set! yrot 0)
   (bind path "<Button-1>" (lambda(x y)(set! mouse-x x)(set! mouse-y y) ))
   (bind path "<B1-Motion>"   ;;;[subst -nocommands ( 
	(eval `(lambda (x y)
         (set! xrot (+ xrot (- mouse-x x))) 
	 (set! yrot (+ yrot (- mouse-y y))) 
	(set!  mouse-x x)
	(set! mouse-y y)
	(,path 'eval :matrixmode 'modelview 
            :popmatrix 
	    :pushmatrix 
            :rotate yrot 1 0 0
            :rotate xrot 0 1 0)
	(,path 'redraw)
          ) () ))    ;;;; eval needs ()
)



(define ( quadric_menu path )
   ; global qmenu quad
   (set! qmenu (tk_optionMenu path 'quad 'sphere 
        'cylinder 'disk 'partialdisk))
    (foreach q '(sphere cylinder disk partialdisk) 
	(apply (eval qmenu() ) 'entryconfigure q 
        :command `(begin (set! quad ',q)(,(tk-name q '_geometry))(redraw)) ())
    )
    path
)

(define (drawstyle_menu  path)
    ;global dsmenu drawstyle
   (set! dsmenu (tk_optionMenu path 'drawstyle 'point 'line 'fill 'silhouette))
   (foreach ds '(point line fill silhouette) 
	(apply (eval dsmenu())  'entryconfigure ds 
          :command `(begin (set! drawstyle ',ds)(redraw))())
    )
    path
)

(define ( orientation_menu path ) ;;;madayo!
    ;global ormenu orientation
   (set! ormenu (tk_optionMenu path 'orientation 'inside 'outside))
   (foreach or '(inside outside) 
	(apply (eval ormenu()) 'entryconfigure or
             :command `(begin (set!  orientation ',or)(redraw))())
    )
   path
)

(define ( normals_menu  path)
    ;global nrmenu normals
   (set! nrmenu (tk_optionMenu path 'normals 'None 'flat 'smooth)) 
   (apply (eval nrmenu()) 'entryconfigure 'None :command '(begin
	(.gl 'eval :disable 'lighting )
	(set!  normals 'none) (redraw) ) ()
    )
    (apply (eval nrmenu()) 'entryconfigure 'flat :command '(begin
	(.gl 'eval :enable 'lighting :shademodel 'flat)
	(puts "normals flat")
       (set! normals 'flat) (redraw)) ()
    )
    (apply (eval nrmenu ()) 'entryconfigure 'smooth :command '(begin
	(.gl 'eval :enable 'lighting :shademodel 'smooth)
	(set! normals 'smooth) (redraw)) ()
    )
    path
)

(define ( texture_menu  path)
    ;global txmenu texture
   (set! txmenu (tk_optionMenu path 'texture 'yes 'no)) 
   (apply (eval txmenu()) 'entryconfigure 'no :command '(begin
	(.gl 'eval :disable 'texture2d )
	(set!  texture 'no) (redraw))   ()
    )
   (apply (eval txmenu()) 'entryconfigure 'yes :command '(begin
	(.gl 'eval :enable 'texture2d )
	(set! texture 'yes) (redraw))   ()
    )
    path
)

(define ( labeled_frame  path labeltxt ) 
    (frame path :relief 'groove :borderwidth 2) 
   ( pack (label (tk-name path '.label) :text labeltxt) :fill 'x)
   path
)

(define ( createcheckerimg )
    (image 'create 'photo 'tmp :width 2 :height 2)
    (image 'create 'photo 'img :width 64 :height 64)
    (tmp 'put '(("#ffffff" "#ff0000") ("#000000" "#ffffff"))) 
    (img 'copy 'tmp :from 0 0 2 2 :zoom 4 4 :to 0 0 64 64)
    (set! tmp ())  ;;rename tmp ()
)

(define ( redraw) ;;; args {
    ;global quad texture orientation drawstyle normals
    ;global qlist
  (let* ((type (tk-name quad)))
   (set! parms (list :displaylist qlist :drawstyle 'drawstyle 
        :normals 'normals :orientation 'orientation 
        :texture 'texture))
    (case type 
       ( (sphere) 
	   ; global s_radius s_slices s_stacks
           (set! geom (list s_radius s_slices s_stacks))
        )
       ( (cylinder) 
	   ; global c_baseRadius c_topRadius c_height c_slices c_stacks
           (set! geom (list c_baseRadius c_topRadius c_height
            c_slices c_stacks))
        )
        ((disk)  
	    ;global d_innerRadius d_outerRadius d_slices d_loops
	   (set! geom (list d_innerRadius d_outerRadius d_slices d_loops))
        )
        ((partialdisk)  
	    ;global p_innerRadius p_outerRadius p_slices p_loops
	    ;global p_stAngle p_swAngle
	   (set! geom (list p_innerRadius p_outerRadius p_slices p_loops
                      p_stAngle p_swAngle)) 
	)
    )
    (eval `( .gl quad ,@parms ,@geom)())
    (.gl 'redraw)
))

(createcheckerimg)

(OGLwin '.gl :width 400 :height 400)

(.gl 'eval
	:matrixmode 'projection 
	:loadidentity 
	:ortho -5 5 -5 5 -5 5 
        :light 'light0 'position 10 10 10
	:enable 'lighting 
	:enable 'light0 
	:enable 'colormaterial 
	:enable 'depthtest 
	:texparameter 'texture2d 'texturewraps 'repeat 
	:texparameter 'texture2d 'texturewrapt 'repeat 
	:texparameter 'texture2d 'texturemagfilter 'nearest 
	:texparameter 'texture2d 'textureminfilter 'nearest 
	:texenv 'textureenv 'textureenvmode 'modulate
        :teximage2d 0 0 'img
)

(define qlist (.gl 'newlist))
(define quad 'sphere)
(define drawstyle 'fill)
(define normals 'smooth)
(define texture 'no)
(define  orientation 'outside)
(define s_radius 1)
(define  s_stacks 10)
(define s_slices 10)
(define c_baseRadius 1.0)
(define c_topRadius 1.0)

(define c_height 1.0)
(define c_stacks 10)
(define c_slices 10)
(define d_innerRadius 0)
(define d_outerRadius 1)
(define d_slices 10)
(define  d_loops 3)
(define p_innerRadius 0)
(define  p_outerRadius 1)
(define  p_slices 10)
(define p_loops 3)
(define  p_stAngle 0)
(define p_swAngle 270)

(pack (frame '.cmd) :side 'bottom :fill 'x)

(pack .gl :expand 'yes :side 'left :fill 'both)

(pack (button '.cmd.quit :text 'quit :command "exit") :fill 'y :side 'left)

(pack (labeled_frame '.cmd.quad 'Quadric) :side 'left)
(pack (quadric_menu '.cmd.quad.menu))

(pack (labeled_frame '.cmd.ds "Display Style") :side 'left)
(pack (drawstyle_menu '.cmd.ds.menu)) 

(pack (labeled_frame  '.cmd.orient "Normal Orientation") :side 'left)
(pack (orientation_menu '.cmd.orient.menu))

(pack (labeled_frame '.cmd.normals "Normal Generation") :side 'left)
(pack (normals_menu '.cmd.normals.menu))

(pack (labeled_frame '.cmd.texture "Texture") :side 'left)
(pack (texture_menu '.cmd.texture.menu))

(pack (frame '.geom :borderwidth 3 :relief 'sunken) :side 'left :fill 'x)

(.gl 'main :clear 'colorbuffer 'depthbuffer
         :call qlist)

(rotation_bindings .gl)

(apply (eval qmenu ()) 'invoke quad ())   




