
#include "lisp.h"
#include <stdio.h>
#include <ctype.h>
#include <string.h>
/*  89.6.15 format.c start */
/*  89.7.11 formsk.c start
          ****/
/*  19.10.20 revised */

#define  KANJIP(x)   (kanji_mode&&((x)&0xff)>127)
#define MAXK  15   /***  53 bit < 16 keta ****/
/**  14  **/
     
#define kolon (modeb&1)
#define atto  (modeb&2)

extern ptr char_space;
    
extern  Uchar *modef();
extern  ptr write_str;
extern  ptr sys_close_str(ptr);

static ptr fm_str=NULL;

Uchar *sfpara();
char *Prin_sint( Long ,int ,char *);
char *Prin_uint(ULong ,int ,char *);

//char f_format[12];    //   will be delete !


ptr fmopen(){
    fm_str=reopen_str(fm_str,0);
  return fm_str;
}

ptr fmclose(){
return sys_close(fm_str);
}
static char char_digit[36];
static double eround[19];

int init_format(){
  int i;
  double x=0.501;
  ptr fmclose();
   // sprintf(f_format,"%%.%dE",MAXK-1);  //%.14E   少数点以下  14keta  E
  write_str=open_str(a_nullstr,write_ac);
  sys_pro(write_str);  /*** only once!  ****/
  sys_close_str(write_str); 

  fm_str=open_str(a_nullstr,write_ac);
  sys_pro(fm_str);  /*** only once!  ****/
  fmclose();
  char_space=MAKECHAR(' ');
  for(i=0;i<10;i++) char_digit[i]=i+'0';
  for(i=10;i<36;i++) char_digit[i]='a'-10+i;
  for(i=0;i<19;i++){
          eround[i]=x;  // for round to i
          x*=0.1;
   }
   /** test  
     Prin_sint(0xffff1234 ,16 ,iobuff);
     printf("test  Prin_sint %s\n",iobuff);  //-edcc
     Prin_uint(0xffff1234 ,16 ,iobuff);
     printf("test  Prin_uint %s\n",iobuff);
   OK ***/
  return 0;
}
char *Prin_sint(Long n,int base,char *buff){
   /*** n is signed int 32 bit **/
  int sig=0,x;
  char *last,*top=buff;
  if(n<0){
    sig=1;
    n=-n;
  }
  do{
   x=n%base;
    *buff++=char_digit[x];
   n/=base;
  }while(n>0);
  if(sig)  *buff++='-';
  last=buff;
  *buff--='\0';
   // reverse
  while(top<buff){
     x=*top;
     *top++=*buff;
     *buff--=x;
  }
 return last;
}

char *Prin_uint(ULong n,int base,char *buff){
   /*** n is unsigned int 32 bit **/
  int  x;
  char *last,*top=buff;
  do{
   x=n%base;
    *buff++=char_digit[x];
   n/=base;
  }while(n>0);
  last=buff;
  *buff--='\0';
   // reverse
  while(top<buff){
     x=*top;
     *top++=*buff;
     *buff--=x;
  }
 return last;
}

void prin_F_Large(double , char *);
void prin_F_Little(double ,char *);
char *prin_F(double x,char *buff);

char *dblsmall_E(double x,char *buff,int k){ // 0<x<1, k keta>=1
  int n;
  while(k>0){
     x*=10.0;
     n=(int)x;
     *buff++=char_digit[n];
     x-=n;
    k--;
  }
  *buff='\0';
  return buff;
}

/*****
char *dblsmall(double x,char *buff,int k){ // 0<x<1
  int n,loc=0,zero=-1,nine=-1;
  double err=1.0e-14;
  while(k>0){
     x*=10.0;
     n=(int)x;
     if(n==0){
         if(zero<0) zero=loc;
      }
     else zero=-1;
     if(n==9){
         if(nine<0) nine=loc;
     }
     else nine=-1;
     buff[loc++]=char_digit[n];
     x-=n;
     if(x<err) break;
     err*=10.0;
    k--;
  }
  if(zero>=0) {
       loc=zero;
       if(loc==0) loc=1;
  }
  if(nine>0&&loc-nine>8) {
       loc=nine;
       buff[loc-1]=buff[loc-1]+1;
  }
  buff[loc]='\0';
  return buff+loc;
}
**********/

//  double
//   64 bit
//   sig=MSB exp 11bit F 52 bit
//  exp 0~2047
//   E=exp-1023
//   x= [1 F]*2^{E-52}

/***  long long is 64bit even if 32bit OS ***/
void prin_G(double x,char *buff){
 union{ double z;long long w;} a;
 int loc=0;
 long long E,F,s;
// char *p;
  a.z=x;
  E=a.w;
  s=E&0x8000000000000000;
  if(s){
  //printf("sig=%ld \n",s);
  E=E&0x7fffffffffffffff;
  buff[loc++]='-';
  }
  if(E&1){
    E++;   // then if F=11...1 then expt is increasing automatic
  }
  else if(E&2){
     E+=2;
  }else ;

    a.w=E;
    x=a.z;
  //F=E&0xffff ffff ffff f
   F=E&0xfffffffffffff;
  //F&=0xfffffffffffff;
  E=(E>>52);
  //E&=0x7ff;
  E=E-1023;
  if(E==-1023&&F<=1){  //0.0  Note =0.0!
     buff[loc++]='0';
     buff[loc++]='.';
     buff[loc++]='0';
     buff[loc]='\0';
    return;
  }
   //  buff[loc]='\0';
  //  x=0.0 then 0 0 0
  //  printf("a.w= %lx E=%ld\n",a.w,E);
 buff+=loc;
if(E>30){
      prin_F_Large(x,buff);
    }
  else if(E<-14){
      prin_F_Little(x,buff);
  }
  else { // %f
    prin_F(x,buff);
  }
}

char *check_zero(char *p){
  int c;
  char *z=NULL;
  while((c=*p)){
     if(c!='0'){
        z=NULL;
     }else if(z==NULL){
      z=p;
     }
    else
      ;
    p++;
  }
  if(z!=NULL) {
     *z='\0';
    return z;
  }
  return --p;
}

static int marume(double x){// x>=1.0  return round x
  int n=x,i=0;
  double g=x;
  while(g>10.0) {
    i++;
    g*=0.1;
      /***    2020.8.25
     This cause infinity loop
      ***/
    if(i>308){
      error(E_unprint,a_f);
     break;
    }
  }
  if(i<=14)
       return  (int)(x+eround[14-i]);  //? 15 or 13
   return n;
}
  
char *prin_F(double x,char *buff){
  char *p=buff;
  int n;
    n=marume(x);
     /**  2019.11.25  1.9999...   14 or 15  of 9 then 1.a  **/
    buff=Prin_sint(n,10,p);
    buff[0]='.';
   if(n>=x){
       buff[1]='0';
       buff[2]=0;
       return buff+2;
    }
    x-=n;
   //below from .
    //return dblsmall(x,buff+1,14-(buff-p));
    n=14-(buff-p);
    //x+=eround[n];
    dblsmall_E(x,buff+1,n);
    return check_zero(buff+2);
}
void prin_F_Large(double x,char *buff){
   int e=0;
   /***  2020.8.25
     This cause infinity loop
     if x==infty (=0x7ff0 0000 0000 0000)
    **/
   while(x>=10.0){
     x/=10.0;
     e++;
     if(e>308){
      error(E_unprint,a_f);
       break;
     }
   }
  //printf("Large e=%d %lf\n",e,x);
  buff=prin_F(x,buff);
  buff[0]='e';
  buff[1]='+';
  Prin_sint(e,10,buff+2);
}

void prin_F_Little(double x,char *buff){
   int e=0;
   while(x<1.0){
     x*=10.0;
     e++;
   }
  //printf("Little e=%d %lf\n",-e,x);
  buff=prin_F(x,buff);
  buff[0]='e';
  buff[1]='-';
  Prin_sint(e,10,buff+2);
}
void prin_E_Large(double ,int, char *);
void prin_E_Little(double ,int,char *);
char *prin_E_s(double x,int,char *buff);

void prin_E(double x,int keta,char *buff){
 union{ double z;long long w;} a;
 long long E,F,s;
// char *p;
  a.z=x;
  E=a.w;
  s=E&0x8000000000000000;
  if(s){
  E=E&0x7fffffffffffffff;
  *buff++='-';
  }
    a.w=E;
    x=a.z;
   F=E&0xfffffffffffff;
  E=(E>>52);
  //E&=0x7ff;
  if(E==0&&F<=1){  //0.0  Note =0.0!
     *buff++='0';
     *buff++='.';
     while(keta>0){
         keta--;
         *buff++='0';
    }
     *buff++='e';
     *buff++='+';
     *buff++='0';
     *buff='\0';
    return;
  }
  E=E-1023;
   //  buff[loc]='\0';
  //  x=0.0 then 0 0 0
  //  printf("a.w= %lx E=%ld\n",a.w,E);
if(E>=0){
      prin_E_Large(x,keta,buff);
    }
  else {
      prin_E_Little(x,keta,buff);
  }
}
char *prin_E_s(double x,int keta,char *buff){
  char *p=buff;
  int n;
   /***  1<= x <10.0  **/
    n=(int)x;
    *buff++=char_digit[n];
    //buff=Prin_sint(n,10,p);
    *buff++='.';
    x-=n;
   //below from .
    return dblsmall_E(x,buff,keta);  // ???
}
void prin_E_Large(double x,int keta,char *buff){
   int e=0;
   while(x>=10.0){
     x/=10.0;
     e++;
   }
   x+=eround[keta];   //  must  18>=keta>=1 
   if(x>=10.0){
        x/=10.0;
        e++;
    }
  //printf("Large e=%d %lf\n",e,x);
  buff=prin_E_s(x,keta,buff);
  buff[0]='e';
  buff[1]='+';
  Prin_sint(e,10,buff+2);
}

void prin_E_Little(double x,int keta,char *buff){
   int e=0;
   while(x<1.0){
     x*=10.0;
     e++;
   }
   x+=eround[keta];   //  must  18>=keta>=1 
   if(x>=10.0){
        x/=10.0;
        e--;
    }
  //printf("Little e=%d %lf\n",-e,x);
  buff=prin_E_s(x,keta,buff);
  buff[0]='e';
  buff[1]='-';
  Prin_sint(e,10,buff+2);
}
//  for test
static char C_printf[512];

ptr s_pr_E(int narg,ptr env){
  ptr x,k;
  char *p,*pf;
  Uint n;
  double y;
  checknarg(narg-2);
   k=*(stack-1);
   x=*(stack-2);
     n=(int)GETNUM(k);
     y=get_float(x);
     printf("pr_E %e %d\n",y,n);
     prin_E(get_float(x),(int)GETNUM(k),C_printf);
    n=strlen(C_printf);
     printf("pr_E strlen=%d %s\n",n,C_printf);
   x=makestring(n);
     p=(char *)get_string(x,&n);
     pf=C_printf;
    while(n--){
      *p++=*pf++;
    }
   return x;
}

/*** (C-printf ctrl float)   C-print,  return string, Only real float  ***/

ptr s_cprintf(int narg,ptr env){
  ptr ctrl,x;
  char *p,*pf;
  Uint n;
  checknarg(narg-2);
  ctrl=*(stack-2);
   x=*(stack-1);
     p=(char *)get_string(ctrl,&n);
     // the next include bug!!! p may not be C-string. 
     sprintf(C_printf,p,get_float(x));
    n=strlen(C_printf);
   x=makestring(n);
     p=(char *)get_string(x,&n);
     pf=C_printf;
    while(n--){
      *p++=*pf++;
    }
   return x;
}

void mode_print(ptr p){
  int modeb;
   modeb=GETNUM(p);
   pr_cstr(STDERR,"modifier ");
   if(modeb&1) pr_cstr(STDERR,":");
   if(modeb&2) pr_cstr(STDERR,"@");
   if(modeb&4) pr_cstr(STDERR,"!");
   newline(STDERR);
}

void form_err(int s,ptr p){
  pr_cstr(STDERR,"Format error!\n");
  switch(s){
      case  E_fm_mode: mode_print(p);
           break;
     default: break;
  }
  error(s,p);
  // return a_nil; Never
}
  

    /** kanji_mode=(CAR(a_kanji)!=a_nil); *****  kanji 89.8.30****/
 
