#include "lisp.h"

/***   INT, BIG  logical   */
extern ptr  longand(),longsub(),longmul(),longdiv();
extern int andsub(),orsub(),xorsub(),eqvsub();
extern int nandsub(),norsub();
/****
,andc1sub(),andc2sub(),
           orc1sub(),orc2sub();
***/
extern ptr Bcom(),Band(),Bior(),Bxor(),Bcount(),Blength();
extern ptr long_logic(),logic16();

extern int (* logic)();
extern ptr (* Blogic)();
extern ptr bibnum(long x);
extern unsigned long int GET32NUM(ptr ); /* big.c*/

ptr genlogic(p,q)
  Reg ptr  p,q;
{
   if(SINTP(p))
    {
      if(SINTP(q))
           return logic16(p,q);
       p=bignum((long)GETNUM(p));
    }
  else if(!BIGINTP(p))
      error(E_notint,p);
  if(SINTP(q))
       q=bignum((long)GETNUM(q));
  else if(!BIGINTP(q))
      error(E_notint,q);
  psh(p);
  psh(q);
           p=long_logic(p,q);
      sp_pull(2);
   return p;
 }

ptr gen_logic(int narg)
{
  Reg ptr p,*free;
   free=stack-narg;
   p=*free++;
   narg--;
   psh(p);
   while(narg--){
       *(stack-1)=p=genlogic(p,*free++);
    }
   return *pull();
 }

ptr gen_and(int narg,ptr env)     
    
 {
    if(narg==0) return MINUSONE;  /****   -1  is unit for logand  *****/
    logic=andsub;         
    Blogic=Band;         
    return gen_logic(narg);
 }

ptr gen_ior(int narg,ptr env)     /*  lsubr  inclusive or*/
    
 {
    if(narg==0) return ZERO;  /****   0  is unit for or  *****/
    logic=orsub;         
    Blogic=Bior;         
    return gen_logic(narg);
 }

ptr gen_xor(int narg,ptr env)     /*  lsubr  inclusive or*/
    
 {
    if(narg==0) return ZERO;  /****   0  is unit for xor  *****/
    logic=xorsub;         
    Blogic=Bxor;         
    return gen_logic(narg);
 }

ptr gen_eqv(int narg,ptr env)     /*  lsubr  eqv */
    
 {
    if(narg==0) return MINUSONE;  /****   -1  is unit for eqv  *****/
    logic=eqvsub;         
    return gen_logic(narg);
 }

/***  CL p.360  (logbitp index integer)  index is from 0
    if index bit is 1 return #t ****/

ptr s_logbitp(int narg,ptr env)    
    
 {
    Reg ptr p,q;
    Reg int s,u;
    checknarg(narg-2);
    p=*(stack-1);
    q=*(stack-2); /*** index ***/
    if(gsign(q)) error(E_illegal,q);
  /***   printf("logbitp 1\n");  ***/
    if(SINTP(p)) 
      {
         u=GETNUM(p);
         if(!SINTP(q)&& BIGINTP(q)) return PRED(u<0);
         s=GETNUM(q);
         if(s>=31) 
          {
            return PRED(u<0);
          }
       return PRED(u&(1<<s));
      }
    else if(BIGINTP(p))
      {
        if(SINTP(q))
           s=GETNUM(q);
        else
           s=GET32NUM(q);
         return PRED(mpz_tstbit(BIGNUM(p),s));
      }
   return error(E_notint,p);
 }

ptr s_logtest(int narg,ptr env)     /*  2,0,0  */
    
 {
    Reg ptr p=*(stack-2);
    logic=andsub;         
    p=genlogic(p,*(stack-1));
    return PRED(p!=ZERO);
 }
 
/*     not =eqv(x,0)   wo riyousuru!!  */
ptr gen_not(int narg,ptr env)
 {
    Reg ptr p=*(stack-1),q;
    checknarg(narg-1);
    if(INTP(p))
      {
        return (ptr)((~(long)p)-1);
      }
    else if(BIGINTP(p))
      {
         return Bcom(BIGNUM(p));
      }
   return error(E_notint,p);
 }

ptr s_logcount(int narg,ptr env)
 {
    Reg ptr p=*(stack-1),q;
    checknarg(narg-1);
    if(INTP(p))
      {
        p=bignum((long)GETNUM(p));
      }
    else if(!BIGINTP(p))
          error(E_notint,p);
    if(gsign(p)){
       p=gen_not(1,a_nil);
       if(SINTP(p)) p=bignum((long)GETNUM(p));
     }

   return Bcount(BIGNUM(p));
 }

ptr s_loglength(int narg,ptr env)
 {
    Reg ptr p=*(stack-1),q;
    checknarg(narg-1);
    if(INTP(p))
      {
        if(p==ZERO) return p;
        p=bignum((long)GETNUM(p));
      }
    else if(!BIGINTP(p))
          error(E_notint,p);
    if(gsign(p)){
       p=gen_not(1,a_nil);
       if(SINTP(p)) p=bignum((long)GETNUM(p));
     }

   return Blength(BIGNUM(p));
 }


/*** 91.3.14  the following are 2,0,0  ***/
ptr gen_nand(arg)
    Reg ptr *arg;
 {
    logic=nandsub;
    return genlogic(*arg,arg[1]);
 }  
ptr gen_nor(arg)       
    Reg ptr *arg;
 {    
    logic=norsub;         
    return genlogic(*arg,arg[1]);
 }  


