/***  hash.c  
   2019.10.22 revised
****/
#define  HASH_C

#include "lisp.h"
#include <stdio.h>
#include <stdlib.h>

/*** #define GMAKESYMBOL(s,size)  SMAKESYMBOL(GMAKESTR(s,size)) 
 ptr SMAKESYMBOL();
***/

//extern ptr makevector(),SCONS(),CONS(),vector_ref(),*get_vector();
extern ptr *get_vector();
extern ptr eqv(),equal(),funcall();
static int shash();
int ghash(ptr );
int xhash(ptr );

ptr hash_found;
/*****   hash support  &&   package  
   04.5.8  started
     for package, hash 
          key=STR,value =SYMBOL, and cmpfn=equal ***/

 
ptr s_hash_table_p(int narg,ptr env)
 {
   Reg ptr x;
    checknarg(narg-1);
    x=*(stack-1);
   return HASHP(x)?a_t:a_f;  
  }

ptr s_make_hash_table(int narg,ptr env)
 {
   
   Reg unsigned int size,k;
  Reg ptr x,s,tes;
   checknarg(narg-2);
   s=*(stack-1);
   if(s==ZERO) k=129;//32
   else
    {
      size=GETNUM(s);
      k=4;
      while(k<size)
          k<<=1;
      k=(unsigned int)MAKESINT(k);
    }
   tes=*(stack-2);
   if(SYMBOLP(tes)) 
         x=ATOMVAL(tes);
   else 
         x=tes;
   if(x==ATOMVAL(a_eq))  /** MAKEID("eq?")***/
    {
    tes=ZERO;
    }
   else if(x==ATOMVAL(a_eqv)) /** MAKEID("eqv?")))**/
    {
    tes=ONE;
    }
   else if(x==ATOMVAL(a_equal)) /** MAKEID("equal?"))**/
    {
    tes=TWO;
    }
  else if(CLOSUREP(x))
     /** s=x;  ***/
      ;   /***  for save,load testfn should be symbol  ***/
  else
     error(E_range,x);
   return make_hash(tes,(ptr)(long)k);
}
   
ptr make_hash(ptr testfn,ptr size)
 {
   Reg ptr v;
    //v=makevector(GETNUM(size),a_nil);
    /*** size is int (odd)    ***/
    v=makevector(GETNUM(size),a_nil);
    v=SCONS(ZERO,v);   // ZERO  is counter
    /***  2014.3.26 long is wrong!!!
    v=SCONS(a_hash,SCONS((ptr)(long)testfn,SCONS((ptr)(long)size,v)));
    ****/
    v=SCONS(a_hash,SCONS(testfn,SCONS(size,v)));  // size is SINT
    ATTR(v)=HASH;
    return v;
 }

ptr rehash(ptr table,int size,ptr n)   /*** size is new value, n is  NO of entry (SINT)***/
 {
   Reg int nn;
   Reg ptr v,p,new,*pos,*setpos;
   Reg ptr newv,oldv;
   int dum;
   
    newv=makevector(size,a_nil);
    v=SCONS(n,newv);
    v=SCONS(MAKESINT(size),v);
    table=CDR(table);
    p=CDR(table); /***  CAR -> size  **/
    nn=GETNUM(CAR(p));
    psh(p);
    CDR(table)=v;  /*** surjery   **/
    oldv=CDR(CDR(p));  /*** old vector ***/
    psh(oldv);
            pos=get_vector(newv,&dum);
     while(nn--)
      {
        p=vector_ref(oldv,nn);
        /*** p=*((ptr *)CAR(oldv)+n);   ***/
        while(p!=a_nil)
         {
            /*** for gbc may be occur!!!! ***/
            new=CONS(CAR(p),a_nil);
            psh(new);
            setpos=pos+ghash(CAR(CAR(p)))%size;   /**  to be improved */
            /** pos=(ptr *)CAR(newv)+(ghash(CAR(CAR(p)))&size);  ***/
            CDR(new)=*setpos;
            *setpos=new;
            p=CDR(p);
            pull();
         }
      }
    pull();
    pull();
    return v;
 }

static ptr test;
int h_test(x,y)
  Reg ptr x,y;
{
    if(x==y) return 1;
     if(test==ZERO)  return 0;
     else if(test==ONE)
                return (eqv(x,y)==a_t);
     else if(test==TWO)
             return (equal(x,y)==a_t);
     else{
            psh(x);
            psh(y);
            x=funcall(test,2,a_nil);
            sp_pull(2);
            return (x!=a_f);
   }
/***  sprintf(iobuff,"h_test error %lx\n",(unsigned long)test);
  lwritestr(STDERR,iobuff);
  error(E_range,a_nil);
***/
}


ptr gethash(key,table)
  Reg ptr key,table;
 {
   Reg ptr *v,s,q;
   Reg int size;
   
   table=CDR(table);
   test=CAR(table);
   table=CDR(table);
   size=GETNUM(CAR(table));
   table=CDR(CDR(table));
  /**  printf("gethash %d  size %d \n",ghash(key)%size,size); **/
   s=vector_ref(table,(ghash(key)%size));  // to be improved
   
   while(s!=a_nil)
    {
     q=CAR(s);
     if(h_test(CAR(q),key))
        {
       hash_found=a_t;
      return CDR(q);
        }
     s=CDR(s);
    }
     return hash_found=a_f;
 }

ptr s_gethash(int narg,ptr env)
 {
   Reg ptr x,y,err=a_f;
    if(narg==2){
      x=*(stack-1);
      y=*(stack-2);
    }
   else if(narg==3){
      err=*(stack-1);
      x=*(stack-2);
      y=*(stack-3);
    }
   else  
       checknarg(narg-3);
    if(!HASHP(y)) error(E_nothash,y);
   x=gethash(x,y);
   if(hash_found==a_f) return err;
  return x;  
 }

ptr sethash(key,table,value)
  Reg ptr key,table,value;
 {
   Reg ptr *v,s,q,nn;
   Reg int size,n;
   Reg ptr memo=table,vect,va;
   
   table=CDR(table);
   test=CAR(table);
   table=CDR(table);
   size=GETNUM(CAR(table));
   table=CDR(table);
   vect=CDR(table);
   #ifdef DEBUG
    /*** printf("sethash enter key %x\n",key); 
       printf("size %d n %d\n",size,ghash(key)%size); 
    ***/
   #endif
   va=s=vector_ref(vect,n=(ghash(key)%size));
  
   while(s!=a_nil)
    {
     q=CAR(s);
     if(h_test(CAR(q),key)) 
        {
            CDR(q)=value;
           return q;
        }
     s=CDR(s);
    }
   vector_set(vect,n,CONS(CONS(key,value),va));
   
   CAR(table)=nn=(ptr)((long)CAR(table)+4);    /*** inc ONE  count ***/
   if(((long)nn>>2)>size)  // note nn is SINT,  size is int.
       rehash(memo,((size-1)<<1)+1,nn);
   return NULL;
 }
   
ptr s_sethash(int narg,ptr env)
      /*** key,table,value ***/
 {
   Reg ptr x;
     checknarg(narg-3);
    x=*(stack- 3);
    if(!HASHP(x)) error(E_nothash,x);
     sethash(*(stack-2),x,*(stack-1));
   return *(stack-1);  
  }

ptr s_remhash(int narg,ptr env)
   
 {
   Reg ptr x;
    checknarg(narg-2);
    x=*(stack-2 );
    if(!HASHP(x)) error(E_nothash,x);
   return remhash(*(stack-1 ),x);
  }


ptr remhash(key,table)
  Reg ptr key,table;
 {
   Reg ptr *v,s,q,prev;
   Reg int size,n;
   Reg ptr memo=table,vect;
   
   table=CDR(table);
   test=CAR(table);
   table=CDR(table);
   size=GETNUM(CAR(table));
   table=CDR(table);
   vect=CDR(table);
   prev=s=vector_ref(vect,n=(ghash(key)%size));
   
   while(s!=a_nil)
    {
     q=CAR(s);
     if(h_test(CAR(q),key)) 
        {
           if(prev==s)
             {
               vector_set(vect,n,CDR(s));
              }
            else
               CDR(prev)=CDR(s);
           CAR(table)=(ptr)((long)CAR(table)-4);    /*** dec  count ***/
           return a_t;
        }
     prev=s;
     s=CDR(s);
    }
   return a_f;
 }
   
   
int ghash(ptr p){
     return  xhash(p)&0xfffffff; /** 28bit **/
  } 

static void check_bytes(ptr p, int n){   /*** for debug***/
   printf("check ptr p %lx\n ",(unsigned long)p);
  printf("check ptr  1 CAR  %lx\n",(unsigned long)CAR(p));
}  

static int cstr_hash();

int number_hash(ptr p){  /*** This bug was found by  Maichi Ishikawa  07.10.20  **/
  /***  p is not SINT  ***/
   /** see number_str.c  **/
 int n;
 char *pp;
 char *mpz_get_str();
 char *mpq_get_str();
 union{double x; long long xi;} fx;

  n=ATTR(p);
  if(n&BIGINT){
      pp=mpz_get_str(0,32,BIGNUM(p));
          n=cstr_hash(pp);
          Myfree(pp);
         return n;
     }
  else if (n&RATIO){
           pp=mpq_get_str(0,32,RATIONAL(p));
          n=cstr_hash(pp);
          Myfree(pp);
          return n;
        }
else if(n&DOUBLE){
           /** format("%f",FLONUM(q)); ***/
           fx.x=FLONUM(p);
           n=(fx.xi>>32)+fx.xi;
           return n;
       }
 else if(n&COMPLEX)
    return xhash(CAR(p))+xhash(CDR(p));
 else
    return 0;  /** Never ocuur  **/
}
 

int xhash(ptr p)
 {
  ptr *v;
  int n,s;
   /**  if(SREGP(p))  return p;  ***/
   /****
   printf("xhash p %x attr %X\n",p,ATTR(p));
   ***/
   /** check_bytes(p,6); ***/
  /***
   printf("xhash p %x\n ",p);
   check_bytes(p,6);
  ***/
  /**  printf("xhash attr  %x\n ",ATTR(p)); **/
   if(SREGP(p))  return (int)(long)p;  
   else if(SYMBOLP(p)||KEYWORDP(p))
           return shash(PNAME(p));
   else if(STRINGP(p))
           return shash(p);
   else if(NUMBERP(p))
           return number_hash(p);
   else if(CONSP(p))
      return xhash(CAR(p))+(3*xhash(CDR(p)));
   else if(VECTORP(p)){
    v=get_vector(p,&n);
    s=n;
    while(n--){
      s+=xhash(*v++);
      }
     return s;
    }
   else if(p==a_nil)
         return 123456;
   else if(p==a_t)
         return 12345;
   else if(p==a_f)
         return 12349;
   else if(p==a_undef)
         return 123499;
   else
           return (int)(long)p;
 }
           
static int shash(s)
   Reg ptr s; /** string ***/
 {
   Reg unsigned char *p;
    Reg int n;
    Uint h;
    
    p=get_string(s,&h);
    n=h;
    while(n--)
      {
         /* h<<=1;
         h+=(*p++)+1;
         */
         /* 90.5.20   saiyou ***/
         h+=(h<<1);
         h+=*p++;
         
      }
    return(h);
 }

static int cstr_hash(unsigned char *p){
   Reg unsigned char c;
  Reg int h=6539;
    while((c=*p++))
      {
         h+=(h<<1);
         h+=c;

      }
    return(h);
 }


ptr s_sxhash(int narg,ptr env)
   
 {
     return MAKESINT(ghash(*(stack-1 ))); /** 30bit or 62bit **/
     /** return MAKENUM(ghash(*(stack-1 )));  ** 28bit **/
 }
ptr s_hash_table_count(int narg,ptr env)
      /*** table ***/
 {
   Reg ptr table;
    table=*(stack- 1);
    if(!HASHP(table)) error(E_nothash,table);
   
   table=CDR(table);
   table=CDR(table);
   table=CDR(table);
   return CAR(table);
 }

ptr s_clrhash(int narg,ptr env)
   
 {
   Reg ptr table;
   Reg ptr *v;
   int size;
   
   table=*(stack-1 );
    if(!HASHP(table)) error(E_nothash,table);
   
   table=CDR(table);
   table=CDR(table);
   size=GETNUM(CAR(table));
   table=CDR(table);
   
   CAR(table)=ZERO;
   
   /** v=CAR(CDR(table));   ***/
   v=get_vector(CDR(table),&size);
   if(size<0){
     printf("clear hash size %x\n",size);
     exit(999);
   }
   while(size--)
    {
     *v++=a_nil;
    }
   return *(stack-1);
 }
 
 /*** returns list of all entries( value only ) ***/
static ptr list_hash(table)
  Reg ptr table;
 {
  Reg int n,c=0;
   Reg ptr p,q,ret;
    table=CDR(table);
    p=CDR(table);
    n=GETNUM(CAR(p));
    p=CDR(CDR(p));  /*** p is vector ****/
   ret=a_nil;
   /* printf("list-hash p=%x n=%x\n",p,n); */
     while(n--)
      {
         q=vector_ref(p,n);
        /*** q=*((ptr *)CAR(p)+(n));  ***/
        while(q!=a_nil)
         {
            c++;
            ret=SCONS(CDR(CAR(q)),ret);
            q=CDR(q);
         }
      }
   /* printf("list-hash c=%d \n",c); */
  return ret;
 }
/***  return  hash_vector    for package.c  ***/
ptr get_hash_vector(ptr table)
 {
   Reg ptr p;
    table=CDR(table);
    p=CDR(table);
    return CDR(CDR(p));  /*** vector ****/
 }

ptr s_maphash(int narg,ptr env)
   
 {
   Reg ptr table,p,s,func;
   Reg ptr *v;
   Reg int size,ind;
   int dum;
   checknarg(narg-2);
   table=*(stack-1);
    if(!HASHP(table)) error(E_nothash,table);
   
   table=CDR(table);
   table=CDR(table);
   size=GETNUM(CAR(table));
   table=CDR(table);
   
   /** v=CAR(CDR(table));   ***/
   v=get_vector(CDR(table),&dum);  
   func=*(stack-2);
   psh(func);
   psh(func);
   ind=0;
   while(size--)
    {
     v=get_vector(CDR(table),&dum);  
     p=*(v+ind++);
      while(p!=a_nil)
      {
        s=CAR(p);
        p=CDR(p);
        *(stack-2)=CAR(s);
        *(stack-1)=CDR(s);
        funcall(func,2,a_nil);
      }
    }
   sp_pull(2);
   return *(stack-1);
 }

/*** in package.c used  **/
ptr s_mapcdrhash(int narg,ptr env)
   
 { 
   Reg ptr table,p,s,func;
   Reg ptr *v;
   Reg int size,ind;
   int dum;
   checknarg(narg-2);
   table=*(stack-1);
    if(!HASHP(table)) error(E_nothash,table);
          
   table=CDR(table);
   table=CDR(table);
   size=GETNUM(CAR(table));
   table=CDR(table);
         
   /** v=CAR(CDR(table));   ***/
   v=get_vector(CDR(table),&dum);
   func=*(stack-2);
   psh(func);
   ind=0;
   while(size--)
    {
     v=get_vector(CDR(table),&dum);  
     p=*(v+ind++);
      while(p!=a_nil)
      {
        s=CAR(p);
        p=CDR(p);
        *(stack-1)=CDR(s);
        funcall(func,1,a_nil);
      }
    }
   pull();
   return *(stack-1);
 }
 
 

