/*   version 0.1  started 03.8.28  started */
/**   ver1.4  04.05.05 is last stable version   ***/

/***  ver1.5   will support package     04.5.8 start ***/

/***  almost completed!!!  ******/
/** ver2.15   2019.10.6  **/

#include "config.h"   /*** by autoconf ***/

#include "ssenv.h"
#include "sserror.h"
#include <gmp.h>
/*********************************************/

/** #define DEBUG   **/    

/*********************************************/
#define ERR  (-1)

/***    atttr=  4 bit mark for gbc  and 12bit for type   ***/
/** typedef struct _cell {struct _cell *_car,*_cdr;unsigned short _attr;} *ptr; **/
/***   above short  is taken as long, so we change attr 32bit!!!  ***/

/*** typedef struct _cell {struct _cell *_car,*_cdr;unsigned int  _attr;} *ptr;
***/
struct _cell {
    union{ struct{struct _cell *_car,*_cdr;} cons;
            struct {MP_INT *data;}                                 bignum;
         struct {MP_RAT *data;}                                 rational;
         struct { double data;}          flonum;
         } ss;
    int  _attr;   /*** V2.0  ***/
    int  _exattr;   /*** V2.16  ***/
     } ;
/***   sizeof(cell)=24 ,  so if add a int  size is same!  ***/

typedef struct _cell*  ptr;
typedef struct _cell cell;
/***  New   atttr=  4 bit mark for gbc  and 28bit for type   ***/
/***   type of CELL   ***/
/***    ()  is list but not symbol  in scheme  ***/
/***  GMP  mpz_q is 24 bytes, however above is pointer only 4 byte  ***/
typedef struct _name_num{char *name;
           unsigned int num;}name_num;

typedef struct sys_subr {char *name;ptr (*func)();
           short narg,rest;}sys_subr;

#ifndef NULL
#define NULL   (0) 
#endif

#define  CELL         0
#define  NILL    1      /** nil undef unbdd**/
#define  SYMBOL  2
#define  STRING  4
#define  BIGINT    0x08
#define  RATIO     0x10
#define  DOUBLE    0x20
#define  COMPLEX   0x40   /**** complex ***/
#define  NUMBER    0x78   /** (8+16+32+64)  **/
#define  REAL      0x38   /** (8+16+32)  **/
/*** #define      0x80     not reserved  ***/
#define  NOCAR    0x80   /**  CAR is not OBJ  ***/

#define  BOOLEAN   0x100  /*** 128 **/
#define  VECTOR    0x200
#define  MATRIX    0x400  
#define  KEYWORD   0x800   
#define  STREAM    0x1000  
/***  0x2000   reserved  ***/
/*** #define  CWC       0x2000  ** call/cc **/
#define  STRUCTURE   0x4000  /****  structure  ***/
#define  NETSOCKET   0x8000  /** Network, socket Not scheme obj **/

#define CLOSURE     0xF0000
#define SPECIAL     0x10000
#define LAMBDA      0x20000
//#define MACRO       0x40000  // reserved
#define SUBR        0x80000   /***   compiled  ***/
#define SLAMBDA     0xa0000   /***   system function  binary    ****/
                              /***    FBODY(p) is  not SS-object  for gbc   ****/
#define TKOBJ      0x100000   /*** TK OBJ for TK-Link values  ***/
/*** #define MULTI      0x200000    values  ***/
#define SYNTAX           0x200000    /****  syntax object  V2.0  ***/
#define SYNTAXSYMBOL     0x200002    /****  syntax object  V2.0  ***/
#define SYNTAXLAMBDA     0x8220000    /****  syntax transformer  V2.0  ***/
#define MALLOC     0x400000   /*** for m-compiler,  malloced space  ***/
                            /*** (adress  .  size) by ptr ***/
#define MALLOC_BIN 0x800000   /***  malloc  data string or pure binary,
                                   contents are not scheme obj ***/
//#define SUBRADD   0x1000000     //reserved org is   subr  (env .  func-address)
#define SSPACKAGE   0x2000000  /****  package ***/
#define HASH      0x4000000  /****  hash ***/
#define EXTEND    0x6000000  /****  hash ,package ***/
#define SRFUNC      0x8000000  /****  SR2 or SYNTAXLAMBDA  ***/
/***  V2.0  functions   ***/
#define SR2 0x8020000  /****  SRFUNC+LAMBDA  ***/
/** #define SR2MACRO 0x8040000  ****  EXTEND+MACRO  ***/
/**  2019.12.30  now used SPECIAL,SLAMBDA,  SR2, SYNTAX+SR2   --- only 4 ***/

/****  END of attr define  ***/

/****  FTYPE def   ***/
//#define FTYPE(f)  (CAR(f))  ->EXATTR  2019.11
#define FENV(f)  (CAR(f)) //v2.22
#define FBODY(f)  (CDR(f))
#define FENVnew(f)  (CAR(f))
#define FBODYnew(f)  (CDR(f))
//#define FALLOC    0x20000000  /*** use in FTYPE  M-compiled!  ***/
#define TRACE     0x40000000  /*** use in FTYPE  traced!  ***/
//#define TKFUNC    0x80000000   /***  use in FTYPE TK   ***/
#define TKFUNC    0x20000000   /***  use in FTYPE TK   ***/
/*** #define SOBJ            0x1   ***  FTYPE is SINT for system obj func-address**/
/***  but subr_argtype() is SINT***/
  
#define SINGLE    0x10001000  /*** use in FTYPE  single-syntax-lambda ***/
#define NOTSINGLE 0x00001000  /*** use in FTYPE  notsingle-syntax-lambda ***/

/***  basic macro **/
#define CAR(xx)  ((xx)->ss.cons._car)
#define CDR(xx)  ((xx)->ss.cons._cdr)
#define BIGNUM(xx)  ((xx)->ss.bignum.data)
#define RATIONAL(xx)  ((xx)->ss.rational.data)
#define FLONUM(xx)  ((xx)->ss.flonum.data)
#define CDDR(xx)  (CDR(CDR(xx)))
#define CADR(xx)  (CAR(CDR(xx)))
#define CADDR(xx)  (CAR(CDDR(xx)))
#define CDDDR(xx)  (CDR(CDDR(xx)))
#define MARK(xx)  ((xx)->_attr)
#define ATTR(xx)  ((xx)->_attr)
#define TYPE(xx)  (((xx)->_attr)&0x0fffffff)
#define TYPEMASK  (0x0fffffff)
#define MARC(xx)  (((xx)->_attr)&0xf0000000) /*** gbc  ***/
#define PNAME(xx)  (CADR(xx)) 
#define FNAME(xx)  (CADDR(xx)) 
#define HOMEPK(xx)  (CDDDR(xx)) 
#define NIL  a_nil
#define UNDEFINED   a_undef
#define Truth   a_t
#define Ntruth   a_f

#define EXATTR(xx)  ((xx)->_exattr)
/**  2019.11  STRING  has real usable size is set to exattr **/

/***  symbol   CAR=value, CADR=PNAME, CDDR=extension reserve **/
/***   CADDR=FNAME CDDR =HOMEpackage ***/
/***   attr of CDR(s)  is attribute for symbol  ****/
// #define  SATTR(x) ATTR(CDR(x))
/*** #define  EXPORT   SYMBOL     not used Now , reserve for other attr of symbol ***/ 
#define  CONSTF   KEYWORD   /*** for symbol flag  ***/ 

#define SVAL(f)  (CAR(f))
#define ATOMVAL(f)  (CAR(f))
#define MAKEID(s)  (intern_c((s),a_undef))   /****  C-str ->symbol ***/
#define top_value_set(x,val)  (CAR(x)=(val))

#define NULLP(p)  (p==a_nil)
#define SYMBOLP(p)  (MARK(p)&SYMBOL)
#define KEYWORDP(p)  (MARK(p)&KEYWORD)
#define STRINGP(p)  (MARK(p)&STRING)
#define VECTORP(p)  (MARK(p)&VECTOR)
#define MATRIXP(p)  (MARK(p)&MATRIX)
#define NUMBERP(p)  (SINTP(p)||((!CHARP(p))&&(MARK(p)&NUMBER)))
#define NOT_NUMBERP(p)  (CHARP(p)||((!SINTP(p))&&(!(MARK(p)&NUMBER))))
#define BOOLEANP(p)  (MARK(p)&BOOLEAN)
#define BIGINTP(p)  (MARK(p)&BIGINT)
#define INTEGERP(p)  (SINTP(p)||BIGINTP(p))
#define RATIOP(p)  (MARK(p)&RATIO)
#define DOUBLEP(p)  (MARK(p)&DOUBLE)
#define FLOATP(p)  (MARK(p)&DOUBLE)
#define COMPLEXP(p)  (MARK(p)&COMPLEX)
#define REALP(p)  (SINTP(p)||(MARK(p)&REAL))
/** #define CWCP(p)  (MARK(p)&CWC) **/
#define FUNCP(p)  (MARK(p)&CLOSURE)
#define CLOSUREP(p)  (MARK(p)&CLOSURE)
#define STREAMP(p)  (MARK(p)&STREAM)
#define TKOBJP(p)  (MARK(p)&TKOBJ)
#define EXTP(p)  (MARK(p)&EXTEND)
#define MALLOCP(p)  (MARK(p)&MALLOC)
#define PACKAGEP(p)  (MARK(p)&SSPACKAGE)
#define HASHP(p)  (MARK(p)&HASH)
//#define SUBRADDP(p)  (MARK(p)&SUBRADD)
#define STRUCTP(p)  (MARK(p)&STRUCTURE)
#define NETSOCKETP(p)  (MARK(p)&NETSOCKET)

#define ATOM(xx)   (TYPE(xx))
#define SSATOM(xx)  (SREGP(xx)||TYPE(xx))
#define CONSP(xx)  (!SSATOM(xx))
#define PAIRP(xx)  (!TYPE(xx))    /***  CONSP ,i.e.  pair? **/
/****   bit version  ***/
#define B_SYMBOLP(p)  ((p)&SYMBOL)
#define B_KEYWORDP(p)  ((p)&KEYWORD)
#define B_STRINGP(p)  ((p)&STRING)
#define B_NUMBERP(p)  ((p)&NUMBER)
#define B_CONSP(xx)  (!(xx))
#define B_BIGINTP(p)  ((p)&BIGINT)
#define B_INTEGERP(p)  ((p)&BIGINT)
#define B_RATIOP(p)  ((p)&RATIO)
#define B_REALP(p)  ((p)&REAL)
#define B_VECTORP(p)  ((p)&VECTOR)
#define B_DOUBLEP(p)  ((p)&DOUBLE)
#define B_FLOATP(p)  ((p)&DOUBLE)
#define B_COMPLEXP(p)  ((p)&COMPLEX)
#define B_CLOSUREP(p)  ((p)&CLOSURE)
/*** #define B_CWCP(p)  ((p)&CWC) **/
#define B_JMPP(p)  ((p)&JMP)
#define B_STREAMP(p)  ((p)&STREAM)
#define B_BOOLEANP(p)  ((p)&BOOLEAN)

#define B_EXTP(p)  ((p)&EXTEND)


/*** register value object ***/
#define Long long long    /*** 64 bit ***/
#define INT   long     /***  32 or 64 bit  same size of ptr  ***/
#define MAKESINT(x)  ((ptr)((((INT)x)<<2)|1))  /*** small int ***/
#define MAKECHAR(x) ((ptr)((((INT)x)<<2)|3))   /*** char include kanji  ***/

#define MAKENUM(x)  MAKESINT(x)

#define  SINTP(x)  ((((INT)x)&3)==1)
#define  INTP(x)  ((((long)x)&3)==1)
#define  CHARP(x)  ((((INT)x)&3)==3)
#define  SREGP(x)  ((((INT)x)&1))    /****  ?scheme object as register value? ***/


//#define  SINT_NUMB(x) (((long)x)>>2)            /*** small int to number **/
#define  GETNUM(x)    (((INT)x)>>2)            /*** small int to number **/
#define  CHAR_CODE(x) ((((INT)x)>>2)&0xffffffff)  /*** may be kanji ,utf8 ***/ 

#define GMAKESTR(p,n)   makestring_p(p,n)
#define CMAKESTR(p)   make_str_c(p)
#define NULLSTR  (a_nullstr)

#define ZERO  ((ptr)1)
#define ONE   ((ptr)5)
#define TWO   ((ptr)9)
#define THREE  ((ptr )13)
#define TEN    ((ptr )41)
#define MINUSONE   ((ptr)-3)  /***  ...1101  **/

#define INTPTR(x)  ((ptr )(long)(x))   // int->ptr

#define  SEOF  ((ptr)(-1))        /**  this is interpreted as a CHAR! eof-object **/
                              /****  and same as EOF  in <stdio.h>  ***/
#define  CLOSED  ((0x8000))   /****  CLOSED port ****/
#define  STR_PORT     0x100   /*** str  **/
#define  FUNC_PORT    0x200   /*** lambda port  **/
#define  SOCKET_PORT    0x400   /*** socket port  **/
#define  EXT_PORT     0x700   /*** str,lambda,socket port  **/
#define  read_ac   0x001
#define  write_ac  0x002
#define  append_ac 0x004
#define  output_ac 0x006
#define  both_ac   0x003    /***  read&write ***/ 
#define  r_a_ac    0x005    /***  read&append ***/ 
#define  no_ac     0x000    /***  can not read&write, listen socket ***/ 
#define  network_ac 0x013
#define  listen_ac  0x020
#define  istty_ac   0x040  /**  v2.19 only keyinput&tty stream.c **/
#define  sock_fdp  0x01   /*** not used  ***/
#define  sock_addr ((ptr)0x11)

#define TMAX 64       /**** fileno Max ***/
#define HISMAX 100   /****  debug combination stack MAX ***/
#define AFTERMAX 100   /**** after cmds MAX ***/
#define  FILEBUFMAX  1024  /*** 2048  **/
#define UL   unsigned long        /**** for cast of pointer ***/

//#define SETSTRLOC(str,loc)  CDR(str)=MAKESINT(loc)
//#define GETSTRLOC(str)  GETNUM(CDR(str))
#define SETSTRLOC(str,loc)  CDR(str)=(ptr)(long)(loc)
#define GETSTRLOC(str)     (long)(CDR(str))

#ifdef MAIN_PROGRAM
#define Extern   
#else
#define Extern extern
#endif

/*****    scm  defined where????   04.4.24  ***/
/*** Extern ptr scm,multiscm;***/

Extern
int sigcode,sys_alarm,block, kanji_mode,kanji_error,rm_error,tk_flag,top_visible,istty; 

/****  for debug loop   ****/
/***
Extern
int debug_level,debug_jmp,debug_narg,debug_next;
Extern
ptr *debug_pc,*debug_stack;
***/
Extern
ptr a_sysdebug;   /***   *SYSDEBUG*   temporally  for MC debug ***/
Extern 
ptr  a_errno;  /***   *errno*  ***/
Extern 
ptr  Errno;  /***   errno    V2.0  ONLY SINT or NULL no need gbc***/
Extern 
ptr a_stdin,a_stdout,a_stderr,a_stdmsg,a_stdnull,a_home,a_pwd,a_startdir,a_hostname;
Extern 
ptr a_dynamic,a_make_cc,a_restore_cc,a_call_cc,a_call_values;
Extern
ptr a_keyinput,a_tcl,a_errorhook,a_nop,a_tclerror,a_tclversion,a_str_slash,a_tk;
Extern
ptr a_errorhook,a_syserrorhook,a_r_e_p;
Extern
ptr  k_q,k_n,k_c,k_hatena,k_set;
Extern
ptr a_tail_call,a_load_reg;   /*** for compiler ***/
Extern
ptr a_argv;    /***   ss cmd parameters are set! in *argv*,  see sysini.c   ***/
Extern
ptr a_eq,a_eqv,a_equal;  /*** for hash  ***/
Extern
ptr a_linehis,a_win_xsize,a_win_ysize,a_win_change;  /*** line history  ***/
Extern
ptr a_structure_inits,a_structure_offset,a_structure_size,a_structure_slots_name;
Extern
ptr a_info,a_cancel,a_tracevars,a_sslib,a_autopath,a_eof_object;

/*** quasiquote **/

#define STDIN    CAR(ATOMVAL(a_stdin))
#define STDOUT   CAR(ATOMVAL(a_stdout))
#define STDERR   CAR(ATOMVAL(a_stderr))
     /***  system  error out 04.11.14   ***/
#define STDMSG   ATOMVAL(a_stdmsg)    /*** init value is stderr ***/ 
     /***  system initialize messgae  not stack   04.11.14   ***/

/** #define CELLMAX    100000   **** 2.4 MB ***/
/*** #define CELLMAX   150000   ***  3.5 MB ***/

//#define CELLMAX      200000  // ***  4.8  MB **

//#define CELLMAX      500000   /*** old usual  12  MB ***/

 /** #define CELLMAX   800000   19MB  test ***/
  //#define CELLMAX      20000  // 480k  test ***
#define CELLMAX      30000  // 720k test   very good     ***

#ifdef MAIN_PROGRAM
cell allcell[CELLMAX];
ptr fc_begp,fc_endp;
#else
extern cell allcell[];
extern ptr fc_begp,fc_endp;
#endif

/*** #define OBJP(x)  ((x)>=allcell&&(x)<=fc_endp)   ***/

/****   scheme stack ****/
/** #define STACKSIZE 2000000    **  8MB **/
#define STACKSIZE 1000000    /****  8MB **/
/*** #define MPUMAX    2000000  **  MPU is used in MC ***/
#define MPUMAX    1000000  /***  MPU is used in MC ***/
#ifdef MAIN_PROGRAM
ptr  stack_base[STACKSIZE];
 ptr MPU[MPUMAX];  
#else
extern ptr stack_base[];
extern ptr MPU[];  
#endif

#ifdef MAIN_PROGRAM
ptr  sysprotect[100];
int  syspro=0;
#else
extern ptr  sysprotect[];
extern int  syspro;
#endif


Extern ptr *stack,*frame_stack,*mpu_stack;   /** frame  in stack ***/

#define l_sp  stack
#define alloc(n)  (stack+=(n))

/****  top-level symbol hash vector **/
#define SYMBOLMAX 4096
#ifdef MAIN_PROGRAM
ptr  top_hash[SYMBOLMAX]; /*** 12 bit hash **/
#else
extern ptr top_hash[];
#endif

#define MAXIO 5000
#ifdef MAIN_PROGRAM
char  iobuff[MAXIO];
#else
extern char iobuff[];
#endif


Extern
ptr sym_list,free_cell,a_nil,a_undef,a_unbdd,a_t,a_f,a_name_char,a_nullstr;
Extern 
ptr s_undef,a_hash,a_package,ss_package,sys_package,alias_package,a_all_packages,a_colon,a_none;
Extern
ptr key_package,tk_package;

Extern
ptr a_dot,a_plus,a_bind,a_toplevel;
Extern ptr a_letsyntax,a_letrecsyntax,a_quote, a_lambda,a_macro,a_system,a_sr2;
Extern ptr a_syntax_lambda; /*** V2.0 ***/
Extern ptr a_macroexpand,a_setq,a_define,a_let,a_let_s,a_letrec,a_begin,a_if,a_dot3,a_letdefine;
/***  Ver 2.0  ***/
Extern ptr a_CALL_CC,a_inline;
Extern
ptr a_read,a_tty_read;
Extern 
ptr a_readtable,a_quasi_quote,a_unquote,a_unquote_splice,a_read_base,a_auto_case;
Extern ptr a_lambda_quote; /*** V2.0 ***/
Extern
ptr a_cons,a_append,a_list,a_liststar,a_auto_regexp;
/***  a_dot は . 1文字のシンボルである。これは、dot対の構成に使う ***/
/***  read　は　単独の . をシンボルとして扱う！  ***/

Extern
ptr a_special,a_errmsg,a_trace,a_eval,a_apply,a_sysapply,a_sysload;
Extern 
ptr a_env,a_error_env;   /****  scheme (local)  environment   ***/

#define push_env(e)      a_env_stack=SCONS((e),a_env_stack)
#define pull_env()      a_env_stack=CDR(a_env_stack)
/*  special form  */



#define EQ 0
#define NEQ 1
#define YES 1
#define NO 0
#define TRUE 1
#define FALSE 0
#define Reg register

#define QCONS(x,y)  CONS(x,y)

/* print circle attribute  */
#define  CIRCLEMARK  0x10000000
#define  CIRCLECLR   0xefffffff
#define  CIRCLEP(x)  (ATTR(x)&CIRCLEMARK)
#define  CLRCIRCLE(x) (ATTR(x)&=CIRCLECLR)
#define  SETCIRCLE(x) (ATTR(x)|=CIRCLEMARK)

/*** for GBC ***/
/****    0x20000000  is resereved ***/
#define  FREECELL    0x40000000
#define  GBCMARK     0x80000000

/*** #define NULL   (0)  ***/
/****    jump   ****/
#define calljmp()   setjmp(user_env[jmp_level++])
/**** psh   ****/
#define psh(p)  (*stack++=(p))
#define pull()  (--stack)
#define sp_pull(n)  (stack-=(n))
#define PRED(x)  ((x)?a_t:a_f)
#define RPRED(x)  ((x)?a_f:a_t)
#define NOT(x)  (((x)==a_f)?a_t:a_f)
/**** char ***/
typedef unsigned char Uchar;
typedef unsigned int Uint;
typedef unsigned Long ULong;
/***** MATH   ***/
ptr a_pi,a_pi2,a_log2,a_log10,a_imag;
#ifdef MAIN_PROGRAM
/*** double pi=3.14159265358979323846264338,pi2; ***/
double pi,pi2;
int jmp_level=0,mc_jmp=0;
#else
extern ptr a_pi,a_pi2,a_log2,a_log10,a_imag;
extern double pi,pi2;
extern int jmp_level,mc_jmp;
#endif
Extern 
ptr prompt,error_prompt,a_prompt,a_version;
#define PROMPT   ATOMVAL(a_prompt)

/*** V2.0 symbol  ***/
Extern
ptr a_begin_sr2;
/****  GMP  ****/
/***   62 bit SINT experiment ***/
#ifdef SYSTEM64
#define SINTMAX 0x1fffffffffffffff  /*** 2305843009213693951 ***/
//#define SINTMIN 0xe000000000000000   ***  this cause Bug!  *** 
#define SINTMIN -2305843009213693952
#else
#define SINTMAX 0x1fffffff  /***  536870911   **/
#define SINTMIN  -536870912  /*** ((int)0xe0000000)   -536870912  **/
#endif

/**** print  ****/
Extern
ptr print_radix;
Extern
int  print_base;
#define pr_cstr(s,p)  lwritestr(s,p)
#define WRITE_CHAR(c,s)  lwritec(s,c)
/** #define form_err(s,p)  error(s,p)  **/

#define PAGE 12       /**** FF code ***/

#ifdef USE_TK
#include "tklisp.h"
#endif
/****  print  ***/
#define PRINT(p) lwritestr(STDOUT,(p)); 
/****  Basic procedures  ***/
#ifndef  HEAP_C
#define HEAP_C extern
#endif
HEAP_C void *Mymalloc(),*Myrealloc(),Myfree();

#ifndef  VM_C
#define  VM_C extern
#endif
VM_C ptr vm_eval(ptr,ptr);

#ifndef  MAKESUB_C
#define  MAKESUB_C extern
#endif
MAKESUB_C  void checknarg(int);
MAKESUB_C  void init_sub( struct sys_subr *, int);

#ifndef  ERROR_C
#define  ERROR_C extern
#endif
ERROR_C  ptr error(int,ptr);
ERROR_C  void fatal_error(int,ptr);
ERROR_C  ptr s_bye(int,ptr);

#ifndef  SYSINI
#define SYSINI extern
#endif
SYSINI void sys_pro(ptr );
SYSINI void paraload(int,char **);
SYSINI void load_verbose_set(int );

#ifndef  LKER
#define LKER extern
#endif
LKER ptr CONS(ptr,ptr),SCONS(ptr,ptr),get_cell(),new_cell(),objaddress(), s_objaddress();
LKER void make_free_cell();
LKER int OBJP(ptr);

#ifndef  STR_PROG
#define STR_PROG extern
#endif
STR_PROG unsigned char *get_string(ptr,Uint *);
STR_PROG unsigned char *get_string_ex(ptr,Uint *,Uint *);
STR_PROG ptr makestring(),makestring_init(int,Uint),copy_str(), make_str_c(),string_equal();
STR_PROG ptr str_append(),j_substring();
STR_PROG unsigned char * jindex(),*jnext();
STR_PROG int pstrcpy(char *,ptr);
STR_PROG int euc_first(Uchar),euc_code(Uchar,Uchar);
STR_PROG int jstrlength(Uchar *,int);
STR_PROG int scm_strcmp(Uchar *,Uchar *,int);
STR_PROG int STRLEN(ptr);
STR_PROG Uchar *extend_str(ptr,unsigned int);
STR_PROG Uchar *set_char(Uint ,Uchar *);

#ifndef  APPLY_PROG
#define APPLY_PROG extern
#endif
APPLY_PROG ptr s_apply(), s_eval();
#ifndef  ASSQ_PROG
#define ASSQ_PROG extern
#endif
ASSQ_PROG ptr assq(),assq2(),rassq(), assoc(), rassoc(),member(), memv(), memq(),remq(),ssremove();
#ifndef  STR2NUM
#define STR2NUM extern
#endif
STR2NUM  ptr str2number(),str2num(),g_radix();
#ifndef  COMP_PROG
#define COMP_PROG extern
#endif
COMP_PROG  ptr s_compile(), list2(),list3(), specialp(),C_macro_expand(),get_value();
#ifndef  MC_PROG
#define MC_PROG extern
#endif
MC_PROG  ptr stack_to_list(),stack_2_list(),comp_to_alloc(),s_mc_eval();
MC_PROG  ptr stack_to_listS(),mc_jsr(),MC_jsr(),*MC_adress(),MC(),list_to_alloc();
#ifndef  FUNCALL
#define FUNCALL extern
#endif
FUNCALL ptr funcall();
#ifndef  GREAD
#define GREAD extern
#endif
GREAD ptr gread(), s_gread(),g_read(),extoken(),mxtoken();
#ifndef  OPEN_PROG
#define OPEN_PROG extern
#endif
OPEN_PROG ptr s_str_output(),s_str_append(),reopen_str(),open_str();
OPEN_PROG ptr makenewstream(),makefilestream(), open_sub();
OPEN_PROG void str_set_pos(ptr);

#ifndef  LIST_PROG
#define LIST_PROG extern
#endif
LIST_PROG ptr  reverse_list(ptr),last_pair(ptr);
LIST_PROG int  _length(ptr),nc_length(ptr);
#ifndef  INTERN_PROG
#define INTERN_PROG extern
#endif
INTERN_PROG  ptr intern_c(),s_gensym(),intern(), key_intern(),key_intern_c(),M_top_value_set();
INTERN_PROG ptr intern_c_pack();
#ifndef  PACKAGE_C
#define PACKAGE_C extern
#endif
PACKAGE_C  ptr find_package(),make_package(),find_symbol(),ss_find_symbol(),k_intern(),in_intern();
#ifndef  FUNC_C
#define FUNC_C extern
#endif
FUNC_C ptr make_subr(),subr_argtype(),function_name();
#ifndef  SLOAD_C
#define SLOAD_C extern
#endif
SLOAD_C  ptr probe_ext(),s_load();
#ifndef  VAR_C
#define VAR_C extern
#endif
VAR_C  ptr load_top();
#ifndef  VECTOR_C
#define VECTOR_C extern
#endif
VECTOR_C ptr *get_vector(ptr,int *),makevector(int,ptr),getvector(int),vector_ref(ptr,int),vector_set(ptr,int,ptr),make_vect_list(ptr);
VECTOR_C ptr vector_copy();
#ifndef APPEND_C
#define APPEND_C extern
#endif
APPEND_C ptr append();
#ifndef  EQUAL_C
#define EQUAL_C extern
#endif
EQUAL_C  ptr eqv(),equal();
#ifndef  WRITE_C
#define WRITE_C extern
#endif
WRITE_C ptr  princ(), prin1(), print();
WRITE_C void newline(),pr_INT(),pr_INTEGER();
#ifndef   MS_C
#define  MS_C extern
#endif
 MS_C  ptr meval(),s_mcompile(),s_meval();
#ifndef   ALLOC_C
#define  ALLOC_C extern
#endif
ALLOC_C ptr make_alloc(),make_alloc_bin(),alloc_str();
#ifndef   ENV_C
#define  ENV_C extern
#endif
ENV_C  ptr pr_env();
#ifndef   GBC_C
#define  GBC_C extern
#endif
GBC_C  ptr gbc();
GBC_C  void Free_cell(ptr);
#ifndef    GLOB_PROG
#define   GLOB_PROG extern
#endif
 GLOB_PROG ptr glob_files();
#ifndef  HASH_C 
#define  HASH_C extern
#endif
HASH_C ptr  make_hash(),rehash(),remhash(),gethash(),sethash(),get_hash_vector();
HASH_C ptr  s_mapcdrhash();
#ifndef  HITORY_C
#define  HITORY_C extern
#endif
HITORY_C  ptr psh_his();
#ifndef   M_OPT_C
#define  M_OPT_C extern
#endif
M_OPT_C ptr delete_warn(),delete_nop(),insert_comp();
#ifndef   KANJI_C
#define   KANJI_C extern
#endif
KANJI_C int utf8_first(Uchar );

#ifndef   MAKENUM_C
#define  MAKENUM_C extern
#endif
MAKENUM_C ptr makenumsub(),makenum();
#ifndef  MATRIX_C
#define  MATRIX_C extern
#endif
MATRIX_C ptr make_matrix_list();
#ifndef   NUMBER_STR
#define  NUMBER_STR extern
#endif
NUMBER_STR ptr number2str();
#ifndef  PATHNAME_C
#define  PATHNAME_C extern
#endif
PATHNAME_C ptr sspathname_base();
PATHNAME_C char *get_ext();
#ifndef   RATIO_C
#define  RATIO_C extern
#endif
RATIO_C  ptr  mpq2rational(),mpz2rational(),intdiv_long(), ratio();
RATIO_C  ptr ratiomul(),ratiodiv(),ratioadd(),ratiosub(),ratiomod();
RATIO_C  ptr  ratioremain(),d2rational();
#ifndef    READ_M_C
#define  READ_M_C extern
#endif
 READ_M_C ptr s_rm_quote(),s_rm_back_q(), s_rm_komma(),s_rm_remark();
 READ_M_C ptr  s_rm_right_p(),s_rm_left_p(),s_rm_str();
#ifndef   READCHAR_C
#define  READCHAR_C extern
#endif
READCHAR_C ptr unreadchar(),read_char(),peekchar(), writechar();
#ifndef   READTABLE_C
#define  READTABLE_C extern
#endif
READTABLE_C ptr get_type(),get_tbl_syntax(),s_rm_dispatch();
#ifndef   S_CHAR_C
#define  S_CHAR_C extern
#endif
S_CHAR_C ptr s_char_downcase(),s_char_upcase();
#ifndef SOCKET_C
#define  SOCKET_C extern
#endif
SOCKET_C  ptr socket_readbuf(),socket_readc();
#ifndef    STREAM_C
#define  STREAM_C extern
#endif
STREAM_C  ptr sys_close(), lreadc(), lfflush(),close_str(), lwritestr();
STREAM_C  ptr str_back_writec(),func_back_writec(), back_writechar();
STREAM_C  ptr func_port_ready(),func_unread();
STREAM_C  void lwritec(), str_writec();
STREAM_C  int ssfileno(ptr);
#ifndef   TAIL_M_C
#define  TAIL_M_C extern
#endif
TAIL_M_C  ptr tail_expand(),let_expand();
#ifndef   TK_CONVERSION_C
#define  TK_CONVERSION_C extern
#endif
TK_CONVERSION_C  ptr get_ss_obj();
#ifndef   TK_EVAL_C
#define  TK_EVAL_C extern
#endif
TK_EVAL_C ptr tcleval(),s_print_last_tcl();
TK_EVAL_C void  update(void);
#ifndef   TK_LINKVAR_C
#define  TK_LINKVAR_C extern
#endif
TK_LINKVAR_C ptr make_tklink(),set_tklink(),get_tklink();
#ifndef   TK_SSCONV_C
#define  TK_SSCONV_C extern
#endif
TK_SSCONV_C ptr ss_tkstr_simple(),ss_tkstr();
#ifndef   TOKEN_C
#define  TOKEN_C extern
#endif
TOKEN_C ptr analyze(),pack_make_symbol();
#ifndef   VALUES_C
#define  VALUES_C extern
#endif
VALUES_C ptr  s_values();
#ifndef   BIG_C
#define  BIG_C extern
#endif
BIG_C ptr  check16(ptr),mpz_check16(mpz_t),mpz2bignum(mpz_t), ptr2bignum(ptr),bignum(long);
BIG_C ptr  bignum64(unsigned long,unsigned long);
#ifndef   BIGMATH_C
#define  BIGMATH_C extern
#endif
BIGMATH_C ptr longadd(),longneg(),longsub(),longmul(),long16mulsub();
BIGMATH_C ptr longdiv(),longmod(),longremain(),long16divsub(),long16modsub();
BIGMATH_C ptr long16remain(),longinc();
#ifndef   COMPLEX_C
#define  COMPLEX_C extern
#endif
COMPLEX_C ptr list_complex(),make_complex(), complex(), s_complex();
COMPLEX_C ptr complexadd(),complexsub(),complexmul(), complexdiv();
COMPLEX_C ptr  norm2(), _complex();
#ifndef   DBL_C
#define  DBL_C extern
#endif
DBL_C ptr  MAKEDBL(),_float(),floatadd(),floatsub(),floatmul(),floatdiv();
DBL_C ptr  floatmod(), floatremain();
DBL_C double  getdbl(),get_float();
#ifndef   F_MATH_C
#define  F_MATH_C extern
#endif
F_MATH_C  ptr  minus(ptr),ABS(ptr),ATAN(ptr,ptr), LOG(ptr), EXP(ptr), CIS(ptr),INTEXPT(ptr,ptr);
F_MATH_C  ptr  num_coerce(ptr,ptr),EXPT(ptr,ptr);
F_MATH_C  int  zerop(ptr),gsign(ptr);
F_MATH_C  int  gen_eq(ptr,ptr);
#ifndef   FLOOR_C
#define  FLOOR_C extern
#endif
FLOOR_C ptr ffloor(), rfloor(),rtruncate(), _ftruncate(),rceiling();
FLOOR_C ptr fceiling(), rround(), fround(),genfix(),negative(),genfixf();
#ifndef  SINT_C
#define  SINT_C extern
#endif
SINT_C  ptr  add(), sub(),mul(),mod(),remain(),intdiv_sint(),div_sint(); 


