/*** number_str.c
***/
#define  NUMBER_STR

#include "lisp.h"
#include <stdio.h>
#include <string.h>

extern mpz_t mpzwork1;
/** extern void force_float(char *);   write.c */
extern void Prin_sint(Long,int,char *);
extern void prin_G(double ,char *);
static int free_flag=0;    // call Myfree
static char  numb_str[32];   // for SINT, DOUBLE

static char *complex_str(ptr,int);

static char * number2str_aux(Reg ptr q,int base){
Reg int n;
Reg char *qq;

/*** printf("number2 %x  base %d\n",q,base); ***/
if(base>36) error(E_range,MAKESINT(base));
if(SREGP(q)){
   if(CHARP(q)) goto err;
   Prin_sint(GETNUM(q),base,numb_str);
   return numb_str;
  }
n=ATTR(q);
       if(n&BIGINT){
          psh(q);
          qq=mpz_get_str(0,base,BIGNUM(q));
          //strcpy(pp,qq);
          //Myfree(qq);
          pull();
           free_flag=1;
          return qq;
        }
       else if(n&RATIO){
           psh(q);
           qq=mpq_get_str(0,base,RATIONAL(q));
         // strcpy(pp,qq);
         // Myfree(qq);
           free_flag=1;
          pull();
          return qq;
        }
       else if(n&DOUBLE){
           /** format("%f",FLONUM(q)); ***/
            prin_G(FLONUM(q),numb_str);
           //format("%-11.8g",FLONUM(q));
           //force_float(iobuff);
          return numb_str;
           
       }
      else if(n&COMPLEX){
         return complex_str(q,base);
      }else{
err:
      fprintf(stderr,"number2str_aux %p %x\n",q,n);
       error(E_notnum,q);
       }
   return numb_str;   // Never reach
}

static char *complex_str(ptr q,int base){
    char *p=NULL,*im;
    int n=0;
     if(CAR(q)!=ZERO)
           p=number2str_aux(CAR(q),base);
     if(p!=NULL) n=strlen(p);
     if(free_flag){
         // old p=Myrealloc(p,n,n+4);
         p=Myrealloc(p,n+4);
      }
     else{
        im=Mymalloc(n+4);
        if(n>0) strcpy(im,p);
        else
          *im='\0';
        p=im;
      }
          q=CDR(q);
           if(gsign(q)){
              q=minus(q);
              strcat(p,"-i");
           }else
              strcat(p,"+i");
         n=strlen(p);
         psh(q);    //ABS(q)
           if(q!=ONE){
              free_flag=0;
              im=number2str_aux(q,base);
              // old p=Myrealloc(p,n,n+strlen(im)+1);
              p=Myrealloc(p,n+strlen(im)+1);
              strcat(p,im);
              if(free_flag) Myfree(im);
            }
          pull();
     free_flag=1;  // always p is malloc
     return p;
}

ptr number2str(Reg ptr q,int base){
  char *p;
      //fprintf(stderr,"number2str %p base=%d\n",q,base);
   p=number2str_aux(q,base);
   q=CMAKESTR(p);
   if(free_flag){
         Myfree(p);
         free_flag=0;
   }
   return q;
}   

ptr s_number2str(int narg,ptr env){
  int base;
  if(narg==1)
          base=10;
  else if(narg==2) base=GETNUM(*(stack-1));
  else
      checknarg(narg-2);
  return number2str(*(stack-narg),base);
}

