/***  qquote.c
    quasiquote 
   2010.8.12   Ver2.0   
     see quasi-syntax.ss   ***/

#include "lisp.h"

extern ptr k_T;
extern ptr _cadr();

static ptr quasi_pair();

ptr quasi_sub(ptr x){
   if(SREGP(x)) return x;
   if(CONSP(x)) return quasi_pair(x);
   if(SYMBOLP(x)){
               x=SCONS(a_quote,SCONS(x,a_nil));
           return SCONS(a_list,SCONS(x,a_nil));
    }
   return x;
}
static ptr quasi_pair(ptr x){
  ptr a,b;
  a=CAR(x);
  b=CDR(x);
  if(SREGP(a)||!CONSP(a)){
     if(a==a_unquote) return CAR(b);
     /*** (list 'cons `a `b)  ***/
   goto general;
  }
  if(CAR(a)==a_unquote_splice){
      if(b==a_nil)
            return CADR(a);
      else{
         x=SCONS(quasi_sub(b),a_nil);
         x=SCONS(CADR(a),x);
         x=SCONS(a_append,x);
         return SCONS(a_list,x);
       }
   }
  general:
     x=SCONS(quasi_sub(b),a_nil);
     psh(x);
     x=SCONS(quasi_sub(a),x);
     x=SCONS(a_cons,x);
     pull();
     return SCONS(a_list,x);
}
ptr lambda_qquote(int narg,ptr env){
 ptr x;
   checknarg(narg-1);
   x=*(stack-1);
   return quasi_sub(x);
}
    
ptr qquote(int narg,ptr env){
 Reg ptr body,x,s=a_nil,res=a_nil,top,tmp;

   checknarg(narg-1);
   body=*(stack-1);
  /**
   printf("quasiquote: body %x\n",body);
   prin1(body,STDOUT);
   **/
   if(SREGP(body)) return body;
   if(ATOM(body)) return SCONS(a_quote,SCONS(body,a_nil));
   
         top=CAR(body);
         if(top==a_unquote) return CADR(body);
        tmp= res=CONS(a_append,a_nil);
        psh(res);                  
           while(CONSP(body)){
          x=CAR(body);
          body=CDR(body);
          if(!SREGP(x)&&CONSP(x)){
             top=CAR(x);
             if(top==a_unquote){
               x=SCONS(a_list,SCONS(_cadr(x),a_nil));
              }
             else if(top==a_unquote_splice){
                x=_cadr(x);
             }
             else {
                 x=SCONS(a_quasi_quote,SCONS(x,a_nil));
                 x=SCONS(a_list,SCONS(x,a_nil));
                 }
           }
           else{
             if(x==a_unquote){
                /***  x=body;   This is Bug!!!  ***/
                x=CAR(body);  /*** 2005.10.10  ***/
                body=a_nil;
               }
             else{
               x=SCONS(a_quote,SCONS(x,a_nil));
               x=SCONS(a_list,SCONS(x,a_nil));
              }
             }
           tmp=CDR(tmp)=SCONS(x,a_nil);
           
          }
          
          if(body!=a_nil){
               x=SCONS(a_quote,SCONS(body,a_nil));
               CDR(tmp)=SCONS(x,a_nil);
        }
   /** printf("quasiquote end  %x\n",*(stack-1)); ***/
    return *pull();
 }

void init_quasi(){
Reg ptr scm,tmp,env;
  env=CONS(k_T,a_quasi_quote);
  env=SCONS(env,a_nil);
  //scm=make_subr(qquote,(int)subr_argtype(1,0)|SMACRO,env);
  //scm=make_subr(qquote,(int)subr_argtype(1,0)|SR2MACRO,env);
  //ATOMVAL(a_quasi_quote)=scm;
  ATOMVAL(a_quasi_quote)=a_undef;
  scm=make_subr(lambda_qquote,(int)(long)subr_argtype(1,0)|SLAMBDA,env);/** for V2.0  **/
  ATOMVAL(a_lambda_quote)=scm;
}


               
               



