#include "lisp.h"
#include <stdio.h>

#define NIL a_nil

/***  simple version 2003.10.27  ***/
/***  use funcall  03.12.21 ***/

/*** short list のsort  sub ***/

void  lvsort();
void llsort();
void svsort();

void slsort(l,pred)
   ptr l,pred;
 {
 	Reg ptr x,z,v,w,m,cmd;
 	ptr s,para;
     
    psh(l);
    psh(l);
   while(l!=NIL){
   	    v=x=CAR(l);
   	    m=CDR(l);
   	    while(m!=NIL){
      	    w=z=CAR(m);
             *(stack-2)=w;
             *(stack-1)=v;
             s=funcall(pred,2,a_nil);
            if(s!=a_f)
               {
                  CAR(m)=x;
   	    	      x=z;
   	    	      v=w;
   	    	}
   	    	m=CDR(m);
   	      }
   	     CAR(l)=x;
   	     l=CDR(l);
   	}
   stack-=2;
 }

/*** short vector のsort  sub ***/

void svsort(p,pred,start,end)
   ptr p,pred;
   int start,end;              /***注意, end を含まない  ***/
 {
 	Reg int n,m,mi;
 	Reg ptr x,z,v,w,cmd;
 	ptr s,para;
     if(start==end-1) return ;
       psh(p);
       psh(p);
   	n=start;
   while(n<end){
   	    v=x=vector_ref(p,n);
            mi=n;
   	    m=n+1;
   	    while(m<end){
      	    w=vector_ref(p,m);
             *(stack-2)=w;
             *(stack-1)=v;
             s=funcall(pred,2,a_nil);
            if(s!=a_f)
               {
   	    	      mi=m; /***  minimum  ***/
   	    	      v=w;
   	    	}
   	    	m++;
   	      }
           if(mi!=n){
   	      vector_set(p,n++,v);
   	      vector_set(p,mi,x);
           }
           else
            n++;
   	}
   stack-=2;
   //return p;
 }

ptr s_sort(int narg,ptr env)
 {
   Reg ptr seq;
    int leng;
    Reg ptr pred;
    
    checknarg(narg-2);
    seq=*(stack-2);
    pred=*(stack-1);
      
   /*** leng=g_length(seq); ***/
    
   if(VECTORP(seq))
      {
            get_vector(seq,&leng);  
             lvsort(seq,pred,0,leng);
    }
   else if(CONSP(seq)){
        llsort(seq,pred,_length(seq));
     }
   else if(seq==a_nil)
        ;
   else 
      error(E_notseq,seq);
     /** printf("sort out stack %x\n",stack); ***/
     return seq;
 }   

/***  sort of long seq ***/ 

/****  quick-sort ***/
void  lvsort(p,pred,start,end)
   ptr p,pred;
   int start,end;              /***注意, end を含まない  ***/
 {
 	Reg int l,r;
 	Reg ptr v,w,cmd,x;
 	ptr s,para,memo;
     
     if(end-start<12) return svsort(p,pred,start,end); 
     psh(p);
     psh(p);
    /*** select middle number ***/
      /***  printf("start %d end %d\n",start,end); ***/
    
       	l=start;
       v=x=vector_ref(p,l);
         while(++l<end){
      	    w=vector_ref(p,l);
             *(stack-2)=w;
             *(stack-1)=v;
             s=funcall(pred,2,a_nil);

               if(s!=a_f)
                      break;
   	      v=w;
   	}
   	  if(s==a_f) {
             /** printf("OK sorted start %d end %d\n",start,end); **/
             /***  pull();    ***** IIIIII   FOOOOGGGGOOOOOTTTTT !!!!!  ***/
               stack-=2; 
               /*** already ordered  ***/
               return ;
          }
             /** w is middle separate <=w, and >w ***/
       /** printf("tart %d l= %d w %x attr %x \n",start,l,w,ATTR(w)); ***/
   	     l=start;  r=end;
   	    while(1)
   	    {
              if(l>=r) break; /*** New >   ->  >=  **/
   	      v=vector_ref(p,l);
             *(stack-2)=w;
             *(stack-1)=v;
             s=funcall(pred,2,a_nil);

            if(s==a_f)
              {         /****  v<=w ***/
              	 l++;
              	 continue;
            }
             /*** v=V(l)>w   ***/
             x=vector_ref(p,--r);
             vector_set(p,r,v);
             vector_set(p,l,x);
 	    }
     stack-=2;
       /*** printf("2tart %d l %d\n",start,l);  ***/
     lvsort(p,pred,start,l);
     lvsort(p,pred,l,end);
    return ;
 }


 void llsort(l,pred,end)
   ptr l,pred;
   int end;
 {
 	Reg int n,s;
 	Reg ptr x;
 
  if(end<12) return slsort(l,pred);
    
     psh(x=make_vect_list(l));
    lvsort(x,pred,0,end);
    
    n=end;
    s=0;
     while(n--)
        {
         CAR(l)=vector_ref(x,s++);
         l=CDR(l);
        }
   pull();

}
 
