/***  string ****/
/***  revised 2004.11.23   for kanji_mode  off! ***/
/***  2014.5  *p++ BUG fix  ***/
#define STR_PROG
#include "lisp.h"
#include "kanji.h"
#include <ctype.h>
#include <string.h>
/***  Debug 2014.5.16  ***/
/*** #include <stdio.h>  ***/

extern ptr k_end,k_nocase;

extern Uchar *alloc_space(ptr ,Uint);
extern int get_alloc_bytes(void *);  // heap.c

ptr j_string_set(Uchar *,int ,int ,Uint );
ptr jstring_list();
ptr string_list();

Uchar *jindex_euc(Uchar *p,int ind, int len);
Uchar *jindex_utf(Uchar *p,int ind, int len);
int jstrlength_euc(Uchar *,int);
int jstrlength_utf(Uchar *,int);

Uchar *get_string(ptr str,Uint *len){
  Reg Uchar *p;   
  int n,m;
  /** org   *len=(Uint)(long)CDR(str);  **/
   //*len=(Uint)GETNUM(CDR(str));  
   n=GETSTRLOC(str);  
   *len=(Uint)n;
  
   p=(Uchar *)(CAR(str));  // org ++str
   //  if len=real size, then the following write next block!
  //  This cause bug!!!
   //*(p+*len)='\0'; /*** if for C-program  ***/
   //m=get_alloc_bytes(p);  // heap.c
   m=EXATTR(str);
   if(n<m)
      *(p+n)='\0'; /*** if for C-program  ***/
   return p;
}

Uchar *get_string_ex(ptr str,Uint *len,Uint *size){  // real size  also
  Reg Uchar *p;
  int n,m;
  /** org   *len=(Uint)(long)CDR(str);  **/
   n=GETSTRLOC(str);  
   *len=(Uint)n;
   p=(Uchar *)(CAR(str));  // org ++str
   // m=get_alloc_bytes(p);  // heap.c
   m=EXATTR(str);
   *size=(Uint)m;
   if(n<m)
         *(p+n)='\0'; /*** for C-program  ***/
   return p;
}


int size_of_char(Uint c){
  int b=1;
   /*** note utf-8 and euc has no bytes of zero **/
  if(c>=256){
    if(c&0xff000000)
      b=4;
    else if(c&0xff0000)
      b=3;
    else
      b=2;
  }
    return b;
}

Uchar *set_char(Uint c,Uchar *p){
   /*** note utf-8 and euc has no bytes of zero **/
  if(c>=256){
    if(c&0xff000000)
      *p++=c>>24;
    if(c&0xff0000)
      *p++=c>>16;
    if(c&0xff00)
      *p++=c>>8;
  }
    *p++=c;
    return p;
}

Uchar *set_char_b(Uint c,Uchar *p,int b){
   switch(b){
    case 4:
      *p++=c>>24;
    case 3:
      *p++=c>>16;
    case 2:
      *p++=c>>8;
   default:
      *p++=c;
  }
    return p;
}



int scm_strcmp(Reg Uchar *p,Reg Uchar *q,Reg int n){
   while(n--){
     if(*p++!=*q++) return NO;
  }
return YES;
}

int scm_strcmp_ci(Reg Uchar *p,Reg Uchar *q,Reg int n){
   while(n--){
     if(tolower(*p++)!=tolower(*q++)) return NO;
  }
return YES;
}


ptr makestring(int i){
 int n;
      ptr c;
    /***  printf("makestring enter size %d\n",i); ***/
       psh(c=new_cell(STRING));
       /*** org CDR(c)=(ptr)(long) i;  ** for gbc Caution!  ***/
    // CDR(c)=MAKESINT( i); /** for gbc   ***/
     SETSTRLOC(c,i);
    alloc_space(c, ++i);  /*** CAR(c) is set ***/
    /*** while(i--) *p++=0;    NULL character ***/
      pull();
    /***  printf("makestring return %x\n",c); ***/
   return c;
  }
/**  2019.10.13  for utf8-4 **/
ptr makestring_init(int i,Uint k){
 int b;
      ptr c;
    Reg  Uchar *p;
    /**  printf("makestr init  enter size %d\n",i); **/
       psh(c=new_cell(STRING));
     if(k<256){
       /** org  CDR(c)=(ptr)(long) i;  ** for gbc Caution!  ***/
     //CDR(c)=MAKESINT( i); /** for gbc   ***/
     SETSTRLOC(c,i);
         p=(Uchar *)alloc_space(c, ++i);  /*** CAR(c) is set ***/
         while(i--) *p++=k;  
      }
    else {  /** utf8 **/
         b=size_of_char(k); //  b=2,3,4
        /** org CDR(c)=(ptr)(INT)(b*i); ** for gbc Caution!  ***/
     //CDR(c)=MAKESINT( b*i); /** for gbc   ***/
     SETSTRLOC(c,b*i);
         p=(Uchar *)alloc_space(c, b*i+2);  /*** CAR(c) is set ***/
         while(i--)  p=set_char_b(k,p,b);
    }
    pull();
    /***  printf("makestr init return %x\n",c); **/
   return c;
  }

ptr s_makestring(int narg,ptr env){
  int ini;
  if(narg==1)ini=' ';
  else if(narg==2) ini=CHAR_CODE(*(stack-1));
  else checknarg(narg-2);
 return makestring_init(GETNUM(*(stack-narg)),ini);
}

ptr copy_str(ptr x){
 Reg ptr new;
 Reg Uchar *p,*q;
 unsigned int n,m;
  if(SREGP(x)||!STRINGP(x)) error(E_notstr,x);
  p=get_string(x,&n);
/*** Debug  ***/
 // printf("copy_str start '%s'  length=%d\n",p,n);
//2014.5.16
  new=makestring(n+1);  //  CDR(new)=n+1 is set by SINT
  //p=get_string(x,&n);
  //printf("copy_str again x '%s'  length=%d\n",p,n);
  q=get_string(new,&m);
  //printf("copy_str New  length=%d\n",n);
  m=n;
  while(n--) *q++=*p++;
  *q='\0';
  //CDR(new)=MAKESINT(m);
     SETSTRLOC(new,m);
 return new;
}


ptr s_string_copy(int narg,ptr env){
 Reg ptr x=*(stack-1);
  checknarg(narg-1);
  return copy_str(x);
}

ptr s_string_fill(int narg,ptr env){
 Reg ptr x=*(stack-2),c;
 Reg Uchar *p;
 unsigned int n,k;
 int b;
  checknarg(narg-2);
  if(SREGP(x)||!STRINGP(x)) error(E_notstr,x);
  c=*(stack-1);
 if(!CHARP(c)) error(E_notchar,c);
 k=CHAR_CODE(c);
  p=get_string(x,&n);
  if(k<256)
     while(n--) *p++=k;
  else {
      b=size_of_char(k);
      while(n>=b){
         p=set_char_b(k,p,b);
         n-=b;
      }
  }
  return a_undef; 
}

ptr makestring_p(Reg char *q, Reg int i){
   Reg   Uchar *p;
   ptr c;
     /** printf("makestring_p  enter %s size %d\n",q,i); **/
       psh(c=new_cell(STRING));
       /** org CDR(c)=(ptr)(long) i;  ** for gbc Caution!  ***/
       //CDR(c)=MAKESINT( i);// for gbc Caution!  
       SETSTRLOC(c,i);
    p=alloc_space(c, ++i);  /*** CAR(c) is set ***/
    while(i-->0) *p++=*q++;  
      pull();
    /**  printf("makestring_p   return %x\n",c); ***/
   return c;
  }

ptr make_str_c(char *str)    /*****  C string only!  ****/
 {
    return makestring_p(str,strlen(str));
 }

/**
C_strcpy (Reg char *p,Reg char *q,Reg int n){
   while(n--)
      *q++=*p++;
   *q=0;
}
**/

int pstrcpy(Reg char *buff,ptr s){
 unsigned int n,k;
 Reg Uchar *p;
  if(SREGP(s)||!STRINGP(s)) error(E_notstr,s);
  p=get_string(s,&n);
  k=n;
  while(k--) *buff++=*p++;
  *buff=0;
  return n;
}

ptr string_equal(ptr sp,ptr sq){
 Reg Uchar *p,*q;
 unsigned int n,m;
   p=get_string(sp,&n);
   q=get_string(sq,&m);
   if(n!=m) return a_f;
   return PRED(scm_strcmp(p,q,n));
}

ptr str_append(ptr u,ptr v){
unsigned int n,m,k;
Uchar *p,*q,*r;
ptr x;
  if(SREGP(u)||!STRINGP(u)) error(E_notstr,u);
  if(SREGP(v)||!STRINGP(v)) error(E_notstr,v);
  p=get_string(u,&n);  
  q=get_string(v,&m);  
  /*** printf("str-app %s %s\n",p,q);  ***/
  x=makestring(n+m);
  p=get_string(u,&n);  
  q=get_string(v,&m);  
  r=get_string(x,&k);
/**   Why  ????
  memcpy(r,p,n);
  memcpy(r+n,q,m);
***/
  while(n--){
  *r++=*p++;
   }
  while(m--){
  *r++=*q++;
  }
  return x;
}

/**  hakaiteki  change u, u must be str  ***/
ptr str_append_f(ptr u,ptr v){
unsigned int n,m,k;
Uchar *p,*q;
ptr x;
  if(SREGP(v)||!STRINGP(v)) error(E_notstr,v);
  p=get_string(u,&n);
  q=get_string(v,&m);
  /*** printf("str-app %s %s\n",p,q);  ***/
  p=extend_str(u,n+m+1);
  //r=Myrealloc(p,n+m+1);
  //CAR(u)=(ptr)r;
  //CDR(u)=MAKESINT(n+m);
  SETSTRLOC(u,n+m);
  memcpy(p+n,q,m);
/***
  while(n--){
  *r++=*p++;
   }
  while(m--){
  *r++=*q++;
  }
***/
  return u;
}

/**  hakaiteki  change u, u must be str  ***/
ptr str_append_fc(ptr u,char *q,int m){  // m is len of q
unsigned int n;
Uchar *p;
ptr x;
  p=get_string(u,&n);
  /*** printf("str-app %s %s\n",p,q);  ***/
  p=extend_str(u,n+m+1);
  //r=Myrealloc(p,n+m+1);
  //CAR(u)=(ptr)r;
  //CDR(u)=MAKESINT(n+m);
  SETSTRLOC(u,n+m);
  memcpy(p+n,q,m);
  return u;
}



ptr s_strappend_org(int narg,ptr env){
 Reg ptr u,v,*sfree;

 if(narg==0) return a_nullstr;
 if(narg==1) return *(stack-1);
sfree=stack-narg;
 u=*sfree++;
 psh(u);
 narg--;
 while(narg--){
  v=*sfree++;
  u=*(stack-1)=str_append(u,v);
 }
pull();
return u;
}  

ptr s_strappend(int narg,ptr env){
 Reg ptr u,v,*sfree,new=NULL;

 if(narg==0) return a_nullstr;
 if(narg==1) return *(stack-1);
sfree=stack-narg;
 u=*sfree++;
 psh(u);
 narg--;
 while(narg--){   // narg>=1
  v=*sfree++;
  if(new==NULL)
      new=*(stack-1)=str_append(u,v);
  else
      str_append_f(new,v);
 }
pull();
return new;
} 

int char_stack_bytes(int narg)  /*** char in stack, then   count bytes ***/
{
  Reg int n=0;
  Uint c;
  Reg ptr *sfree;
  sfree=stack-narg;
   while(narg--){
       c=CHAR_CODE(*sfree++);
       n+=size_of_char(c);
   }
   return   n;
}

ptr  s_string(int narg,ptr env){
   Reg ptr *sfree,s;
   Uint n;
   Reg Uchar *p;
   n=char_stack_bytes(narg);
   if(n==0) return a_nullstr;
   s=makestring(n);
   p=get_string(s,&n);
   sfree=stack-narg;
  while(narg--){
       n=CHAR_CODE(*sfree++);
       p=set_char(n,p);
       if(n<256) *p++=n;
       else
              p=set_char(n,p);
   }
   return   s;
}

int char_list_bytes(ptr x)  /*** x is char list, then   count bytes ***/
{
  Reg int n=0,c;
   while(CONSP(x)){
       c=CHAR_CODE(CAR(x));
       n+=size_of_char(c);
       x=CDR(x);
   }
   return   n;
}

ptr s_list_to_string(int narg,ptr env){
   Reg ptr x,s;
   Uint n;
   Uchar *p;
   x=*(stack-1);
   checknarg(--narg);
   n=char_list_bytes(x);
   s=makestring(n);
   p=get_string(s,&n);
 /**  printf("list->string  x %x n %d p %x", x,n,p);
 prin1(x,STDOUT);
  **/
   while(CONSP(x)){
       n=CHAR_CODE(CAR(x));
       if(n<256) *p++=n;
       else
           p=set_char(n,p);
     /*** printf("list->string  c  %c %d ", n,n); **/
       x=CDR(x);
   }
   return   s;
}


Uchar * jindex(Uchar *p,int ind, int len){
  if(kanji_mode==3)
     return  jindex_utf(p,ind, len);
  else
     return  jindex_euc(p,ind, len);
}

Uchar *jindex_euc(Uchar *p,int ind, int len)
{
  Uchar b;
   while(1){
    /*** printf("ind %d len %d\n",ind,len); ***/
    if(len<0) return (Uchar *)(-1);  /*** Err **/
    if(ind==0) return p;
    b=*p++;
    len--;
    if(euc_code(b,*p)){
           p++;
           len--;
     }
    ind--;
  }
}

Uchar * jindex_utf(Uchar *p,int ind, int len)
{
  Uchar b;
  int by;
  while(1){
    /*** printf("ind %d len %d\n",ind,len); ***/
    if(len<0) return (Uchar *)(-1);  /*** Err **/
    if(ind==0) return p;
    b=*p++;
    len--;
    by=utf8_first(b); /**  0,2,3,4 **/
    if(by){
           by--;
           p+=by;
           len-=by;
     }
    ind--;
  }
}

/***  len is simple bytes  ***/
int jstrlength(Uchar *p,int len){
  if(kanji_mode==3) 
   return jstrlength_utf(p,len);
  else
   return jstrlength_euc(p,len);
}

int jstrlength_euc(Uchar *p,int len)
{
  int j=0;
  Uchar b;
  while(1){
    if(len==0) return j;
    if(len<0) return -1;  /*** Err  not J-string**/
    b=*p++;
    len--;
    j++; 
    if(euc_code(b,*p)){
           p++;
           len--;
     }
  }
}

int jstrlength_utf(Uchar *p,int len)
{
  int j=0,by;
  Uchar b;
  while(1){
    if(len==0) return j;
    if(len<0) return -1;  /*** Err  not J-string**/
    b=*p++;
    len--;
    j++;
    by=utf8_first(b);
    if(by){
        by--;
           p+=by;
           len-=by;
     }
  }
}

int jstr_length(ptr str)
{
 int k;
  unsigned int j;
  Uchar *p;
  p=get_string(str,&j);
  k=jstrlength(p,j);
  if(k<0) k=j;
  return k;
}

ptr s_string_length(int narg,ptr env)
{
  unsigned int j;
  ptr str=*(stack-1);
 checknarg(--narg);
  if (SREGP(str)||!STRINGP(str)) error(E_notstr, str);
  if(kanji_mode)
        j=jstr_length(str);
   else
        get_string(str,&j);
  return MAKESINT(j);
}

ptr s_string_byte_length(int narg,ptr env)
{
  unsigned int j;
  ptr str=*(stack-1);
 checknarg(--narg);
  if (SREGP(str)||!STRINGP(str)) error(E_notstr, str);
  get_string(str,&j);
  return MAKESINT(j);
}

ptr s_string_list(int narg,ptr env)
{
  ptr str=*(stack-1),res=a_nil;
 checknarg(--narg);
  if (SREGP(str)||!STRINGP(str)) error(E_notstr, str);
  if(kanji_mode) {
     res=jstring_list(str);
     if(res!=a_f) return res;
  }
  return string_list(str);
}

ptr s_string_byte_list(int narg,ptr env)
{
  int j;
  ptr str=*(stack-1),res=a_nil;
 checknarg(--narg);
  if (SREGP(str)||!STRINGP(str)) error(E_notstr, str);
  return string_list(str);
}

ptr string_list(ptr str)
{
  ptr res=a_nil;
  Uchar *p;
  unsigned int j;

  p=get_string(str,&j);
  if(j==0) return a_nil;
  res=CONS(res,res);
  psh(res);
  while(j--){
     res=CDR(res)=CONS(MAKECHAR(*p++),a_nil);
  }
  res=*pull();
  return CDR(res);
}

Uchar *jnext(Uchar *p,ptr *ch)
{
  Uint b,by;
  b=*p++;
  if(kanji_mode==3){ /** utf8 **/
    by=utf8_first(b); /** 0,2,3,4 **/
    switch(by){
      case 0: break;
      case 4: b=(b<<8)+*p++;
      case 3: b=(b<<8)+*p++;
      case 2: b=(b<<8)+*p++;
    }
   }
  else if(euc_code(b,*p)){
        b=(b<<8)+*p++;
    }
  else
     ;
  *ch=MAKECHAR(b);
  return p;
}
 
ptr jstring_list(ptr str)
{
  int k;
  unsigned int j;
  ptr res=a_nil,ch;
  Uchar *p;
  p=get_string(str,&j);
  if(j==0) return a_nil;
  k=jstrlength(p,j);
  if(k<0)
      return a_f;  /*** Not J-string ***/
   res=CONS(res,res); 
  psh(res);
  while(k--){
     p=jnext(p,&ch);
     res=CDR(res)=CONS(ch,a_nil);
  }
  res=*pull();
 return CDR(res);
}

ptr s_substring(int narg,ptr env)
{
  int index,end=-1,kmode=kanji_mode,shift;
  unsigned int k;
  ptr str,new,*base,start,endp;
  Uchar *p,*q,*r;
  base=stack-narg;
  if((narg<3)||(narg>5) )
   checknarg(narg-5);
  str=*base++;
  if (SREGP(str)||!STRINGP(str)) error(E_notstr,str);
   p=get_string(str,&k);
  if(narg>3) {   /***  :end used ***/
    if(kmode){
        end=jstrlength(p,k);
          if(end==-1) {
               end=k;
               kmode=0;
          }
       }
     else
        end=k;
 }
  start=*base++;
  narg-=2;
  if(SINTP(start))
     index=GETNUM(start);
  else if(start==k_end){
     index=end;
     if(SINTP(*base)) {
         index+=GETNUM(*base++);
         narg--;
     }
 }
 else
       error(E_range,start);
  endp=*base++;
  narg--;
  if(SINTP(endp))
        end=GETNUM(endp);
  else if(endp==k_end){
    if(end==-1){
       if(kmode){
         end=jstrlength(p,k);
          if(end==-1) {
               end=k;
               kmode=0;
          }
       }
     else
        end=k;
     }
 }
 else
       error(E_range,endp);
  if(narg>0)
       end+=GETNUM(*base);

  if (index < 0) error(E_range,start);
  if (end<index ) error(E_range,endp);
  if(end==index) return a_nullstr;
   if(kmode) return j_substring(p,k,index,end);
/***  not kanji ***/
    q=p+index;
    r=p+end;
   new=makestring(end-index);  /***  may be gbc occur  **/
   p=get_string(new,&k);
  while(q<r)
     *p++=*q++;
   return new;

}

ptr j_substring(Uchar *p,unsigned int k,int index,int end)  /** k=size i, index<end ***/
{
  Uchar *q,*r;
  ptr new;
     r=p+k;
     q=jindex(p,index,k);
    if((q==r)||(q==(Uchar *)-1)){
        error(E_range,MAKESINT(index));
    } 
      r=jindex(p,end,k);
    if(r==(Uchar *)-1){
         error(E_range,MAKESINT(end));
    }
   new=makestring(r-q);  /***  may be gbc occur  **/
   p=get_string(new,&k);
  while(q<r)
     *p++=*q++;
   return new;
}

ptr string_ref(ptr str,int index)
{
  Uint k,by;
  Uchar *p,*q;
  ptr cha;
   p=get_string(str,&k);
   if(!kanji_mode){
      if(index>=k) error(E_range,MAKESINT(index));
      return MAKECHAR(*(p+index));
   }
     q=jindex(p,index,k);
    if((q==p+k)||(q==(Uchar *)-1)){
        return error(E_range,MAKESINT(index));
    }
   else{
     jnext(q,&cha);
      return  cha;
   }
}

ptr s_string_ref(int narg,ptr env)
{
  int index,k;
  ptr str;
  Uchar *p,*q;
  checknarg(narg-2);
  str=*(stack-2);
  index=GETNUM(*(stack-1));
  if (SREGP(str)||!STRINGP(str)) error(E_notstr,str);
  if (index < 0) error(E_range,*(stack-1));
   return string_ref(str,index);
}

ptr s_string_set(int narg,ptr env)
{
  int index,by;
  Uint  k,j,s;
  ptr str,value;
  Uchar *p,*q;
  checknarg(narg-3);
  str=*(stack-3);
  index=GETNUM(*(stack-2));
  if (SREGP(str)||!STRINGP(str)) error(E_notstr,str);
  if (index < 0) error(E_range,*(stack-1));
  value=*(stack-1);
  if(!CHARP(value)) error(E_notchar,value);
    j=CHAR_CODE(value);
     p=get_string(str,&s);
   if(kanji_mode) return j_string_set(p,s,index,j);
   if(index>=s) goto err;
    q=p+index;
   if(j<256){
        *q=j;
   }
   else{ 
        /*** not kanji-mode but given is multi-byte **/
       by=size_of_char(j);  // 2,3,4
       if(q>=(p+s+1-by)) goto err;
       set_char_b(j,q,by);
    }
   return a_undef;
  err:
   return error(E_range,MAKESINT(index));
}

/*** the following cause some problems, so
 will need a change of alloc in string
***/
ptr j_string_set(Uchar *p,int len,int index,Uint j)
{
  Uchar *q;
  int by;
     q=jindex(p,index,len);
    if(((long)q==-1)||(q==p+len)){
         error(E_range,MAKESINT(index));
         /** *(p+index)=j; ***/
     }
    if(j>255){
          by=size_of_char(j); // 2,3,4
             if(q+by>p+len) goto err;
          set_char_b(j,q,by);  //over write may be broken utf-8-char
      }
    else   //   j is ascii
     {
      if(kanji_mode==3){
         by=utf8_first(*q);
         if(by==0) by=1;
          *q++=j;
          by--;
         while(by>0){
             if(q>=p+len) goto err;
            *q++='!';
            by--;
          }
       }
      else if(euc_first(*q)){
            *q++=j;
            *q='!';
       }
      else
        *q=j;
     }
  return a_undef;
err:
   return error(E_range,MAKESINT(index));
}

int STRLEN(ptr p){
unsigned int n;
 get_string(p,&n);
return n;
} 


/*** 04.4.24    ss  Bonus ***/
/***  (string-index s1 s2)   find s1 in s2 and return index ***/
static ptr jstring_index(Uchar *p,int k,Uchar *q,int j,int ci)
{
  Uchar *r;
   int index=0;
  while(1){
    if(ci){
      if(scm_strcmp_ci(p,q,k)) return MAKESINT(index);
     }
    else
         if(scm_strcmp(p,q,k)) return MAKESINT(index);
    r=jindex(q,1,j);
    if((long)r==-1) return a_f;
    j=j-(r-q);
    q=r;
    index++;
   if(j<k) return a_f;
 }
}

ptr s_string_index(int narg,ptr env)
{
  int index;
  unsigned int k,j,ci=0;
  ptr s1,s2;
  Uchar *p,*q;
  if(narg==3) {
     if(*(stack-1)!=k_nocase) error(E_keyword,*(stack-1));
     ci=1;
     s1=*(stack-3);
     s2=*(stack-2);
  }
  else if(narg==2){   
     s1=*(stack-2);
     s2=*(stack-1);
  }
  else
     checknarg(narg-2);
  if (SREGP(s1)||!STRINGP(s1)) error(E_notstr,s1);
  if (SREGP(s2)||!STRINGP(s2)) error(E_notstr,s2);
   p=get_string(s1,&k);
   q=get_string(s2,&j);
  index=0;
  if (k>j) return a_f;
   if(kanji_mode) return jstring_index(p,k,q,j,ci);
  while(1){
    if(ci){
      if(scm_strcmp_ci(p,q,k)) return MAKESINT(index);
     }
    else
         if(scm_strcmp(p,q,k)) return MAKESINT(index);
    q++;
    j--;
    index++;
   if(j<k) return a_f;
 } 
}

static ptr jstring_rindex(Uchar *p,int k,Uchar *q,int j,int ci)
{
   int index=0;
   int memo=-1;
  Uchar *r;
  while(1){
    /** printf("%s %s %d %d %d %d\n",p,q,k,j,index,memo);***/
    if(ci){
      if(scm_strcmp_ci(p,q,k)) memo=index;
     }
    else
         if(scm_strcmp(p,q,k)) memo=index;
    r=jindex(q,1,j);
    if(r==(Uchar *)-1) break;
    j=j-(r-q);
    q=r;
    index++;
   if(j<k) break;
 }
  if(memo==-1) return a_f;
return MAKESINT(memo);
}

/***  (string-rindex s1 s2)   find s1 in s2 from last and return index ***/
ptr s_string_rindex(int narg,ptr env)
{
  int index;
  unsigned int k,j,ci=0;
  ptr s1,s2;
  Uchar *p,*q;
  if(narg==3) {
     if(*(stack-1)!=k_nocase) error(E_keyword,*(stack-1));
     ci=1;
     s1=*(stack-3);
     s2=*(stack-2);
  }
  else if(narg==2){
     s1=*(stack-2);
     s2=*(stack-1);
  }
  else
     checknarg(narg-2);
  if (SREGP(s1)||!STRINGP(s1)) error(E_notstr,s1);
  if (SREGP(s2)||!STRINGP(s2)) error(E_notstr,s2);
   p=get_string(s1,&k);
   q=get_string(s2,&j);
   if(kanji_mode) return jstring_rindex(p,k,q,j,ci);
  index=j-k;
  q=q+j-k;
  if (k>j) return a_f;
  while(1){
    if(ci){
        if(scm_strcmp_ci(p,q,k)) return MAKESINT(index);
     }   
    else
           if(scm_strcmp(p,q,k)) return MAKESINT(index);
    q--;
    j--;
    index--;
   if(j<k) return a_f;
 }
}



/****  from stream.c   hakaiteki,   NOT return str ***/
Uchar *extend_str(ptr str,unsigned int n){
  ptr sp,new;
  unsigned int m;
  Uchar *p,*q,*r;
      m=(n+8)&0xfffffff8;  /*** 8*  32bit ***/
       p=get_string(str,&n);
       q=Myrealloc(p,m);
       CAR(str)=(ptr)q;
       //CDR(str)=(ptr)MAKESINT(m);
       SETSTRLOC(str,m);
       m=get_alloc_bytes(q);  // heap.c
      /*** printf("*** str ext**** m %d   n %d\n",m,n);  ***/
       EXATTR(str)=m;
        return q;
 }


