/*** syntax.c
        syntax data
        for syntax  V2.0
      2010.7.31  
 ****/

#include "lisp.h"
#define SYNTAXP(x)  (ATTR(x)&SYNTAX)

extern ptr error();

/***
check_syntax(ptr x){
  if(SREGP(x)||!SYNTAXP(x)) error(E_notsyntax,x);
}
***/

ptr  make_syntax(ptr x,int syntax){
   /** if(SREGP(x)) error(E_illegal,x); **/
   if(TYPE(x)&&!CLOSUREP(x))error(E_illegal,x);
   ATTR(x)|=syntax;   /*** x is a list or lambda ***/
   if(CLOSUREP(x)){
      //FTYPE(x)=(ptr)SYNTAXLAMBDA;
      EXATTR(x)|=SYNTAXLAMBDA; //need?
   }
   return x;
}
ptr  off_syntax(ptr x){
   ATTR(x)&=~SYNTAX;
  return x;
}

ptr s_make_syntax(int narg,ptr env){ 
   ptr x;
     checknarg(narg-1);
     x=*(stack-1);
    if(SREGP(x)) return x;
    return make_syntax(x,SYNTAX);
  }
ptr s_make_syntaxsymbol(int narg,ptr env){
   ptr x;
     checknarg(narg-1);
     x=*(stack-1);
    if(SREGP(x)) return x;
    return make_syntax(x,SYNTAXSYMBOL);
  }


ptr s_off_syntax(int narg,ptr env){ 
   ptr x;
     checknarg(narg-1);
     x=*(stack-1);
    if(SREGP(x)) return x;
    return off_syntax(x);
}

ptr s_syntax_pred(int narg,ptr env){ 
   ptr x;
     checknarg(narg-1);
     x=*(stack-1);
    if(SREGP(x)) return a_f;
    return PRED(ATTR(x)&SYNTAX);
}
ptr s_syntax_lambda(int narg,ptr env){ 
   ptr x;
     checknarg(narg-1);
     x=*(stack-1);
    if(SREGP(x)) return a_f;
    return PRED(ATTR(x)==SYNTAXLAMBDA);
}
ptr s_syntax_symbol(int narg,ptr env){
   ptr x;
     checknarg(narg-1);
     x=*(stack-1);
    if(SREGP(x)) return a_f;
    return PRED(ATTR(x)==SYNTAXSYMBOL);
}


ptr s_syntax_car(int narg,ptr env){ 
  ptr x;
  int n;
     checknarg(narg-1);
     x=*(stack-1);
  if(SREGP(x)) error(E_notsyntax,x);
   n=ATTR(x);
  if((n&SYNTAX)&&(n!=SYNTAXLAMBDA))
     return CAR(x);
  return error(E_notsyntax,x);
}

ptr s_syntax_cdr(int narg,ptr env){
  ptr x;
  int n;
     checknarg(narg-1);
     x=*(stack-1);
  if(SREGP(x)) error(E_notsyntax,x);
   n=ATTR(x);
  if((n&SYNTAX)&&(n!=SYNTAXLAMBDA)) 
     return CDR(x);
  return error(E_notsyntax,x);
}

ptr s_syntax_single_p(int narg,ptr env){
  ptr x;
  int n;
     checknarg(narg-1);
     x=*(stack-1);
  if(SREGP(x)) error(E_notsyntax,x);
   n=ATTR(x);
  if((n&SYNTAX)&&(n==SYNTAXLAMBDA)){
    //n=(long)FTYPE(x);
      n=EXATTR(x);
     if(n&NOTSINGLE)
       return PRED((n&SINGLE)^NOTSINGLE);
     else
       return a_undef;
   }
     return a_f;
}
ptr s_syntax_single(int narg,ptr env){
  ptr x,flag;
  int n,k;
     checknarg(narg-2);
     x=*(stack-2);
  if(SREGP(x)) error(E_notsyntax,x);
   n=ATTR(x);
  if(n&SYNTAX){
     if(n==SYNTAXLAMBDA){
      flag=*(stack-1);
      //k=(long)FTYPE(x);
       k=EXATTR(x);
      if(flag==a_t)
        EXATTR(x)=(long)(k|SINGLE);
        //FTYPE(x)=(ptr)(long)(k|SINGLE);
      else
        EXATTR(x)=(long)(k|NOTSINGLE);
        //FTYPE(x)=(ptr)(long)(k|NOTSINGLE);
      return a_t;
     }
    return a_f;
   }
  return error(E_notsyntax,x);
}


