/***   vm.c
   SS ver2.0  
   2007.9.15
   see vm-boot2.ss
   2010.5.4  revised
   2010.5.30  SCM,VPC are MACRO
   2010.6.1  MPU  stack version
      but Not speed up at boot
   2010.6.13  JMP change
   2010.8.13  JMP no change!    difficult debug!
   2010.8.26   SR2MACRO    deleted!
   2019.12.27  debug
***/
#define VM_C

#include "lisp.h"
#include <stdlib.h>
#include <setjmp.h>
#include <signal.h>
#include <stdio.h>

extern   ptr assq();
extern ptr reverse_list();
extern ptr k_LB,k_T,a_sys_env;
extern ptr final(),s_vm_compile(),vm_compile();
extern jmp_buf user_env[];
extern int verbose_mode;
extern void trace_var_cmds(ptr);
extern void trace_in(ptr,ptr);
extern void trace_out(ptr,ptr);
extern void ss_update(void);
extern void line_history(void);
extern void print_his(int);
extern int buffer_white(void);
extern void long_jmp(int ,int );
extern int gbc_verbos;


/** extern int _length();  **/
extern int nc_length();   /***  No check length ***/
#define LENGTH(p)   (nc_length(p))  /** May be change ***/

void error_top(ptr);

int input_flag=0;
/*** int input_line=0;  *** mc.c in 1.99 ***/
/***  ptr VPC;   ** main PC register ***/
          /****  a list version  ***/

extern int silent_mode;

#define RETURN_NUM 16   /*** op number  ***/
#define CLOSURE_ENV_NUM 17   /*** op number  ***/

 ptr SYSREG[16]={NULL};    /*** gbc must protect!!!  **/
#define VPUSH(x)  (*mpu_stack++=(x))
#define VPULL()   (*--mpu_stack)

//#define TRACEP(f)   ((int)FTYPE(f)&TRACE) 
#define TRACEP(f)   (EXATTR(f)&TRACE) 


ptr  SCM;
/** #define ST SYSREG[1]  **/
ptr ST;
/*** #define BA SYSREG[2]  **/
ptr BA;
/*** #define MULTIVAL SYSREG[3] **/
ptr MULTIVAL;
/*** #define VMENV SYSREG[4] ***/
ptr VMENV;
/** #define ARGS SYSREG[5] ***/
ptr ARGS;
/** #define VPC SYSREG[6]  **/
ptr VPC;
/** #define PCST SYSREG[7] **/
#define PCST (mpu_stack-1)

#define MULTICLEAR MULTIVAL=a_undef

int vmdeb;   /**** for debug of VM ***/

int NARG;

/*** int evalflag;    eval can't define   ***/
void print_SCM();

static ptr *mcprint();
//static ptr make_lambda(), make_macro();

static void Reg_Push(),Reg_Pull(),Pull_PCST(),VLOAD(),VSET(),
    VMIMM(), IMM_undef(),IMM_t(),IMM_f(),IMM_null(),
    IMM_0(),IMM_1(),
     LOADENV(),SETENV(),
     MAKE_LAMBDA(),
    MAKE_MACRO(),DEFINE(),BIND(),IF_SCM_BA(),JMP2(),FALSE2(),TRUE2(),
    LAMBDA_BIND(),
    FUNC(),
    PUSHARG(),
    VJSR(),TAIL_JMP(),
    RETURN(),
    CLOSURE_ENV(),
    LAMBDA_ARGS(),
    Push_ENV(),Pull_ENV(),Push_ARGS(),
    TRUE2(),Pull_reg(),
    SCM_MULTI(),MULTI_SCM(),SCM_BA(),BA_SCM(),SCM_ST(),SCM_ARGS(),
    ST_SCM(),COPY_CC(),RESTORE_BA(),RESTORE_CC(),LAMBDA_LAST(),ENV_SCM(),ENVLOAD(),SCM_ENV();

//  48 op
static void (* VMOP[])()={
VLOAD,VSET,VMIMM, LOADENV,SETENV,
MAKE_LAMBDA, MAKE_MACRO,DEFINE,BIND,JMP2,
FALSE2,LAMBDA_BIND, FUNC,PUSHARG,VJSR,
TAIL_JMP,RETURN,CLOSURE_ENV,LAMBDA_ARGS,TRUE2,
  SCM_MULTI,MULTI_SCM,SCM_BA,BA_SCM,SCM_ST,
  SCM_ARGS, ST_SCM,COPY_CC,RESTORE_CC,IMM_undef,
  IMM_t,IMM_f,IMM_null,IMM_0,IMM_1,
  Push_ENV,Pull_ENV,Pull_reg,Pull_PCST,Push_ARGS,
VMIMM,VMIMM,VMIMM,VMIMM   /*** dummy   never appear ***/
,LAMBDA_LAST,ENV_SCM,ENVLOAD,SCM_ENV
   };

ptr VM(ptr);
void DO_VM(ptr);
extern void init_vmcomp();
static ptr return_tail;

void init_VM(){
  ptr *st=SYSREG,s;
  int i;
  /** for(i=0;i<8;i++) *(st+i)=a_nil;  **/
 
   BA=CONS(a_f,a_nil);  /***  BA=(#f)  ***/
   MULTIVAL=a_undef;
   VMENV=a_nil;
   SCM=a_nil;

  init_vmcomp(st);
  mpu_stack=MPU;
  s=MAKESINT(RETURN_NUM);
  s=CONS(s,a_nil);
  s=SCONS(s,a_nil);
  VPUSH(s);  /*** ((16)) ==((RETURN))  ***/
  return_tail=s;  /*** for trace to tail  ***/
}

/**** clearenv   ***/
ptr  call_vm(ptr pc,ptr env){
   ptr s;
/***
   PRINT("CALL-VM: "); 
  prin1(env,STDOUT);
  newline(STDOUT);
***/
  VPUSH(SCM);
  VPUSH(VPC);
  VPUSH(VMENV);
  VPUSH(ARGS);
  VMENV=env;
  /** VPC=a_nil;  ** for immedidatly return  2010.5.17  ***/
  VM(pc);
  s=SCM;
  ARGS=VPULL(); 
  VMENV=VPULL(); 
  VPC=VPULL(); 
  SCM=VPULL(); 
  return s;
}
  
ptr s_call_vm(int narg,ptr env){
 ptr ev;
  if(narg==1) ev=a_nil;  /*** clearenv ***/
  else if(narg==2) ev=*(stack-1);       /*** to be modify  ***/
  else {
      error(E_argover,*(stack-1));
  }
  return call_vm(*(stack-narg),ev);
}

//Debug
int checkpc(ptr p){
  ptr x,q;
  while(p!=a_nil){
    x=CAR(p);
    q=CAR(x);
     if(!SINTP(q)){
         return 1;  //Abnormal
     }
   p=CDR(p);
  }
 return 0;  //OK
}

ptr VM(ptr pc){
  Reg ptr x,q;
  Reg int n;
  // ptr z=pc;  //   debug
/***
   PRINT("VM: ");
   prin1(pc,STDOUT);
***/ 
  /** while(CONSP(pc)){ **/
 //psh(pc);  // debug or need?->  no effect
  while(pc!=a_nil){  
  /***
     if(checkpc(pc)){
         error(E_illegal,q);
     }
  ***/
    x=CAR(pc);
/***
   PRINT("DO-VM: ");
   prin1(x,STDOUT);
   newline(STDOUT);
***/
   psh(pc);// Debug No effect!
    VPC=CDR(pc);
   /***  DO_VM(x);  ***/
     q=CAR(x);
     if(!SINTP(q)){
         error(E_vm,x);
     }
  n=GETNUM(q);
  (* VMOP[n])(CDR(x));
   pull();//Debug
    pc=VPC;
  }
// pull();  
 return SCM;
} 
      
void DO_VM(ptr x){
  int n;
  if(x==a_nil){
    fatal_error(999,VPC);
    printf("VM System error\n");
    exit(999); 
  }
  n=GETNUM(CAR(x));
  (* VMOP[n])(CDR(x));
}

   /***  Not used  ***/
/***
void Reg_Push(ptr x)
{
  int n;
  n=GETNUM(CAR(x));
  VPUSH(*(SYSREG+n));
}
***/
void Push_ENV(ptr x){
  VPUSH(VMENV);
}
void Push_ARGS(ptr x){
  VPUSH(ARGS);
}

   /***  Not used , but in table  ***/
void Pull_reg(ptr x)
{
  int n;
  n=GETNUM(CAR(x));
//  *(SYSREG+n)=VPULL();
}

void Pull_ENV(ptr x){
VMENV=VPULL();
}

void Pull_PCST(ptr x)
{
  int n;
  ptr pc;
  n=GETNUM(CAR(x));
 mpu_stack-=n;
/**** 
  pc=PCST;
    while(n>0){
   pc=CDR(pc);
   n--;
  }
  PCST=pc;
 ***/
}

void VLOAD(ptr x)
{
/***
  PRINT("LOAD ");
  prin1(x,STDOUT);
  newline(STDOUT);
***/
  x=CAR(x);
  #ifdef USE_TK
  SCM=load_top(x);   /*** see var.c  tklink need  2010.5.30 ***/
  #else
  SCM=SVAL(x);
  if(SCM==a_unbdd) error(E_unbdd,x);
 #endif
  /***  val=ATOMVAL(s);  ***/
      /***  psh_his(list2(s,val));   ** variable  history **/
  /*** if(val==a_unbdd) error(E_unbdd,CAR(x));  ***/
  MULTICLEAR;
}
void VSET(ptr x)
{
  x=CAR(x);
  /*** ATOMVAL(s)=SCM;  ***/
     M_top_value_set(x,SCM); /*** see intern.c for trace ***/
}

void VMIMM(ptr x)
{
  SCM=CAR(x);
  // MULTIVAL=a_undef;
  MULTICLEAR;
}

void IMM_undef(ptr x)
{
  SCM=a_undef;
  //MULTIVAL=a_undef;
  MULTICLEAR;
}
void IMM_t(ptr x)
{
  SCM=a_t;
  //MULTIVAL=a_undef;
  MULTICLEAR;
}
void IMM_f(ptr x)
{
  SCM=a_f;
  //MULTIVAL=a_undef;
  MULTICLEAR;
}
void IMM_null(ptr x)
{
  SCM=a_nil;
  MULTICLEAR;
  //MULTIVAL=a_undef;
}
void IMM_0(ptr x)
{
  SCM=ZERO;
  MULTICLEAR;
  //MULTIVAL=a_undef;
}
void IMM_1(ptr x)
{
  SCM=ONE;
  MULTICLEAR;
 // MULTIVAL=a_undef;
}


void LOADENV(ptr x)
{
  x=CAR(x);
/***
  prin1(s,STDOUT);
  PRINT(" LOADENV ");
***/
  SCM=CDR(assq(x,VMENV));
  /****
  if(val==a_f){
       PRINT("Env variable Not bind");
       newline(STDOUT);
       error(E_unbdd,x);
   }
  ***/
  /***  SCM=CDR(val);  ***/
       /*** psh_his(list2(s,val));    variable  history **/
/****
  prin1(SCM,STDOUT);
  newline(STDOUT);
***/
  //MULTIVAL=a_undef;
}

void SETENV(ptr x)
{
 ptr s,trace;
  s=CAR(x);
  x=assq(s,VMENV);
  /*** if(x==a_f) error(E_system,s);***/
  CDR(x)=SCM;
  trace=ATOMVAL(a_tracevars);
  if(trace!=a_nil){
      trace=assq(s,trace);
      if(trace!=a_f) { 
        PRINT("trace ENV var:");
        trace_var_cmds(CDR(trace));
      }
  }
}

/****  for SYSMACRO V5  ***/
/***  (ENVLOAD var key)   ***/
void ENVLOAD(ptr x)
{
  ptr key,env;
  key=CADR(x);
  x=CAR(x);
/***
  prin1(s,STDOUT);
  PRINT(" LOADENV ");
***/
  env=assq(key,ATOMVAL(a_sys_env));
/***
     newline(STDOUT);
  prin1(a_sys_env,STDOUT);
  prin1(key,STDOUT);
  PRINT(" ENVLOAD ");
  prin1(env,STDOUT);
****/
  if(env!=a_f) env=assq(x,CDR(env));
  if(env==a_f){
     /*** SCM=load_top(x);  *** see var.c  tklink need  2010.5.30 ***/
      SCM=a_f;
      return;   /*** fail in r5rs , special are not in r5rs **/
  }
  SCM=CDR(env);
  return;
  //MULTIVAL=a_undef;
}
/***  SR2 only
  ((k_LB . args)) (17 VMENV) . sr-list)
  (FENV . FBODY)
  and attr, exattr ==SR2  attr may be SYNTAXLAMBDA
***/
static void MAKE_CLOSURE(ptr x,int attr)
{
  ptr s,p,args;
  MULTICLEAR;
  s=CAR(x);
  args=CAR(s); /*** (LAMBDA-ARGS ...)  ***/
  args=CADR(args);
  s=CDR(s);
  p=CONS(VMENV,a_nil);
  psh(p);
  p=CONS(MAKESINT(CLOSURE_ENV_NUM),p);   /** 17 is CLOSURE-ENV  **/
  *(stack-1)=p;
  p=CONS(p,s);
  *(stack-1)=p;
  p=CONS(a_nil,p); 
  *(stack-1)=p;
  SCM=p;  /* save **/
  s=CONS(k_LB,args);
  *(stack-1)=s;
  s=CONS(s,a_nil);
  CAR(p)=s;  //FENVnew
  ATTR(p)=attr;   /***  Ver2.0  **/
  EXATTR(p)=SR2;   /***  Ver2.18  **/
  pull();
}

void MAKE_LAMBDA(ptr x){
   MAKE_CLOSURE(x,SR2);
}
void MAKE_MACRO(ptr x)
{
 /**　 MAKE_CLOSURE(x,SR2MACRO);     Now not used, but still in table ***/
}
void DEFINE(ptr x)
{
  ptr var,scm,env;
  var=CAR(x);
  scm=SCM;
  if(ATOMVAL(var)==a_unbdd)
      ATOMVAL(var)=scm; /*** Caution!!!  Modify for TK  ***/
  else
     M_top_value_set(var,scm); /*** see intern.c  ***/
    if(!SREGP(scm)&&CLOSUREP(scm)){
       if(ATTR(scm)&SRFUNC){  //SR2, SYNTAXLAMBDA
           env=FENV(scm);
           x=CONS(k_T,var);
           FENV(scm)=SCONS(x,env);
        }
    }
   /** SCM=var;  ***/
}

void BIND(ptr x)
{
  x=CAR(x);
  x=CONS(x,SCM);
  VMENV=SCONS(x,VMENV);
}

void VM_JMP(int n){
  ptr pc;
  pc=VPC;
  while(n-->0){
   pc=CDR(pc);
  }
 VPC=pc;
}
   

void JMP2(ptr x)
{
 /****
  Reg ptr y;
    y=CAR(x);
    if(SREGP(y)){
        VM_JMP(GETNUM(y));
        CAR(x)=VPC;
    }
    else
       VPC=y;
   ***/
   VM_JMP(GETNUM(CAR(x))); 
}

void FALSE2(ptr x)
{
  Reg ptr y;
  if(SCM==a_f){
   /****
       y=CAR(x);
    if(SREGP(y)){
        VM_JMP(GETNUM(y));
        CAR(x)=VPC;
    }
    else
       VPC=y;
    ****/
     VM_JMP(GETNUM(CAR(x)));  
  }
}

void TRUE2(ptr x)
{
  Reg ptr y;
  if(SCM!=a_f){
    /***
   y=CAR(x);
    if(SREGP(y)){
        VM_JMP(GETNUM(y));
        CAR(x)=VPC;
    }
    else
       VPC=y;
     ***/
     VM_JMP(GETNUM(CAR(x)));  
  }
}

void LAMBDA_BIND(ptr x)
{
  ptr s;
  s=CAR(x);
 
  if(CONSP(s)){
     //SCM=ARGS;
     s=CONS(CAR(s),ARGS);
     VMENV=SCONS(s,VMENV);
     ARGS=a_nil;
  }
  else{
    x=ARGS;
    if(x==a_nil)  error(E_shortarg,s);
  //  SCM=CAR(x); 
    s=CONS(s,CAR(x));
    ARGS=CDR(x);
     VMENV=SCONS(s,VMENV);
   }
}
void LAMBDA_LAST(ptr x)
{
  ptr s;
  s=CAR(x);

  if(CONSP(s)){
     SCM=ARGS;
     s=CONS(CAR(s),ARGS);
     VMENV=SCONS(s,VMENV);
     ARGS=a_nil;
  }
  else{
    x=ARGS;
    if(x==a_nil) error(E_shortarg,s);
     SCM=CAR(x);
    s=CONS(s,SCM);
    ARGS=CDR(x);
     VMENV=SCONS(s,VMENV);
    if(ARGS!=a_nil) {
          x=ARGS;
          ARGS=a_nil;
         error(E_argover,x);
         }
   }
}

void FUNC(ptr x)
{
   x=CAR(x);  /*** tail-f  **/
  if(x==a_f){
       VPUSH(VMENV);
       VPUSH(ARGS);
   }
  /*** VPUSH(SCM);   F-object  V2.2  **/
 // MULTIVAL=a_undef;
  ARGS=a_nil;
}

void PUSHARG(ptr x)  /*** PUSH in vm.ss  ***/
{
  ARGS=CONS(SCM,ARGS);
}


void ARGS2stack(ptr args,int n)
{
  while(n-->0){
   *stack++=CAR(args);
   args=CDR(args);
  }
}
void stack2args(int n){
   ptr s=a_nil;
   int k=1;
   NARG=n;
   while(n>0){
     s=SCONS(*(stack-k),s);
     n--;
     k++;
   }
  ARGS=s;
}

ptr sr2_funcall(ptr func,int nar){
   /****  func is sr2 ***/
     /****
        PRINT("sr2_funcall");
        prin1(func,STDOUT);
        newline(STDOUT);
      ****/
       if(TRACEP(func)) trace_in(func,ARGS);
       VPUSH(VPC); /*** save  ***/
       VPUSH(VMENV);
       VPUSH(ARGS);
       VPUSH(func);  /*** for trace  ***/
       VPUSH(a_nil); /*** for immediately return ***/
       stack2args(nar);
       VM(FBODY(func));
       VPC=VPULL();
      return SCM; 
}       

ptr s_funbody(int narg,ptr env){
  ptr f;
  
   checknarg(narg-1);
   f=*(stack-1);
   if(SREGP(f)) return a_f;
   if(SYMBOLP(f)) f=ATOMVAL(f);
   if(SREGP(f)) return a_f;
   if(CLOSUREP(f)) return FBODY(f);
   return a_f;
}  

void VJSR(ptr x)  /*** JSR in vm.ss **/
{
  ptr s,st, (*addr)(),env;
  int attr,type,narg,ft;
  void func_error();
  // MULTIVAL=a_undef;
  /***  st=VPULL();  Func-object  ***/ 
   VPUSH(SCM); /*** V2.2  **/
   st=SCM; /*** Func-object , keep for trace  ***/ 
  VPUSH(VPC);
  if(SREGP(st)) func_error(st);
  /***   ARGS=reverse_list(ARGS);   ***/
  attr=ATTR(st);
  if(attr&CLOSURE){
       /*** psh_his(CDR(assq(k_T,FENV(st))));    Function history **/
       /*** psh_his(assq(k_T,FENV(st)));   ** Function history **/
       psh_his(FENV(st));   /*** Function history **/
   }
  else
      func_error(st);
  //ft=(int)FTYPE(st);   ***  CAR   see lisp.h  **
  ft=EXATTR(st);   /***  exattr   see lisp.h  ***/
  if(ft&TRACE)  trace_in(st,ARGS);  /*** trace.c  ***/
  if(attr==SR2||attr==SYNTAXLAMBDA){
      VPC=FBODY(st);  /***  CDDR st  ***/
      return;
    }
  /***
  else if(attr==SYNTAXLAMBDA){
      VPC=FBODY(st);  //  CDDR st
      return;
   }
  ***/
  //else if(ft&SUBR){     org
  else if(attr&SUBR){
       s=CAR(x);
       if(SINTP(s))
           NARG=GETNUM(s);
        else
           NARG=LENGTH(ARGS);
      addr=(ptr (* )() )FBODY(st);  // SUBR change!
      ARGS2stack(ARGS,NARG);
      env=FENV(st);
      narg=NARG;
      SCM=(*addr)(NARG,env);   /*** may be change NARG ***/
      stack-=narg;
/***
     PRINT("***  SYSTEM FUNCTION CALL ");
     prin1(st,STDOUT);
     newline(STDOUT);
   ***/ 
     RETURN(a_f);
     return;
  }
  else
     ;
}

void func_error(ptr st){
  /***
    PRINT("Null function call ARGS: ");
    prin1(ARGS,STDOUT);
    newline(STDOUT);
  ***/
    error(E_nullfunc,st);
}

void TAIL_JMP(ptr x)  /*** narg  level  **/
{
  ptr s,st, (*addr)(),env;
  int attr,type,narg,tr,ft;
   // MULTIVAL=a_undef;
  st=SCM; /*** Func-object V2.2  ***/ 
   /***
   s=CAR(x);
   if(SINTP(s))
      NARG=GETNUM(s);
   else
     NARG=_length(ARGS);
  ***/
  /** Pull_PCST(CDR(x));***/
   s=CADR(x);
   if(s!=ZERO){
    mpu_stack-=GETNUM(s);
   }
  /*** printf("TAIL: %x\n",st); **/
  if(SREGP(st)) func_error(st);
  attr=ATTR(st);
  // ft=(int)FTYPE(st);   **  CAR   see lisp.h  **
  ft=EXATTR(st);   /***  exattr   see lisp.h  ***/
  if((tr=(ft&TRACE)))  trace_in(st,ARGS);  /*** trace.c  ***/
  if(attr==SR2){
     if(tr){
        VPUSH(VMENV);
        VPUSH(ARGS);
        VPUSH(st);
        VPUSH(return_tail);
      } 
      VPC=FBODY(st);
    }
  else if(attr&SUBR){
        s=CAR(x);
        if(SINTP(s))
           NARG=GETNUM(s);
         else
           NARG=LENGTH(ARGS);
      addr=(ptr (*)())FBODY(st);
      ARGS2stack(ARGS,NARG);
      env=FENV(st);
      narg=NARG;
      SCM=(*addr)(NARG,env);
      stack-=narg;
      if(tr)  trace_out(st,SCM);  /*** trace.c  ***/
      RETURN(a_t);
  }
  else{
    func_error(st);
  /***
    printf("VM Not supports  sr(1.99) call *TAIL* attr=%x  st=%x\n",attr,st);
    prin1(st,STDOUT);
    printf("\n");
      RETURN(s);
   ***/
  }
}

void RETURN(ptr x){
   VPC=VPULL();   
   x=VPULL(); /*** Func, OBJ used for trace ***/
   ARGS=VPULL();   
   VMENV=VPULL();  
   if(TRACEP(x)) trace_out(x,SCM);
/*** 
   PRINT("** RETURN ** ");
   prin1(SCM,STDOUT);
   prin1(x,STDOUT);
   newline(STDOUT);
***/
}

void CLOSURE_ENV(ptr x){
   VMENV=CAR(x);
}

void LAMBDA_ARGS(ptr x){
   x=CAR(x);
   x=CONS(k_LB,x);   /*** :LAMBDA-BIND ****/
   VMENV=SCONS(x,VMENV);
}

void SCM_MULTI(ptr x){
   MULTIVAL=SCM;
   if(CONSP(SCM))
      SCM=CAR(SCM);
   else
      SCM=a_undef;  /***  if SCM==() else error ***/
}
void MULTI_SCM(ptr x){
   if(MULTIVAL!=a_undef)  /** 2010.8.29 **/
        SCM=MULTIVAL;
   else{  /***  must MULTI=(SCM)  ***/ 
       SCM=CONS(SCM,a_nil);
   }
   MULTIVAL=a_undef;
}

void SCM_BA(ptr x){
   BA=SCM;
}

void BA_SCM(ptr x){
   SCM=BA;
}

void SCM_ST(ptr x){
   ST=SCM;
}
/***
void SCM_ARGS(ptr x){
   ptr s,args;
  s=SCM;
  args=ARGS;
   while(CONSP(s)){
     args=SCONS(CAR(s),args);
     s=CDR(s);
   }
   SCM=s;
   ARGS=args;
}
***/
void SCM_ARGS(ptr x){
   ARGS=SCM;
}

void ST_SCM(ptr x){
   SCM=ST;
}
void ENV_SCM(ptr x){
   SCM=VMENV;
}
void SCM_ENV(ptr x){
   VMENV=SCM;
}
 
extern ptr getvector();
extern ptr *get_vector();

ptr get_pcst(){
   int n;
   ptr v,*p,*q;
   n=mpu_stack-MPU;
   v=makevector(n,ZERO);
   p=get_vector(v,&n);
   q=MPU;
   while(n--)
     *p++=*q++;
  return v;
}
void set_pcst(ptr v){
   int n;
   ptr *p,*q;
   p=get_vector(v,&n);
   q=MPU;
   while(n--)
     *q++=*p++;
   mpu_stack=q;
}

void COPY_CC(ptr x){    
   ptr s;
   s=CONS(VMENV,a_nil); 
   s=SCONS(ARGS,s); 
   s=SCONS(get_pcst(),s);
   s=SCONS(VPC,s);
   SCM=s;
}


void RESTORE_CC(ptr x){
  ptr s,v;
   s=SCM;
   VPC=CAR(s);
   s=CDR(s);
   v=CAR(s);  /** PCST  ***/
   set_pcst(v);
   s=CDR(s);
   ARGS=CAR(s);
   s=CDR(s);
   VMENV=CAR(s);
/***
  PRINT("RESTORE");
  prin1(VPC,STDOUT);
  newline(STDOUT);
****/
  if(CONSP(MULTIVAL))
    SCM=CAR(MULTIVAL);
  else
    SCM=a_undef;    /***  OK! undef means No-value!!!***/
}
/****  TOP  ***/
ptr s_TOP(int narg,ptr env){
  ptr p,m;
  ptr *memo;
  int n;
   if(verbose_mode){
        PRINT(" s_TOP enter ");
        newline(STDOUT);
   }
  psh(a_nil);
  input_flag=1;
  memo=stack;
  Errno=NULL;
   if(verbose_mode){
        PRINT(" s_TOP jmp_level ");
        princ(MAKESINT(jmp_level),STDOUT);
        newline(STDOUT);
    }
        
  n=calljmp();  /*** jmp_level=1  ***/
  if(n){
    PRINT("s_TOP jmp  ");  //debug
    if(Errno){
       /** debug_level=0; **/
       error_top(Errno);
       Errno=NULL;
     }
    else if(sigcode){
        PRINT("signal received ");
        princ(MAKESINT(sigcode),STDOUT);
        newline(STDOUT);
        sigcode=0;
     }
    else
      print_SCM();  /**** jmp from errorhook ***/
   }
  if(stack!=memo){
      stack=memo;
}
 //  for Debug!
// 2020.1.2  use myloop in  myloop2.ss
 if(ATOMVAL(a_r_e_p)!=a_nil) funcall(ATOMVAL(a_r_e_p),0,a_nil);

loop:
  if(stack!=memo){
        printf("SYSTEM stack %lx abnormal %lx\n",(unsigned long)stack,(unsigned long)memo);
      stack=memo;
}
  if(istty){
    if(gbc_verbos)  PRINT("TOP:");   //Debug!  by ss -d
    princ(PROMPT,STDOUT);
    //PRINT("USER> ");
   lfflush(STDOUT);
   }
  ss_update();
     if(istty){
#ifdef USE_TK
            if(top_visible)  update();
#endif
        while(buffer_white()) {   /*** while ***/
                    ss_update();  /*** always check for cygwin   see timer.c ***/
                   if(sigcode) {
                        sigcode=0;
                        break;
                    }
#ifdef USE_TK
           if(top_visible){
              if(Tk_GetNumMainWindows()>0){  /*** 1 ***/
                 update();
                /*** Tcl_DoOneEvent(0); ***/
              }
             else
                long_jmp(0,189); /****  No window then , jump to tk_lisp Main and
                        initialize TK again     *****/
            }
#endif
     }
   }
    input_flag=1;
        if(silent_mode) {
           /** printf("silent visible %d\n",top_visible); ***/
              ss_update();
#ifdef USE_TK
           if(top_visible){
                 /*** update(); ***/
              if(Tk_GetNumMainWindows()>0){  /*** 1 ***/
                  update();
                /*** Tcl_DoOneEvent(0); ***/
              }
             else{
                s_bye(0,a_nil);
                long_jmp(0,199); /****  No window then , jump to tk_lisp Main and
                        initialize TK again     *****/
               }
            }
#endif
      goto loop;  /*** because we need ss_date ***/
     }

  //PRINT("debug:g_read  start");
    //    newline(STDOUT);
  p=s_gread(0,a_nil);
  //PRINT("debug:g_read  END");
  //      newline(STDOUT);
    input_flag=0;
     /** if(istty) line_history(input_line++); **/
     if(istty) line_history();

     if(p==SEOF){
                s_bye(0,a_nil);
      }

  *(stack-1)=p;
  p=s_vm_compile(1,a_nil);
  /***  debug  
  PRINT("compile:");
  prin1(p,STDOUT);
  newline(STDOUT);
**/

  *(stack-1)=p;
   /***  lfflush(STDOUT); ***/
  p=VM(p);
  *(stack-1)=p;
  print_SCM();
  if(p!=SCM) {  /*** Abnormal  ***/
  PRINT("Abnomal SCM Value:");
  prin1(SCM,STDOUT);
  PRINT("p is:");
  prin1(p,STDOUT);
  newline(STDOUT);
  }
 goto loop;
}
  
void print_SCM(){
 ptr m=MULTIVAL,memo=SCM;
 psh(m);
 psh(memo);
 PRINT("Value: ");  //  if STDOUT is func port, this change SCM!
  prin1(memo,STDOUT);
  newline(STDOUT);
  if(CONSP(m)){
  PRINT("Multi-value:");
     while(CONSP(m)){
        prin1(CAR(m),STDOUT);
        newline(STDOUT);
        m=CDR(m);
     }
    MULTIVAL=a_undef;
  }
  SCM=memo;
  sp_pull(2);
}

ptr vm_eval(ptr s,ptr env){
  psh(s);
  psh(env);
  s=s_vm_compile(2,a_nil);
  *(stack-1)=s;
  /***
  PRINT("vm_eval");
  prin1(s,STDOUT);
  newline(STDOUT);
  ***/
  s=call_vm(s,env);  /***  clear env  to be modify ***/
  stack-=2;
  return s;
}

ptr s_vm_eval(int narg,ptr env){
  ptr s;
   checknarg(narg-2);
  s=s_vm_compile(2,a_nil);
  *(stack-2)=s;
  s=call_vm(s,*(stack-1)); /*** to be modify ***/
  return s;
}

/****  Not call syntax-expand ***/
ptr s_sys_eval(int narg,ptr env){
  ptr s;
   checknarg(narg-2);
  s=vm_compile(*(stack-2),*(stack-1));
  *(stack-2)=s;
  s=final(s);
  s=call_vm(s,*(stack-1)); /*** to be modify ***/
  return s;
}


void error_top(ptr err){
  PRINT("Error: ");
  prin1(err,STDOUT);
  newline(STDOUT);
  print_his(20);
}

