;;; usage:  (save-file-name)
;;;         (save-file-name "test.sgf")
;;;  if no file,   #f  is returned
;;;  overwite is confirmed
;;;  system cwd may be changed in this dialog!!!
;;; 
;;;  2005.1.87 first created
;;
(in-package "save-file")

(define *file-non* "Input File Name")
(define *save-file-dialog* 0)
(define *save-ok* 0)
(define *save-ent* 0)

(define (save-file-name  default . mesg)
  (let* ((ext '("*")) 
         (s 0)
        (dir  (gen-toplevel '.savefile))
        (dir-glob (tk-name dir ".glob"))
        (dir-cwd (tk-name dir ".labcwd"))
        (dir-wdir  (tk-name dir ".wdir"))
        (wdir-yscroll  (tk-name dir ".wysc"))
        (dir-lb  (tk-name dir ".lbox"))
        (dir-yscroll  (tk-name dir ".ysc"))
        (dir-name  (tk-name dir ".name"))
        (dir-ok  (tk-name dir ".ok"))
        (dir-cancel  (tk-name dir ".cancel"))
        (dir-mk  (tk-name dir ".mk"))
        (dir-mkent  (tk-name dir ".mkent"))
        (file-name (string->symbol (substring (symbol->string dir) 1 :end)))
        (dir-mesg  (tk-name dir ".mesg"))
        (memo (getcwd))
        )
    (set! *save-file-dialog*  dir) 
    (set!  *save-ent* dir-name)
    (set!  *save-ok* dir-ok)
    (grab dir)   ;;; can't other work
     (symbol-value-set  file-name default)
     (set! s (regexp (symbol-value file-name)  #"\.[^.]+$"))
     (if s (set! ext (list (tk-string #\* s))))
     (if (pair? mesg)  (set! mesg (car mesg)) (set! mesg #f))

    (wm 'title  dir  "Input File Name")
    (wm 'geometry dir "500x430+80+80")
    (entry dir-glob  :width 25)
    (insert-glob dir-glob ext)
     (grid dir-glob :column 2)
     (label dir-cwd :text (getcwd))
     (grid dir-cwd :column 2)
     (listbox  dir-wdir  
        :yscrollcommand
                  (lambda l (apply (function  wdir-yscroll) 'set l))
       :width 20 :height 16)
     (scrollbar  wdir-yscroll  :orient 'vertical
                 :command
                    (lambda l (apply  (function dir-wdir)  'yview l))
       )
      (listbox  dir-lb 
        :yscrollcommand
                  (lambda l (apply  (function dir-yscroll) 'set l))
       :width 35 :height 16)
     (scrollbar  dir-yscroll  :orient 'vertical
                 :command
                    (lambda l (apply (function  dir-lb)  'yview l))
       )
     (grid  dir-wdir wdir-yscroll
           dir-lb   dir-yscroll :row 2  :sticky 'nws)
     
     (entry dir-name :bg 'snow :width 25  :textvariable file-name)
    ;;;; (funcall dir-name 'insert 0 (symbol-value file-name))
     (grid dir-name :column 2 :row 3  :sticky 'ew)
     (button dir-ok :text "OK" :width 11 :command
            (lambda()(grab 'release dir)(destroy dir)))
     (button dir-cancel :text "CANCEL" :command 
                        (lambda() (symbol-value-set file-name *file-non* )
                                 (grab 'release dir) (destroy dir))  )
     (grid dir-ok  :column 2 :row 4 :sticky 'ew ) 
     (grid  dir-cancel :column 2 :sticky 'e )   ;;;  :sticky 'ew )
     (label dir-mk :text "mkdir")
     (entry dir-mkent :bg 'snow :width 25 )
     (grid dir-mkent :column 0 :row 3  :sticky 'ew)
     (grid dir-mk :column 0 :row 4  :sticky 'ew)
      (dir-reset dir-lb dir-wdir dir-glob )
     (when mesg 
        (label dir-mesg :text mesg)
        (grid dir-mesg :column 0 :row 5 :columnspan 2 :sticky 'ew)
     )
     
    (bind dir-lb   "<Button-1>" (lambda (y)
                          (get-file-ypos  y dir-lb  file-name)
                          )
          )
    (bind dir-wdir  "<Button-1>" (lambda (y)
                          (chd-ypos  y dir-wdir dir-cwd dir-lb dir-glob file-name)
                          )
          )
    (bind  dir-lb  "<Return>" (lambda () (check-name "Return" )))
    (bind  dir-glob  "<Return>" (lambda () (dir-reset  dir-lb dir-wdir dir-glob )))
    (bind dir-name "<KeyPress>" (lambda(K) (check-name K )))
    (bindtags dir-name  (list 'Entry "."  'all dir-name))
    (bind  dir-mkent  "<Return>" (lambda () (new-mkdir dir-mk dir-mkent dir-lb dir-wdir dir-glob)))
    ;;;(tkwait 'visibility  dir )
    (focus dir-name)
    (tkwait 'window dir )
     ;;;  below not eq? because tklink copy string
     (set! s (symbol-value file-name))
     (if (or (equal? s *file-non*)(equal? s ""))
        (set! s  #f )
       ;;; (if (number? s) (number->string s) s)
        (set! s (tk-string (getcwd) #\/ s))
     )
   (chdir memo)
  s
))

(define (new-mkdir lab ent dir-lb dir-wdir dir-glob)
  (let* ((name (funcall ent 'get)))
    (if (or (file-exists? name) (equal? name ""))
      (funcall lab 'configure :text "mkdir Fail")
      (begin
        (mkdir name)
         (dir-reset dir-lb dir-wdir dir-glob)
      (funcall lab 'configure :text "mkdir OK")
      )
   )
))
(define (check-name key )
  (let* ((file (funcall *save-ent*  'get)))
   ;;;(format #t "~s ~s ~%" key  file)
   (if (file-exists? file) 
        (funcall *save-ok* 'configure :text "Over Write" :fg 'red :activebackground 'red )
       (begin
         (funcall *save-ok* 'configure :text "OK" :fg 'black :activebackground 'snow)
         (update)
         ;;;(format #t "key ~s~%" key)
         (when (equal? key "Return")
               (format #t "Dialog end ~%" )
               ( funcall  *save-ok* 'invoke)
               ;;(destroy *save-file-dialog*)
               (format #t "file name ~s~%" file)
               (update)
         )
       )
   )
))

   
(define (dir-reset dir-lb dir-wdir ent )
   (let* ((n-files 0) (dir-list 0)(direc 0))
   (funcall dir-lb 'delete 0 'end)
   (funcall dir-wdir 'delete 0 'end)
     (set!  dir-list (sort (apply glob-file  (get-ext ent)) string<?))
      ;;;  up dir
      (set! direc (sort (glob-dir-dot) string<?))
      (do ((x ()) (i 0) (dirs direc))
          ((null? dirs) )
         (set! x (pop dirs))
          (funcall dir-wdir 'insert 'end  x)
          ; (format #t "~a~%" x)
          (set! i (+ i 1))
       )
     (do ((x ()) (i 0) (dirs dir-list))
          ((null? dirs) (set! n-files i))
         (set! x (pop dirs))
          (funcall dir-lb 'insert 'end  x)
          ; (format #t "~a~%" x)
          (set! i (+ i 1))
        )
    (check-name "a" )
     (focus *save-ent*)
    (update)
    n-files
))

(define (get-file-ypos  y  dir-lb  file-name)
   (let* ((i  (funcall dir-lb  'nearest y  ))
           (file "")
            )
     ; (format #t "~s ~s ~%" i y)
     (set! file (funcall dir-lb 'get i))
     (symbol-value-set file-name file)
    (check-name "a" )
     (focus *save-ent*)
     (update)
)) 

(define (chd-ypos  y dir-wdir dir-cwd dir-lb ent file-name)
   (let* ((i  (funcall dir-wdir  'nearest y  ))
           (file "")
            )
     ; (format #t "~s ~s ~%" i y)
     (set! file (funcall dir-wdir 'get i))
     (chdir file)
     (funcall dir-cwd 'configure :text (getcwd))
    (check-name "a" )
     (dir-reset dir-lb dir-wdir ent )
))
 
(define (glob-dir-dot)
   (let* ((s (glob-dir  "*" ".*")))
        (set! s (remove "." s))
        (set! s (remove ".." s))
        (cons ".." (cons "." s))
))

(define (insert-glob ent ext)
  (funcall ent 'delete 0 'end)
  (while (pair? ext)
     (funcall ent 'insert 'end (pop ext))
     (if (pair? ext) (funcall ent 'insert 'end " "))
  )
)

(define (get-ext ent)
  (let* ((ext  (funcall ent 'get)))
    (set! ext (regexp ext #"[^\s]+" :repeat))
    (if ext ext '("*"))
))


(export 'save-file-name)
(use-package "save-file" "ss")

;;(get-file-name)



