;;; http 1.0
;;;
;;;  2004.11.6
;;;  2004.11.23
;;;  2004.11.28   DL-manager
;;;  2005.1.5  ver1.3 
;;;
(in-package "http")
;;;  Caution!!!
(kanji-error #f)
;;;
(define *recv* ())

(require "http-base")
;;;;
(load "http-proto")
(load "load-proxy")   ;;;;  for load proxy file
;;; (define *Proxy* '("66.250.69.2" 81))     ;;; IP port   use as default proxy
;;; DL-manager
(define *DL-que* ())
(define *DL-cancel* ())
(define *DL-MAX* 2)
(define *DL-num* 0)
(define *DL-active* #f)
(define *DL-accept* #f)   ;;; enable change que
(define *DL-enable* #t)   ;;; enable download in get-msg
(define *DL-stop* #f)
;;;    ssweb  GUI
(load "html-init")
(load "href-win")
(load "http-ssweb")
(load "http-dlwin")
;;;  engine
(load "html-form")
(load "html-table")
(load "http-engine")
(load "html-auto")
;;;
(load "http-que")
;;;
;;;;   (DL-start)  will DL-manager active 
(define (DL-start  .  req)
   (set! req  (if (pair? req) (car req) #f))
   (set! *DL-stop* #f)
   (DL-manager req  #f)
)

;;; Usage:
;;;(http-get  "http://www.dendai.ac.jp/" )    ;;;GET    
;;;(http-head  "http://www.dendai.ac.jp/" )   ;;;HEAD   only check url&access
;;; if you like direct
;;;    (http "www.google.co.jp" "GET / HTTP/1.0" "")

;;; proxy 66.250.69.2:81ͳǥ
;;; (http-get "http://www.dendai.ac.jp/" "66.250.69.2" 81)

;;;
;;;

(define (http-get  url . proxy)
  (let* ((dld (request-DLD url "GET" #f #f))(ishtml (DLD-ishtml dld)))
    (set! *DL-stop* #f)
    (if (null? proxy) (set! proxy *Proxy*)) 
    (set-DLD dld :proxy proxy)
    (if (not ishtml) (set-DLD dld :screen #f))
    (DL-manager dld  ishtml)
))

(define (http-get-force  url . proxy)
  (let* ((dld (request-DLD url "GET" #f #f))(ishtml (DLD-ishtml dld)))
    (set! *DL-stop* #f)
    (if (null? proxy) (set! proxy *Proxy*))
    (set-DLD dld :proxy proxy)
    (if (not ishtml) (set-DLD dld :screen #f))
    (DL-manager dld  #t)
))


(define (http-head url )
  (let* ((dld (request-DLD url "HEAD" #f #f)))
     (http-request dld)
))

(define (http-cgi-get  url name.value-list )
  (let* ((x 0)(ren #\?) (dld 0))
    (while (pair? name.value-list)
      (set! x (pop name.value-list))
      (set! url (tk-string  url ren (url-encode (car x)) #\=
                     (url-encode (cdr x))))
      (set! ren #\&)
    )
    (set! dld (request-DLD url "GET" #t #f))
    (http-request dld)
))

(define (http-cgi-post url name.value-list )
  (let* ((x 0)(ren "")(post "") (dld 0))
   (while (pair? name.value-list)
      (set! x (pop name.value-list))
      (set! post (tk-string  post  ren (url-encode (car x)) #\=
                     (url-encode (cdr x))))
      (set! ren #\&)
    )
   (set! dld (request-DLD url "POST" #t post))
   (http-request dld )
))

(define (http-request dld)
  (let* ((x 0)(req '("") ) (method (DLD-method dld))
          (proxy (DLD-proxy dld))
          (post (DLD-post dld))
          (url (DLD-url dld))
          (host 0)(ref 0) )
    (set! *DL-accept* #f)
     (when post
        (set! req (list "" post))
        (push (tk-string "Content-length: " (string-byte-length post) ) req)
     )
    (set! host (DLD-host dld))
    (if host (push (string-append "Host: " host) req))
    (set! ref (DLD-referer dld))
    (if ref (push (string-append "Referer: " ref) req))
    (if *User-Agent* (push *User-Agent* req))

  (if proxy
      (apply http-proto dld  (cadr proxy) (car proxy)
              (string-append method " "  url " HTTP/1.0") req)
      (apply http-proto dld  (DLD-port dld) host
             (string-append method " "  (DLD-location dld) " HTTP/1.0") req)
  )
))


#|

(http-cgi-get "http://localhost/cgi-bin/test.cgi"
  '(( "MESSAGE" . "hello"))  )

(http-cgi-post "localhost/cgi-bin/post.cgi" "testdayo!!! good?ƣ")

|#
;;;   start = 10  for 11-20
(define (google key . start)
   (if (pair? start)
        (set! start (tk-string "&sa=N&start=" (car start)))
        (set! start "")
   )
    ;;;;  UTF-8 Google  
  (http-get (string-append  "http://www.google.co.jp/search?hl=ja&lr=lang_ja&btnG="
     "Google+%E6%A4%9C%E7%B4%A2&q=" (url-encode (euc->sjis key)) start)
  )
)

;;;
#|
(define (save-rename file obj)
   (let* ((new 
          (save-file-name obj (tk-string obj " exists. Input New Name")) 
         ))
   (if (and new (not (equal?  new "")))
       (rename-file  file  new)
       (remove-file file)
   )
  new    
))

(define (save-str str obj dld)
   (let* ((new obj)(out 0))
       (if (file-exists? obj)
           (set! new (save-file-name obj (tk-string obj " exists. Input New Name")))
       )
   (when (and new (not (equal?  new "")))
       (set! out (open-output-file new))
       (display str out)
       (close-port out)
   )
   (set-DLD dld :object new)
  new
))
|#
;;;;  we make new auto
(define (save-str str obj dld)
   (let* ((new (new-file-name obj))(out 0))
       (set! out (open-output-file new))
       (display str out)
       (close-port out)
   (set-DLD dld :object new)
  new
))

;;;;  *****    Change here! if you want!!!!!!   ***********************
(define (ssweb)   ;;;; start program
  (let* ((mainwin   (gen-web)))
  (read-proxy)
  (gen-dl)
  (read-bookmark "bookmark" (string-append *HOME* "/bookmark" )
      (string-append *SSLIBDIR* "bookmark" )
  )
#|
  (if (silent-mode?)
      (tkwait 'window mainwin)
  )
 |#
))


(export '( ssweb *recv* http-get  http-head http-cgi-post http-cgi-get google href
   href-abs href-relative href-google  load-proxy
   DL-start DL-stop))
(use-package "http" "ss")
