;;;
(in-package "http")

(define (href-win hf)
   (let* (;;;(hf (gen-toplevel '.hrefWIN))
          (hflis  (tk-name hf  '.dlm))
          (hf-ysc  (tk-name hf '.dlmysc))
          (hf-lab  (tk-name hf '.lab))
          (hf-regexp  (tk-name hf '.reg))
          (hf-save  (tk-name hf '.save))
          (hf-DL  (tk-name hf '.dlque))
          ;;;(dlm-act  (tk-name hf '.stop))
         )
   (listbox  hflis :width 60 :height 10 :exportselection #t
        :selectMode 'extended
        :yscrollcommand (lambda l (apply (function hf-ysc)  'set l)))
   (scrollbar hf-ysc :orient 'vertical
            :command (lambda l (apply (function hflis) 'yview l)))
   (entry  hf-regexp )
   (funcall hf-regexp 'insert 'end "\\.pdf")
   (label  hf-lab :text "regexp:" )
   (button hf-DL :text "DL" :command  (lambda() (hf-dlque hflis)))
   (button hf-save :text "SAVE" :command (lambda()(href-save hflis)))
   (grid  hf-lab :sticky 'news :row 0 :column 0)
   (grid  hf-regexp :sticky 'news :row 0 :column 1)
   (grid  hf-DL :sticky 'news :row 0 :column 2)
   (grid  hf-save :sticky 'news :row 0 :column 3)
   (grid  hflis  :sticky 'news :columnspan 8 :row 1)
   (grid  hf-ysc :sticky 'news :row 1 :column 8)
   (grid 'columnconfigure hf 6 :weight 1)
   (grid 'rowconfigure hf 1 :weight 1)
    (bind hf-regexp  "<Return>"
           (lambda () (href-win-get hflis (funcall hf-regexp 'get))))
))

(define (href-win-get hflis reg)
  (let* ( (ur ())) 
    (if (equal? reg "")
        (set! reg #f)
        ;;;;; (set! reg  (regexp->nfa reg))           ;;;;; (make-regexp reg))
    )
    (funcall hflis 'delete 0 'end )
    (set! ur (if reg ( href reg) (href)))
    (while (pair? ur)
           (funcall hflis 'insert 'end (tk-string #\space (pop ur)))
    )
   (funcall hflis 'selection 'set 0 'end)
)) 

(define (hf-dlque hflis)
  (let* ((sel (listbox-index hflis))(id 0))
     ;;;(format #t "url ~s~%" ind)
     (while  (pair? sel)
         (set! id (pop sel))
         (set! id (funcall hflis 'get id))
         (set! id (substring id 1 :end))
         (http-get id)  ;;;  not force
     )
))

(define (href-save hflis)
  (let* ((sel (listbox-index hflis)) (memo sel) (id 0)(file 0)(out 0)(name ".href")(n 0))
     ;;; make file name
     (when (pair? sel)
         (set! id (car sel))
          (set! id (funcall hflis 'get id))
          (set! id (regexp id #"[^/]+$"))
          (when  id 
              (set! n (string-index "." id))
              (if n (set! id (substring id 0 n))) 
              (set! name (tk-string id name))
          )
     )
     (funcall hflis 'selection 'clear 0 'end)
    ;;;;
     (set! file (save-file-name name "Save href"))
     (when file
       (set! out (open-output-file file))
       (while  (pair? sel)
         (set! id (pop sel))
         (set! id (funcall hflis 'get id))
         (set! id (substring id 1 :end))
         (display id out)
         (newline out)
      )
      (close-port out)
         (format #t "save! ~s~%" file)
    )
   (selection-recover memo hflis)
))

;;;(href-win)
