;;;  load-proxy
;;;  2005.1.9
;;;  proxy
;;;   usage (load-proxy  "proxy")
;;;
(in-package "http")

(define (read-proxy-file  file )
   (let* ((in (open-input-file file)) (x 0)(ip 0)(pro 0) 
             (regpro (regexp->nfa #"(\d+\.\d+\.\d+\.\d+):(\d+)")) (res ()) )
     (set! x (read-line  in))
     (while (not (eof-object? x))
       (set! pro (regexp  x regpro))
       (when pro
         (set! ip (match-string  1))
         (set! pro (string->number (match-string  2)))
         (push (list ip pro) res)
       )
       (set! x (read-line  in))
     )
    (close-port in)
   (set! res (reverse res))
   (set! *Proxy-list* res)
   (if (pair? res) (set! *Proxy* (car res)))
   res
))

(define (load-proxy . file-list)
 (let* ((f #f))
  (while (and (not f) (pair? file-list))
    (set! f (pop file-list))
    (if (file-exists? f)
        (read-proxy-file f )
        (set! f #f)
    )
  )
   (if (not f) (format #t "Not exists proxy ~%" ))
))

(define (read-proxy)
  (load-proxy "proxy" (string-append *HOME* "/proxy" )
      (string-append *SSLIBDIR* "proxy" )
  )
)

;;;;(read-proxy)

