;;;  white-<-> black  definitions
;;;;  16.3.16
;;;
;;; rxvt

(in-package "tty")
(define *input-controls* ())

;;;   key boad input sequence
;;;
;;;      input key(sequence) -> editor command
;;; 
(make-control cur-up  #\escape  #\[ #\A)
(make-control cur-down  #\escape  #\[ #\B)
(make-control kcur-right  #\escape  #\[ #\C)
(make-control kcur-left  #\escape  #\[ #\D)
(make-control his-up         #\escape  #\[ #\5 #\~)
(make-control his-down        #\escape  #\[ #\6 #\~)
(make-control cur-begin-end       (CTRL #\P) )
(make-control read-chk        (CTRL #\O) )
(make-control read-end        (CTRL #\Q) )
(make-control scr-insert-new        (CTRL #\D) )
(make-control delete-line          (CTRL #\E) )
(make-control scr-hotstart          (CTRL #\T) )
(make-control delete       #\delete )
(make-control backspace       #\backspace )

;;;;  diplay control  definitions
;;;;      related   terminfo 
;;;;
(define Up    (string-append  ESC  "[A"))
(define Down  (string-append  ESC  "[B"))
(define Right (string-append  ESC  "[C"))
(define Left  (string-append  ESC  "[D"))

;;; 0 black 1 red  2 green  3 yellow  4 blue   5 mazenda  6 sian 7 gray ?
;;; 8  no-effect(?)  9 white
(define black 9)    ;;; for newline at the end of line
(define gray 7)    ;;; for newline at the end of line
(define white 0)   ;;;  original bg color
(define blue 4)
(define sian 6)
(define mazenda 5)

;;;;   we use N= 2,3,4,1 to indicate the level of ()  
(define (set-fg n)
  (if (= n 3) (set! n 9))
  (display  ESC )
  (display   "[3")
  (display n)
  (display 'm)
)

(define (set-bg n)
  (if (= n 3) (set! n 9))
  (display  ESC )
  (display   "[4")
  (display n)
  (display 'm)
)
;;;; if terminal don't support color
;;;; (set-fg white) should be normal display
;;;;  other (set-fg n)  (set-bg n) 
;;;;         means some  change atribute for display character
;;;; if you don't need check syntax ,  these can be defined a foo function!
;;;;
#|
   ;;; Not used
(define Bold    (string-append (string #\escape) "[1m"))
(define Smso    (string-append (string #\escape) "[7m"))      ;;;  into like xterm
(define Setab    (string-append (string #\escape) "[47m"))   ;;; back white
(define Setaf    (string-append (string #\escape) "[30m"))  ;;; char black
(define Cnorm    (string-append (string #\escape) "[?25h"))  ;;; cursor normal
(define Sgr0     (string-append (string #\escape) "[m" (string #\null) "17"))  ;;; clear all attr
(define Smcup    (string-append (string #\escape) "7" (string #\escape) "[?47h"))  ;;; clear all attr
(define S0ds    (string-append (string #\escape) "(B"))   ;;; code set 0    ascii
(define S1ds    (string-append (string #\escape) "(0"))   ;;; code set 1

|#
