(define-syntax let (syntax-rules (begin)
   ((let () b ...)   (begin b ...))
   ((let ((x y)) b ...)  (let* ((x y)) b ...))
   ((let ((x y)(z u) ...) b ...) 
      (let* ((temp y) )
         (let ((z u) ...)
           (let* ((x temp))  b ...))))
  ) 
)

#|
(s '(let () (write x)))

(s '(let ((x 8)) (write x)))

(s '(let ((x 8)(y x)) (write x)))

(s '(let ((x 8)(y x)(z y)) (format #t "~s ~s ~s" x y z)))

(s '(let ((x 8)(y x)(z y)(u (+ x y))) (format #t "~s ~s ~s ~s" x y z u)))

(let ((x 8)(y x)(z y)(u (+ x y))) (format #t "~s ~s ~s ~s" x y z u))

|#

 
