;;;  exp-linear.ss
;;;     for MACRO
;;;  2005.10.17
;;;;

(define *exp-last* #f)

(define (exp->linear exp)
  (let* ((res (exp->linear-main exp)))
    (if (pair? res)
       (begin
           (set-cdr! *exp-last* (cons (list 'S-read-eof?)()))
            res
       )
         (list res (list 'S-read-eof?))
    )
))
         
(define (exp->linear-main  exp)
   (if (pair? exp)
      (let* ((tmp (cons () ())))
          (set! *exp-last* (exp->linear-sub exp tmp))
          (cdr tmp)
      )
      exp
    )
)

(define (exp->linear-sub exp tmp)
 (let* ((x (car exp)))
   (if (symbol? x)
       (cond ((eq? x '...)
                (set! x (exp->linear-main (cadr exp)))
                ;;;  linear form is always a list!!!
                (if (not (pair? x))  (set! x (list x))) 
                (set-cdr! tmp (cons (list '... x )()))
                (cdr tmp)
              )
             ( (eq? x 'vector)
                  (set-cdr! tmp (cons '(S-read-vector-left) ()))
                  (set! tmp (cdr tmp))
                  (set! exp (cdr exp))   ;;; skip vector
                  (set! tmp (exp->linear-pair exp tmp))
                 (set-cdr! tmp (cons '(S-read-vector-right) ()))
                 (cdr tmp)
               )
             (else
                 (set-cdr! tmp (cons exp ()))
                  (cdr tmp)
             )
        )
     (begin
         (set-cdr! tmp (cons '(S-read-left) ()))
         (set! tmp (cdr tmp))
         (set! tmp (exp->linear-pair exp tmp))
         (set-cdr! tmp (cons '(S-read-right) ()))
         (cdr tmp)
      )
   )
))

(define (exp->linear-pair exp tmp)
   (let* ((x 0))
     (while (pair? exp)
             (set! x (pop exp))
             (if (pair? x)
                  (set! tmp (exp->linear-sub x tmp))
                   (begin
                       (set-cdr! tmp (cons x ()))
                       (set! tmp (cdr tmp))
                   )
             )
     )
   tmp
))


