;;;;  template-exp.ss
;;;;  transorm template
;;; 04.4.04
;;; 04.4.17  alias is corrected by
;;;    introducing *template-name-change*

(in-package "macro")
(compiler-not-eval (define  *template-name-change* ()))
;;;(define *stop-expand* "stop-expand")
;;;;(define *null-dot* "null-dot-env")

                  
;;;; template expand
;;;;
;;;; temp must be outlinear
(define (template-exp temp )
  (set!  *template-name-change* ())
  (set! *pat-level* 0)
  (S-write-init)
  (init-get-data)
  (for-each template-expand  temp )
  (S-write-close)
)

(define (find-alias-name name alias)  ;;;; 04.4.17 New
  (let ((d (assq name *template-name-change*)))
    (if d 
       (cdr d)
      (begin
         (if (assq alias *local-env*)  
              ;;; already used alias outside
             (begin
                (set! d (gensym))
                (push (cons name  d) *template-name-change*)
                (symbol-value-set d (symbol-value alias)) ;;; 4.18 for compiler
                 d
              )
             (begin
                 (push (cons name alias) *template-name-change*)
                 alias
             )
          )
        )
     )
))

(define (template-expand temp )
    ;;; (format #t "template-expand ~s~%" temp)
   (if (pair? temp)
        (template-expand-pair  temp () 0)
        (S-write temp)
   )
)

(define (template-expand-pair temp env level)
    (let* ((top (car temp)) (as 0)(s 0)(obj 0))
       ;;;(format #t "template-expand ~s~%" temp)
      (cond ((eq? top 'pat) 
                 (set! top (get-data (cadr temp) level))
                 (if (not (eq? top eof-object?))   ;;;;;bug fix 
                       (S-write top) 
                 )     )
            ((eq? top 'macro) (S-write (cadr temp)))
            ((eq? top 'literal) (S-write (cadr temp)))
            ((eq? top 'local)
                    (set! s (cadr temp))
                    ;;; local is not free and use always alias
                    ;;;   4.18
                    ;;;(set! as (assq s *local-env*))
                    ;;;(if (eq? as (cadddr temp))
                    ;;;     s
                        (begin
                         (set! as (caddr temp))   ;;; alias
                         ;;;(set! as (find-alias-name s (caddr temp)))
                         (push (cons s as) *name-change*)
                         (push (cons as s) *alias-name*)
                         (S-write as)
                        )
                    ;;;; )
                )
                 ;;;;   (cadr temp)) ;;; toriaezu
            ((eq? top 'template) 
                   ;;;  free var uses alias   4.18
                    (set! s (cadr temp))
                         (set! as (find-alias-name s (caddr temp)))
                           (push (cons as s) *alias-name*)
                          (S-write  as)   ;;; alias
                )
            ((eq? top 'special)
                    ;;;(format #t "special temp ~s local-env ~s~%" temp *local-env*)
                    (set! s (cadr temp))
                    (set! obj (symbol-value s))
                    (set! as (caddr temp))   ;;; special-object
                    (if ( or (assq s *local-env*) (not (eq? as obj)))
                         (begin
                           (push (cons as s) *alias-name*) ;;;; 
                            (S-write as )  ;;; special-object
                         )
                         (S-write s)
                     )
                 )
            ((eq? top 'syntax-macro) 
                   (set! s (cadr temp))  ;;; original name
                   (set! obj (cadddr temp))   ;;; def
                   (set! as (get-macro s))
                   (if (and (eq? as obj) (not (assq s *local-env)))
                        (S-write  s)
                     (begin 
                        (set! s (caddr temp))
                        (if (not (eq? as obj)) 
                           (set! *macro-bind-local* 
                               (cons (cadr (cadddr temp)) *macro-bind-local* ))
                        )
                       (push (cons s (cadr temp)) *alias-name*)
                       (S-write s)
                     )
                    )
                 )
            ((eq? top 'classic-macro)   ;;;  New!!!
                  (S-write (cadr temp)) )   ;;;;  Good?

            ((eq? top 'vector)   ;;;;  MADA!!!
                 (set! s (template-expand (cddr temp) env dot-env))
                 (list->vector s)
               )
            ((eq? top '... )
                (set! top (cadr temp)  )
                    (set! env (trans-up top (+ level 1)))
                (if (= level 0)   ;;;; initalize all
                    (for-each  (lambda (v)  (init-get-request (car v) ) ) env)
                )
                    ;;;(format #t "env ~s~%" env)
                (template-dot-exp top env level)  )
            (else
                (funcall top)
            )
        )
))

(define (trans-up s n)
  (let* ((x 0) (res ()))
  (while (pair? s)
    (set! x (pop s))
      (if (pair? x)
        (if  (eq? (car x) 'pat)
             (push (list (cadr x) n (var-level (cadr x)) ) res)
           (if (eq? (car x) '...)
               (set! res (append (trans-up (cadr x) (+ n 1)) res))
           )
        )
      )
  )
  res
))


(define (pat-init-data ev level)
   (let* ((v (car ev)) (patlevel (cadr ev)) (vlevel (caddr ev))
            (s (- patlevel vlevel))  (real (- level s)) )
      ;;;(format #t "pat-init v ~s real ~s level ~s~%" v real level)
        (cond ((< real 0) #t)  ;;; do nothing
              ((eq? real 0)
                 (init-get-request v) )
              ((> real 0)
                 (get-request v real)  )
              (else #t)   ;;; never occur
        )
))
      
(define (init-data-request env level)
  ;;;(for-each  (lambda (v)  (get-request (car v) level) ) env)
  (for-each  (lambda (v)  (pat-init-data  v level) ) env)
)

(define (pat-shift-req ev level)
   (let* ((v (car ev)) (patlevel (cadr ev)) (vlevel (caddr ev))
            (s (- patlevel vlevel))  (real (- level s)) )
        (cond ((<= real 0) #t)  ;;; do nothing
              ((> real 0)
                 (shift-request v real)  )
              (else #t)   ;;; never occur
        )
))


(define (shift-data-request env level)
  ;;;(for-each  (lambda (v)  (shift-request (car v) level) ) env)
  (for-each  (lambda (v)  (pat-shift-req  v level) ) env)
)

(define (template-dot-exp pat env level)
   ;;; (let  ((x 0) (y 0)  (top 0) (memo pat)  (ans #t)(ans2 #f) (out 0)) 
     ;;;   This let can not be compiled!!! Why????
     ;;;;
   (let*  ((x 0) (y 0)  (top 0) (memo pat)  (ans #t)(ans2 #f) (out 0)) 
       (inc level)
     ;;;  (format #t "Enter template-dot-exp  pat ~s level ~s ~%"
     ;;;              pat  level)
       (init-data-request env level)
    (while ans
       (set! pat memo)
       (set! ans #f)
       (set! out (S-write-get))
      (while  (pair? pat)  
        (set! x (pop pat))
        (if (pair? x)
            (begin
              (set! y (template-dot-pair x env level))
 ;;;;;        (format #t "dot-exp  ans ~s  x ~s level ~s ~%" y x level)
              (if (car y)
                  (set! ans #t)
                 (when(= level (cdr y))
                          (set! ans #f)
                          (set! pat ())
                 )
              )
            ;;;;  (if (= level 1)
            ;;;;     (format #t "template-dot-exp  ans ~s env ~s  ~%" ans  env))
            )
          (S-write x)
        )
      )
     (if ans (set! ans2 #t) (S-write-set out))
;;;;  (if (= *pat-level* 1)(format #t "dot-while  S-write ~s~%"  (S-write-get)))
    )
    (shift-data-request env level)
   ;;;    (format #t "template-dot-exp  ans2 ~s ~%" ans2 )
    (cons ans2 level) 
))

(define (template-dot-pair x env level)
  (let* ((top (car x)) (v 0)(n 0))
    (cond ((eq? top 'pat)
             (set! v  (cadr x))
             (set! n (var-level v))
                   ;;;(get-request v level)  
              (set! x (get-data v level))
              (if (eof-object? x)
                     (cons #f level) 
                   (begin
                     (S-write x)
                      (cons #t level) 
                   )
             )
           )
          ((eq? top '...)
             (set! env (trans-up (cadr x)  (+ level 1)))
             (set! x (template-dot-exp (cadr x) env level))
              x
            )
         (else
            (template-expand-pair x env level)
              (cons #f 0) 
           )
     )
))

#| test
  (define temp (template-trans ' (letrec
       ((loop
           (lambda (var ...)
             (if test
                 (begin
                   (if #f #f)
                   expr ...)
                 (begin command ...
                   (loop (do "step" var step ...)
                       ...)
                 )
              )
            )
           ))
        (loop init ...))      ())
  )

  (get-temp-dotenv temp)
  (define env *temp-dotenv* )
  ;;(define s (take-1st env))

  ;;; bug  ---> OK
    (define def (assq 'do *macro-bind*))
   (macro-ex '(do ((i 7)(j 88 (+ j 1))) ((= i 888) foo) goo doo) def)
   (s  '(do ((i 7)(j 8 (+ j 1))) ((= j 80) (write 'end)) (set! i (+ i j)) (write i)) )
  
   (s  '(do ((i 7(+ i 3))(j 88 (+ j 1))) ((= i 888) foo) goo doo) )

   (s '(or))
   (s '(or x (> y 9) ))
   ;;
   (s '(let ((temp 'foo))  (pop x) (write temp)) )
  ;; bug
   (s ' (do ((var 0) (temp lis (cdr temp)))
           ((null? temp))
           (set! var (car temp))
           (write var)
           (write "why"))    )

    (macro-ex ' (do ((var 0) (temp lis (cdr temp)))
           ((null? temp))
           (set! var (car temp))
           (write var)
           (write "why"))   def  )

      (s ' (do ((i 999 (+ i 1)) (var 0) (temp lis (cdr temp)))
           ((null? temp))
           (set! var (car temp))
            (inc i)
           (write var)
           (write "why"))    )
      

  

|#


