;;;  2010.7.10  psyntax
;;;  2010.7.27  psyntax2.ss
;;;;

(define *macro-bind* ())
(define *syntax-binds*  ())
(define *local-syntax*  #f)
(define *bind-env* ())

(define (bind-env f)
   (if (pair? f)
         (if (and (eq? (car f) 'syntax) (pair? (cdr f)))
               (bind-env-syntax (cadr f))
               (begin
                  (bind-env (car f))
                  (bind-env (cdr f))
               )
         )
   )
 )

(define (bind-env-syntax  f)
   (if (symbol? f)
        (bind-env-symbol f)
       (if (pair? f)
         (if (not (eq? (car f) 'quote))
           (begin
            (bind-env-syntax (car f)) 
            (bind-env-syntax (cdr f))
           )
         )
       )
   )
)

(define (bind-env-symbol f)
    (or (assq f *vars*) 
        (assq f *macro-env*)
        (assq f *literal*)
        (assq f *bind-env*)
        (eq? f *macro-key*)
        (eq? f '...)
            (if (symbol-bind? f)
               (push (cons f (symbol-value f)) *bind-env*)
             )
    )
)
(trace bind-env)        
;;;;   syntax   is a macro like a quote
 (define-macro  ( syntax form)
     `(template-exec (template-trans ',form))
 )

(define (pre-expand-rules rules)
  (let* ((last (cons ()())))
    (set!  *bind-env* ())
     (if (pair? rules)
         (pre-expand-rules-aux rules last)
     )
    (cdr last)
))

(define (pre-expand-rules-aux rules last)
  (let* ((rule 0)(pat 0)(temp 0)(fender #t))
         (set! rule (car rules))
         (set! pat  (s->pat (car rule)))
         (set! pat  (list *vars* *max-level* pat))
         ;;;(set! pat   (car rule))
         (if (null? (cddr rule))
               (set! temp (cadr rule))
             ;;;;fender
               (begin
                   (set! fender  (cadr rule))
                   (set! temp (caddr rule))
               )
         )
        (bind-env temp)   ;;;;  only for make *bind-env*
        ;;;(set! temp (template-trans temp))
        (set-cdr! last (cons (list pat fender temp) ()))
       (if (pair? (cdr rules))
             (pre-expand-rules-aux (cdr rules) (cdr last))
       )
))

 (define-macro ( syntax-case-transformer  lite . rules)
   (let* ((form 0)(ans #f)(rule 0)(memo ())(pat 0)(env *local-env*))
       (set! *literal* lite)
       (set! *macro-env* env)
       (set!  rules (pre-expand-rules rules))
       ;;;(set!  *macro-env* (append *bind-env* *macro-env*))
       ;;;(set! *bind-env* ())
       (set! memo rules)
       (lambda (exp)
          (set! *macro-env* env)
          (set! ans #f)
          (set! rules memo)
         (while (and (not ans) (pair? rules))
           (set! rule (car rules))
           ;;;(set! pat (s->pat (car rule)))
           (set! pat  (car rule))
           (set! *vars* (car pat))
           (set! *max-level* (cadr pat))
           (set! pat (caddr pat))
           (set! ans (s-match pat exp))
           (if ans (set! ans (eval (cadr rule) *local-env*)))  ;;; fender
           (if ans
               (set! form (eval (caddr rule) *local-env*))
           )
           (set! rules (cdr rules))
         )
        (if ans  form (error E_illegal exp))
       )
)) 

(define-macro ( syntax-case exp lite . clauses)
   `((syntax-case-transformer ,lite ,@clauses)
          ,exp)
 )

;;;;   see P192, DYBVIG
(define-macro (syntax-rules-trans x)
       (syntax-case x
          (*macro-key* *macro-env* *local-env* *alias-name*)
          ((_ (i ...) ((keyword .  pattern) template )...)
             (syntax
               (let* ((macro-key *macro-key*)
                 ;;;(syntax-env   *macro-env*
                 (syntax-env   *local-env*
                   )
                 (alias-name ()) (memo ())
                  )  
                 (format #t "syntax-rules-local-env: ~s~%" *local-env*)
                 (->syntax
                   (lambda (y) 
                    (set!  memo *macro-env*)
                    (set! *macro-env* syntax-env)
                 (format #t "EX-syntax-rules-macro-env: ~s~%" *macro-env*)
                 (format #t "EX-syntax-rules-local-env: ~s~%" *local-env*)
                    (set! *macro-key* macro-key)
                    (set! *alias-name* alias-name)
                    (set! y (syntax-case y (i ...)
                       ((_ . pattern)(syntax template)) ...))
                    (set! alias-name *alias-name*)
                    (set! *macro-env* memo)
                    y 
                   )
                 )
               )
             )
      ))   
)

(define-macro (define-syntax key syntax-rules)
    `(let* ((transformer ())(key-macro ())
               (macro-bind *macro-bind*)(memo ()))
          (set! *macro-key* ',key)
          (set! transformer (eval (syntax-rules-trans ,syntax-rules) *local-env*))
    #|
          (set! key-macro  
               (macro x (set! *key-macro* key-macro)
                        (set! memo *macro-bind*)
                        (set! *syntax-loads* ())
                        (set! x (transformer (cons ,key x)))
                        (set! *macro-bind* memo)
                        (set! *macro-key* #f)
                        x
                )
           )

               (cons key-macro (cons  transformer ()))
    |#
          (set! *macro-bind* (cons (cons ',key 
                   transformer )
                   *macro-bind*))
          ;;;(push (cons *macro-key* *macro-env*) *syntax-binds*) 
          (push (cons *macro-key* *bind-env*) *syntax-binds*) 
          (set! *bind-env* ())
             ;;;;  (key  key-macro  transformer )
          (set! *macro-key* #f)
          ',key
     )
)
;;(trace template-trans)
(define-syntax syntax-environment
  (syntax-rules ()
      ((_  () form) form)
      ((_  ((alias var key) ...) form)
            (let* ((alias (syntax-load (quote var ) (quote key))) ...)
                 form
            )
        )
   )
)
(define-syntax let-syntax-environment
  (syntax-rules ()
      ((_  () form) form)
      ((_  ((alias var key) ...) form)
            (let* ((alias var) ...)
                 form
            )
        )
   )
)

(define (syntax-load var key)
    (let* ((x (assq key *syntax-binds*)))
       (if (not x )
              (error E_illegal key)
           (begin
              (set! x (assq var (cdr x)))
              (if x
                  (cdr x)
                  (error E_illegal var)
              )
           )
       )
))

;;;;
(define (macro-bind->local)
   (while (pair? *macro-bind*)
      (push (pop *macro-bind*) *local-env*)
   )
)

(define-syntax let-syntax-transformer 
   (syntax-rules 
      (*local-env* *syntax-loads* *macro-env* *local-syntax* )
       ((_ ((key  exp)...))
              (let*  ((temp *macro-bind*)(env *local-env*) (memo 0))
                (set! *macro-bind* ())
               (format #t "let-syntax-local-env:~s~%" *local-env*)
                (define-syntax key exp) ...
                (macro-bind->local)
                (set! env *local-env*)
                (lambda (x)  
                   (set! *syntax-loads* ())
                   (set! memo *macro-env*)
                   (set!  *macro-env* env)
                   (set!  *local-env* env)
               (format #t "let-syntax-macro-env:~s~%" env)
                   (set! *local-syntax* #t)
                   (set! x (syntax-expand  x *local-env*)) 
                   (format #t "let-syntax-loads:~s~%" *syntax-loads*)
                   (set! *macro-bind* temp)
                   (set! *local-syntax* #f)
                   (set! *macro-env* memo)
                    x
                ))
         ) 
      )
)

(define-macro (let-syntax key-exp . forms)
     (let*  ((form ()) (memo 0) )
         (set! memo *local-env*)
         (set! *macro-env* memo)
         (format #t "let-syntax env:~s~%" *macro-env*)
#|
           (set! form  (eval (syntax-expand
             `((let-syntax-transformer ,key-exp) '(begin ,@forms))
              *local-env*) ()) ) 
|#
           (set! form   
             (eval (syntax-ex `(let-syntax-transformer ,key-exp)) *local-env*))
         (set! *local-env* memo)
         (set! *macro-env* memo)
            (set! form  (form (cons begin forms)))
            (set! form `(let-syntax-environment
                ,*syntax-loads* ,form))
            (set! *syntax-loads* ())
            form  
     )
 )

(define-macro (letrec-syntax key-exp . forms)
     (let*  ((form ()) (memo 0) )
         (set! memo *local-env*)
         (set! *macro-env* memo)
           (set! form  (eval (syntax-ex
             `(letrec-syntax-transformer ,key-exp)) *local-env*))
        ;;; (set! *local-env* memo)
         (set! *macro-env* *local-env*)
            (set! form  (form (cons begin forms)))
            (set! form `(let-syntax-environment
                ,*syntax-loads* ,form))
            (set! *syntax-loads* ())
            form
     )
 )

(define (set-top-macro!)
    (let* ((x (car *macro-bind*))(c 0))
       (format #t "set-top:macro ~s ~% local ~s~%" *macro-bind* *local-env*)
       (set! *macro-bind* (cdr *macro-bind*))
       (set! c (assq (car x) *local-env*))
       (set-cdr! c (cdr x))
))

(define dummy (->syntax (lambda(x) (cdr x))))

(define-macro (letrec-syntax-helper . key-exps)
   (let* ((s key-exps) (res ()))
      (while (pair? s)
          (push (list 'set-top-macro!) res)
          (push (list 'define-syntax (caar s)(cadar s)) res)
          (set! s (cdr s))
      )
     (set! s key-exps)
      (while (pair? s)
         (push (list 'push (list 'cons (list 'quote (caar s)) dummy) '*local-env*)
                res)
         (set! s (cdr s))
      )
   (cons 'begin res)
))

(define-syntax letrec-syntax-transformer
   (syntax-rules (*macro-bind* *local-env* *macro-env* *local-syntax*)
       ((_ ((key  exp) ...))
              (let*  ((temp *macro-bind*)(env *local-env*) (memo 0))
                (set! *macro-bind* ())
               (format #t "letrec-syntax-local-env:~s~%" *local-env*)
                (letrec-syntax-helper  (key exp) ...) 
               (format #t "After: let-syntax-local-env:~s~%" *local-env*)
                (set! env *local-env*)
                (lambda (x)
                   (set! *syntax-loads* ())
                   (set! memo *macro-env*)
                   (set!  *macro-env* env)
                   (set!  *local-env* env)
               (format #t "letrec-syntax-macro-env:~s~%" env)
                   (set! *local-syntax* #t)
                   (set! x (syntax-expand  x *local-env*))
                   (format #t "let-syntax-loads:~s~%" *syntax-loads*)
                   (set! *macro-bind* temp)
                   (set! *local-syntax* #f)
                   (set! *macro-env* memo)
                    x
                ))
         )
      )
)

