;;;; structure.ss
;;;04.7.8
;;;    use  make-struct,struct-name,struct-vector
;;;05.1.24  revised
;;;05.10.11  revised

(in-package "structure")

;;; (define *structure-inits* ())  in src
(define *structure-slots* ())
;;;(define *structure-offset* ())  in src

;;;(define *undef* (if #f))   in src
#|
(define-syntax to-form-pair
  (syntax-rules (*undef*)
    ( (to-form-pair (a b) ...) ((a b) ...))  ;;; finish
    ( (to-form-pair (a b) ... c d ...) (to-form-pair (a b) ... (c *undef*) d ...))
  )
)

(define-syntax add-quote
  (syntax-rules ()
     ((add-quote a ...)  (list (quote a) ...))
  )
)
|#

 
(define-syntax struct-include      ;;;;  take :include  OK
  (syntax-rules ()
     ((struct-include) ())
     ((struct-include (#t  a) ...)
              ( a  ...))     ;;;;  finish
     ((struct-include (#t a) ...  :include st args ...)
          (struct-include  (#t  a) ... (#t st)  args ...) )

  )
)

(define-macro (make-constructor name)
  (let* ((mac (tk-name "make-" name  )))
      ;;(format #t "make-struct-name  ~s~%" name)
     `(define-macro ( ,mac . args)
              (list* 'make-structure ',name  args  )
      )
))

(define-macro (make-s-reader name)
  (let* ((mac (tk-name "make-s-" name  )))
      ;;(format #t "make-struct-name  ~s~%" name)
     `(define-macro ( ,mac . args)
              (list* 'make-s-structure ',name  args  )
      )
))



(define-macro (set-structure-macro  name)
  (let* ((mac ()))
     ;;; (format #t "make-struct-name  ~s~%" name)
      (set! mac  (tk-name "set-" name ))
      ;;;(format #t "make-set ~s~%" mac)
     `(define-syntax ,mac
         (syntax-rules (set-structure ,name)    ;;;; we need name for literal
                                                ;;;; but why we need set-structure is literal???
           ( (,mac args ...)
              (set-structure ,name args ...) )
         )
      )
))

(define-macro (ref-structure-macro  name)
  (let* ((mac ()))
    ;;;  (format #t "ref-name  ~s~%" name)
      (set! mac  (tk-name "ref-" name ))
     `(define-syntax ,mac
           (syntax-rules (ref-structure ,name)    ;;;; we need name for literal
                                                ;;;; but why we need set-structure is literal???
           ( (,mac args ...)
              (ref-structure ,name args ...) )
         )
      )
))



(define-syntax defstruct-exec
  (syntax-rules (*structure-inits* *structure-slots* *structure-offset* *structure-size*
        *structure-slots-name* compiler-eval  make-s-reader
        set-structure-macro ref-structure-macro make-constructor)
    ( (defstruct-exec name (inc ...) (slot init) ...)
       (compiler-eval
         (let* ( 
                (all-inits (apply make-all-inits (quote (inc ...)) (quote ((slot init) ...))))
                (all-slots (map car all-inits))  
                (off-set ( make-offset (quote (inc ...))
                       (length (quote ((slot init) ...)))))
                (slots-name (make-slots-name all-inits))
                 (n 0) (x  0) (temp all-slots)(s 0)(sl ()))
           (push (cons 'name all-inits) *structure-inits*)
           (push (cons 'name slots-name) *structure-slots-name*)
          (symbol-value-set (tk-name "copy-" 'name)
                 (make-copier  'name ))
           (symbol-value-set (tk-name 'name "?")
                 (make-pred  'name ))

         ;;  (format #t "temp ~s~%" temp) 

              ;;;; for the reason if name crash then first is taken.
              ;;;;;  so, last bind imust be former.
           (set! temp (reverse temp))
           (set! n (length temp))
          (push (cons 'name n) *structure-size*)  
           (while (pair? temp)
                (set! n (- n 1))
               (set! s (pop temp))
                (set! x (substring (keyword->string s) 1 :end))
                (symbol-value-set (tk-name  'name "-" x)
                   (make-access 'name  n))
                (push (cons s n) sl)
               ;;;(set!  n (+ n 1))
           )
          ;;;;(push (cons 'name (reverse sl)) *structure-slots*)
          (push (cons 'name sl) *structure-slots*)   ;;; already reversed!
          (push (cons 'name off-set) *structure-offset*)  
          ;;;; (format #t "off-set ~s~%" off-set)
         )
         ;;;;  Here we can't use above off-set even if it is defined global
         ;;;;  because these macro expansion is done before ,above push's will be done
          ;;;;  actually!!!! 
        (make-constructor name )
        (make-s-reader name )
        (set-structure-macro name) 
        (ref-structure-macro name) 
         'name
       ;;; (make-set-struct 'name all-slots)
     )
   )
)) 

;;;; I could't use  to-form-pair here.
;;;;  This related to th order of expansion of macro
;;;;    and alias:.
;;;;;  This must be solved in the future!!!!
;;;;
;;;;;   Note:  if I use to-form-pair , but defstruct is called before 
;;;;;   expanding to-form-pair, then mismatch will occur!
;;;;

;;;  revised 2005.10.11  to avoid infinity loop by Back-trace of macro-expand
;;;;      ... matches no argument so  (a b) ... e f ... is wrong!!!
;;;
(define-syntax defstruct   ;;; OK
  (syntax-rules (*undef*)
    ( (defstruct "exec" a b (c d)... "para"  (e f) g  ...)
              (defstruct "exec" a b (c d) ... (e f) "para" g ...))
    ( (defstruct "exec" a b (c d)... "para"  e  g  ...)
              (defstruct "exec" a b (c d) ... (e *undef*)  "para" g ...))
    ( (defstruct "exec" a b (c d)... "para" )
              (defstruct-exec  a b (c d) ...))  ;;;  goal
   ;;; ( (defstruct "exec" a b (c d)...  e f ...) (defstruct "exec" a b (c d) ... (e *undef*) f ...))
  ;;;;  ( (defstruct "exec" a b ...) 
  ;;;;             (defstruct-exec a b ...)) ;;; goal
              ;;;(begin (defstruct-exec a b ...)(set-structure-macro  a)) ) ;;; goal
    ( (defstruct (name  st ...) arg1  ...)
               (defstruct name "include"  (st ...)   arg1  ... ) )
    ( (defstruct name  "include" ( (st) ... :include  f g  ... ) arg ...)
               (defstruct name "include"  ((st) ... (f) g  ...)   arg ... ) )
    ( (defstruct name  "include" ( (st) ... ) arg ...)
               (defstruct "exec" name   (st ... ) "para"   arg ... ) )  ;;; take :include
    ( (defstruct name  arg1 arg2 ...)
               (defstruct "exec"  name () "para" arg1 arg2 ... ) )
  )
)

(define (make-all-inits inc-list . inits)
  (let* ((s 0)(x 0) (res ()))
    (while (pair?  inc-list)
       (set! s (pop inc-list))
       (set! x (assq s *structure-inits*))
       (if x
          (set! res (append res (cdr x)))
          (error E_struct_access s)
       )
    )
   ;;;(append res inits)
   (append inits res)
))

#|
(define (make-offset inc-list )
  (let* ((s 0)(x 0)(n 0) (res ()))
    (while (pair?  inc-list)
       (set! s (pop inc-list))
       (set! x (assq s *structure-inits*))
       (if x
          (begin
             (push (cons s n) res)
             (set! n (+ n (length (cdr x))))
          )
          (error E_struct_access s)
       )
    )
   (reverse res)
))
|#

(define (make-offset-rec s n res )
  (let* ((x 0)(y 0)(off 0)(sub 0) )
     (set! x (assq s *structure-offset*))
     (when x
        (set! x (cdr x))
        (while (pair? x)
           (set! y (pop x))
           (set! sub (car y))
           (set! off (+ (cdr y) n))
           (push (cons sub off ) res)
           (set! res  (make-offset-rec sub off res))
       )
     )
    res
))

(define (make-offset inc-list n )
  (let* ((s 0)(x 0) (res ()))
    (while (pair?  inc-list)
       (set! s (pop inc-list))
       (set! x (assq s *structure-inits*))
       (if x
          (begin
             (push (cons s n) res)
             (set! res (make-offset-rec s n res))
             (set! n (+ n (length (cdr x))))
          )
          (error E_struct_access s)
       )
    )
   (reverse res)
))


(define (make-access name n) 
  (lambda(x . sh) 
          (structure-ref x name n))
)

(define (make-slots-name slots)
  (let* ((x 0)(d 0)(n 0)(res ()) (db ()))
    (while (pair? slots)
      (set! x (pop slots))
      (set! x (car x))
      (set! d (assq  x db))
      (if d
        (begin
           (set! n (cadr d))
           (set! n (+ n 1))
           (set! x (list x n))
           (push x res)
           (push x db)
        )
       (begin
           (push x res)
           (push (list x 0) db)
       )
     )
    )
   (reverse res)
))
         

#|
(define (make-copier name )
  (lambda(x) (if (eq? name (structure-name x))(copy-structure x)
                (error E_struct_access x)
              )
  )
)
|#

(define (make-copier name )
  (lambda(x . sh) (if (null? sh)
                        (copy-structure x name)
                        (copy-structure x name (car sh))
                   )
  )
)

(define (make-pred name )
  (lambda(x ) (eq? name (structure? x)))
)


(define-macro (make-structure  name   . values)
   (let* ((x 0)(v 0)(n 0)(s (assq name *structure-slots*))
                (off-set (assq name *structure-offset*))
                (inits (assq name *structure-inits*)) (res ())(para ())(sh 0) (sub 0) )
      (if (not s) (error E_struct_access name))
      (set! s (cdr s))
      (set! inits(cdr inits))
      (set! off-set  (cdr off-set))
      (while  (pair? values)
          (set! x (pop values))
          (set! v  (pop values))
          (set! n #f)
          (if (pair? x)   ;;;  index    (key shift)
              (begin
                 (set! sh (cadr x))
                 (set! x (car x))
                 (set! sub s)
                 (while (>=  sh 0)
                    (set! n (assq x sub))
                    (if (not n) (error E_struct_access n))
                    (set! sub (cdr (member n sub)))
                    (set! sh (- sh 1))
                 )
               )
               (set! n (assq x s))
          )
          (if (not n) (error E_struct_access n))
          (push (cons (cdr n) v) res)
      )
      (set! n 0)
      (while (pair?  inits)
        (set! v (cadr (pop inits)))
        (set! x (assq n res) )
        (if x  (set! v (cdr x)) )
        (push v para)
        (set! n (+ n 1))
      )
        ;;;`(struct-set ',name ,obj  ,@(reverse res))
     `(make-struct ',name  ',off-set   ,@(reverse para))
))
;;;   for read #s(   )
;;;     not needs eval parameter
(define-macro (make-s-structure  name   . values)
   (let* ((x 0)(v 0)(n 0)(s (assq name *structure-slots*))
                (off-set (assq name *structure-offset*))
                (inits (assq name *structure-inits*)) (res ())(para ())(sh 0) (sub 0) )
      (if (not s) (error E_struct_access name))
      (set! s (cdr s))
      (set! inits(cdr inits))
      (set! off-set  (cdr off-set))
      (while  (pair? values)
          (set! x (pop values))
          (set! v  (pop values))
          (set! n #f)
          (if (pair? x)   ;;;  index    (key shift)
              (begin
                 (set! sh (cadr x))
                 (set! x (car x))
                 (set! sub s)
                 (while (>=  sh 0)
                    (set! n (assq x sub))
                    (if (not n) (error E_struct_access n))
                    (set! sub (cdr (member n sub)))
                    (set! sh (- sh 1))
                 )
               )
               (set! n (assq x s))
          )
          (if (not n) (error E_struct_access n))
          (push (cons (cdr n) v) res)
      )
      (set! n 0)
      (while (pair?  inits)
        (set! v (cadr (pop inits)))
        (set! x (assq n res) )
        ;;;(if x  (set! v (cdr x)) )
        (if x  (set! v (list 'quote (cdr x)) ))
        (push v para)
        (set! n (+ n 1))
      )
        ;;;`(struct-set ',name ,obj  ,@(reverse res))
     `(make-struct ',name  ',off-set   ,@(reverse para))
))


(define-macro (set-structure  name obj . values)
   (let* ((x 0)(v 0)(n 0)(s (assq name *structure-slots*)) (res ())(sh 0) (sub 0) )
      (if (not s) (error E_struct_access name))
      (set! s (cdr s))
      (while  (pair? values)
          (set! x (pop values))
          (set! v  (pop values))
          (set! n #f)
          (if (pair? x)   ;;;  index    (key shift)
              (begin
                 (set! sh (cadr x))
                 (set! x (car x))
                 (set! sub s)
                 (while (>=  sh 0)
                    (set! n (assq x sub))
                    (if (not n) (error E_struct_access n))
                    (set! sub (cdr (member n sub)))
                    (set! sh (- sh 1))
                 )
               )
               (set! n (assq x s))
          )
          (if (not n) (error E_struct_access n))
          (push (cdr n) res)
          (push v res)
      )
     `(struct-set ',name ,obj  ,@(reverse res))
))

(define-macro (ref-structure  name obj slot)
   (let* ((x 0)(v 0)(n #f)(s (assq name *structure-slots*)) (res ())(sh 0) (sub 0) )
      (if (not s) (error E_struct_access name))
      (set! s (cdr s))
          (set! x slot)
          (if (pair? x)   ;;;  index    (key shift)
              (begin
                 (set! sh (cadr x))
                 (set! x (car x))
                 (set! sub s)
                 (while (>=  sh 0)
                    (set! n (assq x sub))
                    (if (not n) (error E_struct_access n))
                    (set! sub (cdr (member n sub)))
                    (set! sh (- sh 1))
                 )
               )
               (set! n (assq x s))
          )
          (if (not n) (error E_struct_access n))
     `(structure-ref ,obj ',name ,(cdr n))
))

(export 'defstruct )
(use-package "structure" "ss")

;;;(macro-update 'defstruct)
;;;;  test
#|
(defstruct man :name (:age 0))
(defstruct woman :name (:age 0))
(defstruct (pair :include man :include woman))
|#
