;;;;  help  for Non GUI
;;;;  04.8.31
;;;;

(in-package "sshelp")
(define DOC (string-append *SSLIBDIR* "Doc/*"))

(define *note* (glob DOC))

(define (note-list->string notes)
  (let* ((res " "))
    (while (pair? notes)
      (set! res (string-append res " "(pop notes) ))
    )
  res
))

(define bag (list  #\newline #\:))

(define (help-1 word notes)
  (let* ((res
            (exec (tk-string "grep -c " word (note-list->string notes)))
          ))
   (make-help-list  (string-split res bag))
))

(define (make-help-list lis)
 (let* ((file 0)(count 0)(res ()))
  (while (pair? lis)
    (set! file (pop lis))
    (set! count (string->number (pop lis)))
    (if (> count 0)
        (push (cons  file count) res))
  )
  res
  (sort res (lambda (x y) (> (cdr x) (cdr y))))
))

(define (help . words)
 (let* ((memo words) (sel   (map (lambda (x) (cons x 0)) *note*)))
    (while (pair? words)
        (set! sel (help-1 (pop words) (map car sel)))
    )
   (if (null? sel)
       (format #t "No match ~s !!!~%" memo)
       (select-note  sel)
  )
))

(define (select-note sel)
 (let* ((ans #t))
    (if (= (length sel) 1)
       (display-note  (caar sel))
       (while ans
          (set! ans (note-dialog sel))
          (if ans (display-note  ans))
       )
    )
))

(define (display-note note)
    (system (string-append "more " note))
)

(define (note-dialog sel)
  (let* ((note 0) (n 0)(k 1)(lis sel))
        (format #t "Select:   file   matches~%")
     (while (pair? lis)
        (set! note (pop lis))
        (format #t "~s: ~s  ~s~%" k (car note) (cdr note))
        (inc k)
     )
        (format #t "~s:  quit~%" k )
     (display "Select-number? ")
     (flush)
     (set! n (read))
     (if (and (number? n) (< 0 n k))
          (car (list-ref sel (- n 1)))
          #f
     )
))

(export 'help)
(use-package "sshelp" "ss")

