;;;  Definition or correction of function names
;;;  2010.9.18
(define hashtable? hash-table?)
(define cons* list*)
(define (memp proc lis)
  (cond ((null? lis) #f)
        ((pair? lis)
           (if (proc (car lis))
              lis
              (memp proc (cdr lis))
           ))
        (else (error E_notlist lis))
   )
)
#|
(define (remp proc lis)
  (cond ((null? lis) lis)
        ((pair? lis)
           (if (proc (car lis))
              (remp proc (cdr lis))
              (cons (car lis) (remp proc (cdr lis)))
           ))
        (else (error E_notlist lis))
   )
)
|#
(define (remp proc lis)
   (filter (lambda(x) (not (proc x))) lis)
)

(define (list-sort! pred lis)
   (sort lis pred)
)

(define (list-sort pred lis)
   (sort (list-copy lis) pred)
)

(define (vector-sort! pred lis)
   (sort lis pred)
)

(define (vector-sort pred lis)
   (sort (vector-copy lis) pred)
)
#|
(define mod modulo)
(define div quotient)
|#
(define bitwise-not lognot)
(define bitwise-and logand)
(define bitwise-ior logior)
(define bitwise-xor logxor)
(define bitwise-if 
   (lambda(ex1 ex2 ex3)
     (logior (logand ex1 ex2) (logand (lognot ex1) ex3))))

(define (bitwise-bit-count n)
   (if (positive? n) (logcount n)
      (lognot (logcount n))
   )
)

(define (bitwise-length  n)
   (if (positive? n) (integer-length n)
      (integer-length  (lognot n))
   )
)

(define bitwise-arithmetic-shift  ash)

(define bitwise-arithmetic-shift-right  
   (lambda (n sh) (ash n (- sh))))

(define bitwise-arithmetic-shift-left  
   (lambda (n sh) (ash n  sh)))

(define (fixnum-width) 30)

(define flonum? float?)

(define hashtable-set! set-hash)
(define hashtable-ref get-hash)
(define hashtable-contains?
   (let* ((no '(no))) 
    (lambda (table key)   (not (eq? (get-hash table key no) no)))
  ))

(define hashtable-delete!  rem-hash)

(define hashtable-clear!  
     (lambda(table . size) (clear-hash table)))

(define (hashtable-keys table)
  (let* ((res ()))
    (map-hash (lambda(k v) (push k res)) table)
    (list->vector res)
))

(define (hashtable-entries table)
  (let* ((res ()) (val ()))
    (map-hash (lambda(k v) (push k res)(push v val)) table)
    (values (list->vector res)(list->vector val))
))

(define (current-input-port) (car *stdin-stack*))
(define (current-output-port) (car *stdout-stack*))
(define (current-error-port) (car *stderr-stack*))

(define open-string-input-port open-input-str)

(define (open-string-output-port )
    (let* ((p (open-output-str (make-string 10))))
      (values p (lambda()(close-port p)))
))

(define (eof-object) *eof-object*)

        






