;;;;   (telnet server [service])
;;;;   ex.
;;;;     (telnet "umail" "http")
;;;;
(in-package "socket")

(define *recv* #t)

(define (telnet host . proto)
  (let* ((soc 0)(net 0)(err 0))
     (if (null? proto)
        (set! proto "telnet")
        (set! proto (car proto))
     )
     (set! net (netport proto host))
     (set! err (catch (set! soc (socket-connect net))))
      (if err
         (format #t "connection failed!~%")
         (begin
           (when-socket-ready soc (lambda()(print-get soc)))
           (clear-input)
            (set! *recv* #t)
           (telnet-session soc)
            (when-socket-ready soc #f)
         )
     )
))

(define (telnet-session soc)
  (let* ((msg 0))
     (while (not (closed-port? soc))
         (when *recv*
            (newline)
            (display "> ")
            (flush)
            (set! *recv* #f)
         )
          (update)
         (when (char-ready?)
            (set! msg (read-line))
            (when (not (closed-port? soc))
                (format soc "~a~%" msg )
                ;;;;(format #t "send: ~a~%" msg )
            )
            (if (equal? msg "quit") (close-port soc)) 
         )
        (update)
      )
    (format #t "****** telnet-session end !! ******~%")
    (flush)
))

(define (clear-input)
    (while (char-ready?)
            (read-char) )
)

(define (print-get soc)
  (let* ((ready #t)(msg ""))
              (format #t "~%>> ")
    (while (string? msg)
       (set! msg #f)
       (when  (char-ready? soc)
           (set! msg (read-line soc))
           (when (not (eof-object? msg))
              (format #t "~a~%" msg)
           )
          (set! *recv* #t)
       )
    )
   (flush)
   (if (eof-object? msg)
          (close-port soc)
   )
))

(export 'telnet)            
           
  
