;;;  zoom
;;;;  by Mouse
;;;;
(define *move-mode* 'box)
(define *move-id* 0)
(define *zx1* 0)
(define *zy1* 0)
(define *zx2* 0)
(define *zy2* 0)
(define *zbox* #f)
(define *times-move* 0)

(define (mouse-on x y)
 (let ((id 0)(tags 0)(pos 0))
   (set! *times-move* 0)
   (set!  id  (.can.c0 'find 'closest x y ) )
   (set! tags (.can.c0 'gettags  id) )
   (format #t "w-id : ~s tag ~s ~%" id tags )
    (set! *zx1* x)
   (set! *zy1* y)
   (set! *move-mode* 'box)
   (when  (member "move"  tags)
      (set! pos (.can.c0 'bbox id))  ;;;get box of ID
      (format #t "wpos: ~s x,y:~s ~s ~%" pos x y)
      (and (>=  x (car pos)) (<= x (caddr pos))
           (>= y (cadr pos)) (<= y (cadddr pos))
          (set! *move-mode* 'move)  ;;; x,y are in box
      )
   )
   (if (eq? *move-mode* 'move)
          (set! *move-id* id)
         (mouse-on-box x y)
   )
))
 
(define (mouse-on-box  x y)
 (let ((id 0))
   (if *zbox* (.can.c0 'delete *zbox*))
   (set! *zbox* #f)
   (set! *times-move* 0)
))
(define (mouse-move x y)
  (if (eq? *move-mode* 'box)
      (mouse-move-box x y)
     (begin 
       (.can.c0 'move  *move-id* (- x *zx1*)(- y *zy1*))
       (set! *zx1* x)
       (set! *zy1* y)
    ) 
  )
)

(define (mouse-move-box  x y)
  (when  *zbox*
      (.can.c0 'delete *zbox*)
  )
  (set! *zbox* (.can.c0 'create 'rect *zx1* *zy1* x y))
  (set! *zx2* x)
  (set! *zy2* y)
  (set! *times-move* (+ *times-move* 1))
)
(define (mouse-off x y)
  (if (eq? *move-mode* 'box)
      (mouse-off-box x y)
     (begin
       (.can.c0 'move  *move-id* (- x *zx1*)(- y *zy1*))
       (set! *zx1* x)
       (set! *zy1* y)
    )
  )
)


(define (mouse-off-box  x y)
  (let ((data ())(p1 0)(p2 0)(xmin 0)(xmax 0)(ymin 0)(ymax 0))
   (when *zbox*
      (set! xmin *zx1*)
     (set! xmax *zx2*)
       (set! ymin *zy1*)
       (set! ymax *zy2*)
      (when  (> xmin xmax)
        (set! x xmin)(set! xmin xmax)
        (set! xmax x)
      )
      (when  (> ymin ymax)
        (set! x ymin)(set! ymin ymax)
        (set! ymax x)
      )
     (format #t "area ~s ~s ~s ~s ~%" xmin ymin xmax  ymax)
     (set! *zx1* xmin)
     (set! *zy1* ymin)
     (set! *zx2* xmax)
     (set! *zy2* ymax)
     ;;;(set! *zbox* #f)
     (if (> *times-move* 5)
        (format #t "Ps print  ready  ~s ~%" *times-move* )
       (begin
          (.can.c0 'delete *zbox*)
          (set! *zbox* #f)
       )
     )
   )
))

