;;; init.scm
;;;

(define-macro (push x list)
  `(begin
        (set! ,list (cons ,x ,list))
        ,list
   )
)

(define-macro (pop  list)
 (let ((var (gensym)))
  `(let ((,var ()))
        (set! ,var (car ,list)) 
        (set! ,list (cdr  ,list))
        ,var
   )
))

(define (tk-name . args)
    (string->symbol (apply tk-string args)))

(define (tk-string . args)
   (do ((s "") (x ()))
        ( (null? args) s)
      (set! x (pop args))
      (cond ((string? x ))
            ((symbol? x) (set! x (symbol->string x)))
            ((number? x)(set! x (number->string x)))
            ((char? x)(set! x (string x)))
            (#t)
      )
     (set! s (string-append s x))
    )
 )


