;;;   Try Change ALL BLUE!
;;;   Lights out
(toplevel '.game)
(define N 3)       ;;; 4 is easy, 5 is difficult
(define *ban* (make-matrix N N 1))

(define (make-ban)
  (let* ((ban-frame 0) (bt 0))
    (do ((i 0(+ i 1)))
        ((= i N))
        (set! ban-frame (tk-name ".game.fr" i))
        (frame ban-frame)
       (do ((j 0(+ j 1)))
           ((= j N))
            (set! bt (tk-name ban-frame ".bt" j))
            (button bt :width 5 :height 5  :bg 'blue :relief 'solid
                           :command `(change ,i ,j))
             (pack bt  :side 'left)
       )
       (pack ban-frame)
    )
    (button '.game.restart :text "Restart" :command '(restart))
    (button '.game.exit :text "Exit" :command '(bye))
    (pack .game.restart .game.exit)
))

(define (change i j)
  (let* ((nbd (nearest i j))(p 0)(c 0))
    (while (pair? nbd)
       (set! p (pop nbd))
       (set! c (matrix-ref *ban* (car p)(cdr p)))
       (matrix-set! *ban* (car p)(cdr p) (- c))
       (change-bt (car p)(cdr p) (- c))
   )
)) 
    
(define (change-bt i j c)
   (let*  ((s 0))
     (set! s (tk-name ".game.fr" i ".bt" j))
     (if (= c 1) (set! c 'blue)(set! c 'red)) 
     (funcall s 'configure :bg c :activeBackground c) 
))    

(define (nearest i j)
   (let* ((res (list (cons i j))))
      (if (>=  (- i 1) 0)
            (push (cons (- i 1) j) res) )
      (if (<  (+ i 1) N)
            (push (cons (+ i 1) j) res) )
      (if (>=  (- j 1) 0)
            (push (cons i (- j 1) ) res) )
      (if (<  (+ j 1) N)
            (push (cons i (+ j 1) ) res) )
   res
))

(make-ban)

(define (restart) 
  (do ((i 0 (+ i 1)))
      ((= i 100))
      (change (random N) (random N))
  )
)

(restart)
